const sql = require("mssql/tedious");

// TODO: REMEMBER THIS HARD-CODED TARGET NAME CHECK IF UPDATING PCARD RECAP STAGELIST
const stagelist = ['New Txn', 'Submitted', 'Approved', 'Processed', 'Reconciled']
const purchasestatus = ['Pending', 'Received']
mode_list=["DENIED","NEW FORM","APPROVED FORM","COMPLETED"]


// Note that Images are saved to the DB as VARCHAR(MAX) (supports up to 2GB)

const config = {
    server: 'PWDSTORMNEW\\CARTEGRAPH_APPS',
    database: 'PWDPCARD',
    user: 'pwdpcard',
    password: 'pwdpcard',
    encrypt: false
};

const config2 = {
  server: 'PWDSTORMNEW\\CARTEGRAPH_APPS',
  database: 'Cartegraph_OMS',
  user: 'pwdpcard',
  password: 'pwdpcard',
  encrypt: false
};

const pool = new sql.ConnectionPool(config)
  .connect()
  .then(pool => {
    console.log('New Connection to MSSQL')
    return pool
  }).catch(err => {
    console.log('Database Connection Failed! Bad Config: ', err)
  })

 const pool2 = new sql.ConnectionPool(config2)
  .connect()
  .then(pool2 => {
    console.log('New Connection2 to MSSQL')
    return pool2
  })
  .catch(err => console.log('Database Connection2 Failed! Bad Config: ', err))

async function dbLogQuery(arg, result) {
  if (arg.log_type) {
    if (arg.log_linked_id == null && result.recordset && typeof result.recordset[0] === 'object' && result.recordset[0] !== null) {
      arg.log_linked_id = Object.values(result.recordset[0])[0]
    }
    if (!arg.log_note || arg.log_note=='') {
      arg.log_note = null
    }

    input = [
      {name:'log_linked_table', value:arg.log_linked_table},
      {name:'log_linked_id', value:arg.log_linked_id},
      {name:'log_type', value:arg.log_type},
      {name:'log_desc', value:arg.log_desc},
      {name:'log_uname', value:arg.log_uname},
      {name:'log_note', value:arg.log_note}
    ]
    query = 'INSERT INTO log ( '+
      'log_linked_table, '+
      'log_linked_id, '+
      'log_type, '+
      'log_desc, '+
      'log_uname, '+
      'log_note '+
    ') '+
    'VALUES ( '+
      '@log_linked_table, '+
      '@log_linked_id, '+
      '@log_type, '+
      '@log_desc, '+
      '@log_uname, '+
      '@log_note '+
    ') '

    arg.input = input
    arg.query = query

    const conn = await pool
    const request = new sql.Request(conn)
    arg.input.forEach(element => {
      request.input(element.name, element.value)
    });
    return await request.query(arg.query)
  } else {
    return result
  }
}

async function dbExecuteQuery(arg){
  const conn = await pool
  const request = new sql.Request(conn)

  if (arg.input) {
    arg.input.forEach(element => {
      request.input(element.name, element.value)
    });
  }

  return request.query(arg.query, arg.input)
  .then(pass=>{
    dbLogQuery(arg, pass)
    return pass
  }).catch(error=>{
    throw error
  })
}

async function dbExecuteQuery2(arg){
  let conn2 = await pool2
  let request = new sql.Request(conn2)

  if (arg.input) {
    arg.input.forEach(element => {
      request.input(element.name, element.value)
    });
  }
  return await request.query(arg.query)
}

async function loadAllCartegraphUsers() {
  query = 'SELECT * FROM wdLaborMainGeneral'

  arg = {}

  arg.query = query
  return await dbExecuteQuery2(arg)
}

async function org_load(arg){
  input = [
    {name:'org_key', value:arg.org_key}
  ]
  query = 'SELECT * FROM orgkey '+
  'WHERE org_key = @org_key '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function obj_load(arg){
  input = [
    {name:'obj_code', value:arg.obj_code}
  ]
  query = 'SELECT * FROM objcode '+
  'WHERE obj_code = @obj_code '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function org_add(arg, uname){
  input = [
    {name:'org_key', value:arg.org_key},
    {name:'org_desc', value:arg.org_desc},
    {name:'org_enabled', value:arg.org_enabled}
  ]

  query = 'INSERT INTO orgkey ( '+
    'org_key, '+
    'org_desc, '+
    'org_enabled '+
  ') '+
  'OUTPUT Inserted.org_key '+
  'VALUES ( '+
    '@org_key, '+
    '@org_desc, '+
    '@org_enabled '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'orgkey'
  arg.log_type = 'INSERT'
  arg.log_desc = 'Create New orgkey ' +arg.org_key +' for ' +arg.org_desc
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function obj_add(arg, uname){
  input = [
    {name:'obj_code', value:arg.obj_code},
    {name:'obj_desc', value:arg.obj_desc},
    {name:'obj_enabled', value:arg.obj_enabled}
  ]

  query = 'INSERT INTO objcode ( '+
    'obj_code, '+
    'obj_desc, '+
    'obj_enabled '+
  ') '+
  'OUTPUT Inserted.obj_code '+
  'VALUES ( '+
    '@obj_code, '+
    '@obj_desc, '+
    '@obj_enabled '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'objcode'
  arg.log_type = 'INSERT'
  arg.log_desc = 'Create New objcode ' +arg.obj_code +' for ' +arg.obj_desc
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function org_edit(arg, uname){
  input = [
    {name:'org_key', value:arg.org_key},
    {name:'org_desc', value:arg.org_desc},
    {name:'org_enabled', value:arg.org_enabled}
  ]

  query = 'UPDATE orgkey SET '+
  'org_desc = @org_desc, '+
  'org_enabled = @org_enabled '+
  'WHERE org_key = @org_key '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'orgkey'
  arg.log_type = 'UPDATE'
  arg.log_desc = 'Update orgkey ' +arg.org_key
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function obj_edit(arg, uname){
  input = [
    {name:'obj_code', value:arg.obj_code},
    {name:'obj_desc', value:arg.obj_desc},
    {name:'obj_enabled', value:arg.obj_enabled}
  ]

  query = 'UPDATE objcode SET '+
  'obj_desc = @obj_desc, '+
  'obj_enabled = @obj_enabled '+
  'WHERE obj_code = @obj_code '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'objcode'
  arg.log_type = 'UPDATE'
  arg.log_desc = 'Update objcode ' +arg.obj_code
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function createTravel(arg, uname) {
  input = [
    {name:'travel_event_id', value:arg.travel_event_id},
    {name:'travel_emp_id', value:arg.travel_emp_id},
    {name:'travel_org_key', value:arg.travel_org_key},
    {name:'travel_depart_datetime', value:arg.travel_depart_datetime},
    {name:'travel_return_datetime', value:arg.travel_return_datetime},
    {name:'travel_method', value:arg.travel_method},
    {name:'travel_has_rental_car', value:arg.travel_has_rental_car},
    {name:'travel_desc', value:arg.travel_desc},
    {name:'travel_personal_days', value:arg.travel_personal_days},
    {name:'travel_eligible_lodging_nights', value:arg.travel_eligible_lodging_nights},
    {name:'travel_eligible_rental_car_days', value:arg.travel_eligible_rental_car_days},
    {name:'travel_dist_miles', value:arg.travel_dist_miles},
    {name:'travel_airfare_estimate', value:arg.travel_airfare_estimate},
    {name:'travel_max_reinbursible', value:arg.travel_max_reinbursible},
    {name:'travel_bfst_allowed', value:arg.travel_bfst_allowed},
    {name:'travel_lnch_allowed', value:arg.travel_lnch_allowed},
    {name:'travel_dinn_allowed', value:arg.travel_dinn_allowed},
    {name:'travel_bfst_not_cvrd', value:arg.travel_bfst_not_cvrd},
    {name:'travel_lnch_not_cvrd', value:arg.travel_lnch_not_cvrd},
    {name:'travel_dinn_not_cvrd', value:arg.travel_dinn_not_cvrd},
    {name:'travel_form_status', value:arg.travel_form_status},
    {name:'travel_linked_filesys_ids', value:arg.travel_linked_filesys_ids}
  ]
  query = 'INSERT INTO travel_recap ( '+
    'travel_event_id, '+
    'travel_emp_id, '+
    'travel_org_key, '+
    'travel_depart_datetime, '+
    'travel_return_datetime, '+
    'travel_method, '+
    'travel_has_rental_car, '+
    'travel_desc, '+
    'travel_personal_days, '+
    'travel_eligible_lodging_nights, '+
    'travel_eligible_rental_car_days, '+
    'travel_dist_miles, '+
    'travel_airfare_estimate, '+
    'travel_max_reinbursible, '+
    'travel_bfst_allowed, '+
    'travel_lnch_allowed, '+
    'travel_dinn_allowed, '+
    'travel_bfst_not_cvrd, '+
    'travel_lnch_not_cvrd, '+
    'travel_dinn_not_cvrd, '+
    'travel_form_status, '+
    'travel_linked_filesys_ids, '+
    'travel_event_count '+
  ') '+
  'OUTPUT Inserted.travel_id '+
  'VALUES ( '+
    '@travel_event_id, '+
    '@travel_emp_id, '+
    '@travel_org_key, '+
    '@travel_depart_datetime, '+
    '@travel_return_datetime, '+
    '@travel_method, '+
    '@travel_has_rental_car, '+
    '@travel_desc, '+
    '@travel_personal_days, '+
    '@travel_eligible_lodging_nights, '+
    '@travel_eligible_rental_car_days, '+
    '@travel_dist_miles, '+
    '@travel_airfare_estimate, '+
    '@travel_max_reinbursible, '+
    '@travel_bfst_allowed, '+
    '@travel_lnch_allowed, '+
    '@travel_dinn_allowed, '+
    '@travel_bfst_not_cvrd, '+
    '@travel_lnch_not_cvrd, '+
    '@travel_dinn_not_cvrd, '+
    '@travel_form_status, '+
    '@travel_linked_filesys_ids, '+
    'COALESCE( '+
      '(SELECT MAX(travel_event_count) '+
      'FROM travel_recap '+
      'WHERE travel_event_id= @travel_event_id) '+
      ', 0 '+
    ')+1 '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'travel_recap'
  arg.log_type = 'INSERT'
  arg.log_desc = 'Create New Travel for Event '  +arg.travel_event_id +', Employee ' +arg.travel_emp_id
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function loadHistory(arg){
  input = [
    {name:'log_linked_table', value:arg.log_linked_table},
    {name:'log_linked_id', value:arg.log_linked_id}
  ]
  query = 'SELECT * FROM log '+
  'WHERE log_linked_table = @log_linked_table '+
  'AND log_linked_id = @log_linked_id '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function travelModify(arg, uname){
  input = [
    {name:'travel_form_status',  value:arg.travel_form_status},
    {name:'travel_id',  value:arg.travel_id}
  ]

  query = 'UPDATE travel_recap SET '+
  'travel_form_status = @travel_form_status '

  if(arg.travel_max_stage != null){
    input.push(
      {name:'travel_max_stage',  value:arg.travel_max_stage}
    )
    query += ', travel_max_stage = @travel_max_stage '
  }

  query += 'WHERE travel_id = @travel_id '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'travel_recap'
  arg.log_linked_id = arg.travel_id
  arg.log_type = 'UPDATE'
  arg.log_desc += ' to '+arg.travel_form_status
  arg.log_uname = uname

  // console.log('arg', arg)

  return await dbExecuteQuery(arg)
}

async function createEvent(arg, uname) {
  arg.log_linked_table = 'event'
  arg.log_type = 'INSERT'
  arg.log_desc = 'New Event, Name' +arg.event_name
  arg.log_uname = uname

  arg.event_fiscal_year = calculatefiscalyear(new Date(arg.event_start_date))

  input = [
    {name:'event_name', value:arg.event_name},
    {name:'event_type', value:arg.event_type},
    {name:'event_desc', value:arg.event_desc},
    {name:'event_provider', value:arg.event_provider},
    {name:'event_start_date', value:arg.event_start_date},
    {name:'event_end_date', value:arg.event_end_date},
    {name:'event_street', value:arg.event_street},
    {name:'event_city', value:arg.event_city},
    {name:'event_state', value:arg.event_state},
    {name:'event_zip_code', value:arg.event_zip_code},
    {name:'event_bfst_prov', value:arg.event_bfst_prov},
    {name:'event_lnch_prov', value:arg.event_lnch_prov},
    {name:'event_dinn_prov', value:arg.event_dinn_prov},
    {name:'event_regis_date', value:arg.event_regis_date},
    {name:'event_regis_fee', value:arg.event_regis_fee},
    {name:'event_fiscal_year', value:arg.event_fiscal_year}
  ]
  query = 'INSERT INTO travel_event ( '+
    'event_name, '+
    'event_type, '+
    'event_desc, '+
    'event_provider, '+
    'event_start_date, '+
    'event_end_date, '+
    'event_street, '+
    'event_city, '+
    'event_state, '+
    'event_zip_code, '+
    'event_bfst_prov, '+
    'event_lnch_prov, '+
    'event_dinn_prov, '+
    'event_regis_date, '+
    'event_regis_fee, '+
    'event_fiscal_year, '+
    'event_fy_count '+
  ') '+
  'OUTPUT Inserted.event_id '+
  'VALUES ( '+
    '@event_name, '+
    '@event_type, '+
    '@event_desc, '+
    '@event_provider, '+
    '@event_start_date, '+
    '@event_end_date, '+
    '@event_street, '+
    '@event_city, '+
    '@event_state, '+
    '@event_zip_code, '+
    '@event_bfst_prov, '+
    '@event_lnch_prov, '+
    '@event_dinn_prov, '+
    '@event_regis_date, '+
    '@event_regis_fee, '+
    '@event_fiscal_year, '+
    'COALESCE( '+
      '(SELECT MAX(event_fy_count) '+
      'FROM travel_event '+
      'WHERE event_fiscal_year= @event_fiscal_year) '+
      ', 0 '+
    ')+1 '+
  ') '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}


// GLOBAL OBJECT UPDATE FUNCTIONS
async function loadPermissions(uname) {
  input = [{name:'uname', value:uname}]
  query = 'SELECT * '+
    'FROM employee '+
    'WHERE emp_uname = @uname'

  arg = {}
  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}
// GLOBAL OBJECT UPDATE FUNCTIONS
async function loadequipmenttypes(uname) {
  query = 'SELECT distinct(EquipmentClass) '+
    'FROM wdEquipmentMainGeneral ' +
    'order by EquipmentClass'

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}



async function loadequipmentlocations(uname) {
  query = "SELECT LocationID "+
    "FROM EquipmentLocations " +
    "WHERE Inactive ='0' " +
    "order by LocationID"

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}

async function loaddepartments(uname) {
  query = 'SELECT Department '+
    "FROM Departments " +
    "WHERE Inactive ='0'" +
    "ORDER BY Department"

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}

async function loadequipmentclassifications(uname) {
  query = 'SELECT distinct(Classification) '+
    'FROM wdEquipmentMainGeneral ' +
    'WHERE Classification IS NOT NULL ' +
    'ORDER BY Classification'

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}


async function loadequipmentmanufacturers(uname) {
  query = 'SELECT Manufacturer '+
    'FROM wdManufacturers ' +
    "WHERE Inactive ='0'" +
    'ORDER BY Manufacturer'

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}

async function loadequipmentvendors(uname) {
  query = "SELECT ID "+
    "FROM Vendors " +
    "WHERE Inactive ='0'" +
    "ORDER BY ID"

  arg = {}

  arg.query = query
  let result = await dbExecuteQuery2(arg)
  return result
}

async function loadequipmentlist(arg) {
  const os = require ('os');
  const submitname = os.userInfo ().username;


  input = [
    
    {name:'target_val', value:arg.target_val}
   
    
  ]
  

  query = 'SELECT * '+
    'FROM modifyequipment a INNER JOIN employee b' +
    'ON a.submitted_by = b.emp_uname '+
    
    'WHERE  a.' +arg.target_name+' = @target_val '

  if (arg.target_val == "DENIED" ){
    input.push({name:'submitname', value:submitname})
    query += 'AND a.submitted_by = @submitname'

  }

  /*if (arg.target_val == "NEW FORM" ){
    input.push({name:'submitname', value:submitname})
    query += 'AND modifyequipment.submitted_by = @submitname '

  }*/
    




  arg.input = input
  arg.query = query
  argout = await dbExecuteQuery(arg)

  arg.log_linked_table = 'modifyequipment'
  arg.log_linked_id = arg.target_val

  argout2 = await loadComments(arg)

  let comments = []
  argout2.recordset.forEach(log => {
    if (log.log_note) {
      comments.push(log)
    }
  });
  if (argout.recordset && argout.recordset[0]){
    argout.recordset[0].log_notes = comments
  }
  argout3 = await loadConstants()
  let constants = []
  argout3.recordset.forEach(constant => {
    constants.push(constant)
  })

  argoug4 = await loadHistory(arg)
  let history = []
  argoug4.recordset.forEach(entry =>{
    history.push(entry)
  })

  if (argout.recordset && argout.recordset[0]){
    argout.recordset[0].log_notes = comments
    argout.recordset[0].constants = constants
    argout.recordset[0].history = history
  }
  return argout
}


async function selectedequipmentmodify(arg, uname){// check

  if (arg.FemaRate, arg.FemaCode){

    input = [
      {'name':'FemaRate',  'value':arg.FemaRate},
      {'name':'FemaCode',  'value':arg.FemaCode},
      {'name':'Equipmentformid', 'value':arg.Equipmentformid},
      {'name':'Status', 'value':arg.Status}
    ]
    query = 'UPDATE modifyequipment SET '+
      'FemaRate = @FemaRate, '+
      'FemaCode = @FemaCode, '+
      'Status = @Status '+
      'WHERE Equipmentformid= @Equipmentformid '

  }else{
    input = [
      
      {'name':'Equipmentformid', 'value':arg.Equipmentformid},
      {'name':'Status', 'value':arg.Status}
    ]
    query = 'UPDATE modifyequipment SET '+
      
      'Status = @Status '+
      'WHERE Equipmentformid= @Equipmentformid '

  }
  

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'modifyequipment'
  arg.log_linked_id = arg.Equipmentformid
  arg.log_type = 'UPDATE'
  arg.log_desc = 'Update Equipment fema notes to ' +arg.Status
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function modifyaddequipmentform(arg,uname) {
  input = [
    
    {'name':'datanumber', 'value':arg.datanumber},
    {'name':'equipmentclassifications', 'value':arg.equipmentclassifications},
    {'name':'purchasedate', 'value':arg.purchasedate},
    {'name':'equipmentmanufacturers', 'value':arg.equipmentmanufacturers},
    {'name':'model',  'value':arg.model},
    {'name':'year',  'value':arg.year},
    {'name':'inservicedate',  'value':arg.inservicedate},
    {'name':'serialnumber', 'value':arg.serialnumber},
    {'name':'attachedequipid', 'value':arg.attachedequipid},
    {'name':'equipmentvendors',  'value':arg.equipmentvendors},
    {'name':'equipmentlocations',  'value':arg.equipmentlocations},
    {'name':'avlserialnumber',  'value':arg.avlserialnumber},
    
    {'name':'departments', 'value':arg.departments},
    {'name':'newlocation',  'value':arg.newlocation},
    {'name':'newdepartment', 'value':arg.newdepartment},
    
    
    {'name':'Linked_File', 'value':arg.Linked_File},
    {'name':'Equipmentformid', 'value':arg.Equipmentformid}
  ]


  query = 'UPDATE modifyequipment SET '+
  'Data_No = @datanumber, '+
  'Description = @equipmentclassifications, '+
  'Purchase_Date = @purchasedate, '+
  'Manufacturer = @equipmentmanufacturers, '+
  'Model = @model, '+
  'Year = @year, '+
  'Inservice_Date = @inservicedate, '+
  'Vendor = @equipmentvendors, '+
  'Location = @equipmentlocations, '+
  'AVLSerial = @avlserialnumber, '+
  
  'Department = @departments, '+
  'Location_New = @newlocation, '+
  'Department_New = @newdepartment, '+
  'Linked_File = @Linked_File '+
  'WHERE Equipmentformid= @Equipmentformid '
  // 'IF @@ROWCOUNT=0 '+
  // 'INSERT INTO  modifyequipment ( '+

  //   'Data_NO, '+
  //   'Description, '+
  //   'purchase_Date, '+
  //   'Manufacturer, '+
  //   'Model, '+
  //   'Year, '+
  //   'Inservice_Date, '+
  //   'serial_number, '+
  //   'Vendor, '+
  //   'Location, '+
  //   'AVLSerial, '+
    
  //   'Department, '+
  //   'Location_New, '+
  //   'Department_New, '+
    
  //   'Linked_File '+
    
  // ') '+

  // 'VALUES ( '+
  //   '@datanumber, '+
  //   '@equipmentclassifications, '+
  //   '@purchasedate, '+
  //   '@equipmentmanufacturers, '+
  //   '@model, '+
  //   '@year, '+
  //   '@inservicedate, '+
  //   '@serialnumber, '+
  //   '@equipmentvendors, '+
  //   '@equipmentlocations, '+
  //   '@avlserialnumber, '+
  //   '@notes, '+
  //   '@department, '+
  //   '@newlocation, '+
  //   '@newdepartment, '+
    
  //   '@Linked_File '+
  // ') '
    

    

      


  arg.input = input
  arg.query = query

  arg.log_linked_table='modifyequipment'
  arg.log_linked_id=arg.Equipmentformid
  arg.log_type='UPDATE'
  arg.FemaCodelog_desc='User Modified Denied Equipment Request'
  arg.log_uname=uname
  arg.notes=arg.notes
  


  

  return await dbExecuteQuery(arg)
}






async function submitaddequipmentform(arg, uname) {
  // if (arg.datanumber,arg.equipmentclassifications,arg.purchasedate,arg.equipmentmanufacturers,arg.model,arg.year,arg.inservicedate,arg.serialnumber,arg.equipmentvendors,arg.equipmentlocations,arg.avlserialnumber,arg.departments,arg.newlocation,arg.newdepartment,arg.Modify_Type,arg.submitted_by,arg.Linked_File){}
  status2 = 'APPROVED FORM'

  input = [
    {'name':'datanumber', 'type':sql.VarChar, 'value':arg.datanumber},
    {'name':'equipmentclassifications', 'type':sql.VarChar, 'value':arg.equipmentclassifications},
    {'name':'purchasedate', 'type':sql.Date, 'value':arg.purchasedate},
    {'name':'equipmentmanufacturers', 'type':sql.VarChar, 'value':arg.equipmentmanufacturers},
    {'name':'model', 'type':sql.VarChar, 'value':arg.model},
    {'name':'year', 'type':sql.VarChar, 'value':arg.year},
    {'name':'inservicedate', 'type':sql.Date, 'value':arg.inservicedate},
    {'name':'serialnumber', 'type':sql.VarChar, 'value':arg.serialnumber},
    {'name':'attachedequipid', 'type':sql.VarChar, 'value':arg.attachedequipid},
    {'name':'equipmentvendors', 'type':sql.VarChar, 'value':arg.equipmentvendors},
    {'name':'equipmentlocations', 'type':sql.VarChar, 'value':arg.equipmentlocations},
    {'name':'avlserialnumber', 'type':sql.VarChar, 'value':arg.avlserialnumber},
    {'name':'notes', 'type':sql.VarChar, 'value':arg.notes},
    {'name':'departments', 'type':sql.VarChar, 'value':arg.departments},
    {'name':'newlocation', 'type':sql.VarChar, 'value':arg.newlocation},
    {'name':'newdepartment', 'type':sql.VarChar, 'value':arg.newdepartment},
    {'name':'Modify_Type', 'type':sql.VarChar, 'value':arg.Modify_Type},
    {'name':'submitted_by', 'type':sql.VarChar, 'value':arg.submitted_by},
    {'name':'Linked_File', 'value':arg.Linked_File}
  ]

  query = 'INSERT INTO modifyequipment ( '+
    'Data_NO, '+
    'Description, '+
    'purchase_Date, '+
    'Manufacturer, '+
    'Model, '+
    'Year, '+
    'Inservice_Date, '+
    'serial_number, '+
    'Attached_equipID, '+
    'Vendor, '+
    'Location, '+
    'AVLSerial, '+
    'Notes, '+
    'Department, '+
    'Location_New, '+
    'Department_New, '+
    'Modify_Type, '+
    'submitted_by, '+
    'Linked_File, '+
    'Formid '+
  ') '+
  'OUTPUT Inserted.Equipmentformid '+
  'VALUES ( '+
    '@datanumber, '+
    '@equipmentclassifications, '+
    '@purchasedate, '+
    '@equipmentmanufacturers, '+
    '@model, '+
    '@year, '+
    '@inservicedate, '+
    '@serialnumber, '+
    '@attachedequipid, '+
    '@equipmentvendors, '+
    '@equipmentlocations, '+
    '@avlserialnumber, '+
    '@notes, '+
    '@departments, '+
    '@newlocation, '+
    '@newdepartment, '+
    '@Modify_Type, '+
    '@submitted_by, '+
    '@Linked_File, '+
    '( COALESCE '+
      '( '+
        '( SELECT MAX(Formid) FROM modifyequipment WHERE Modify_Type = @Modify_Type ) '+
        ', 0 '+
      ') '+
    ')+1'+
  ') '

  
  

  arg.input = input
  arg.query = query
  // console.log(arg)

  let result = await dbExecuteQuery(arg)
  return result
}

async function selectionlookup(arg) {
  console.log('arg', arg)
  input = [{'name':'equip_id', 'value':arg.datanumber}]
  query = 'SELECT * '+
    'FROM modifyequipment '+
    'WHERE Equipmentformid = @equip_id'

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function loadConstants() {
  query = 'SELECT * '+
    'FROM constants '

  arg = {}
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function searchlookup(arg) {
  console.log('arg', arg)
  input = [{'name':'fromdate', 'value':arg.fromdate},
  {'name':'todate', 'value':arg.todate}

]
  query = 'SELECT * '+
    'FROM modifyequipment INNER JOIN employee ' +
    'ON modifyequipment.submitted_by = employee.emp_uname '+
    'WHERE CONVERT(DATE,modifyequipment.Submit_Date) >= @fromdate and CONVERT(DATE,modifyequipment.Submit_Date) <= @todate'

    

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}


async function deletelookup(arg) {
  console.log('arg', arg)
  input = [{'name':'equip_id', 'value':arg.datanumber2}]
  query = 'SELECT * '+
    'FROM wdEquipmentMainGeneral '+
    'WHERE ID = @equip_id'

  arg.input = input
  arg.query = query

  return await dbExecuteQuery2(arg)
}

async function loadConstants() {
  query = 'SELECT * '+
    'FROM constants '

  arg = {}
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function loadOrgKeys() {
  query = 'SELECT * '+
    'FROM orgkey '

  arg = {}
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function loadObjCodes() {
  query = 'SELECT * '+
    'FROM objcode '

  arg = {}
  arg.query = query

  return await dbExecuteQuery(arg)
}

// async function loadSupervisors() {
//   query = 'SELECT * '+
//     'FROM employee WHERE '+
//     'emp_id IN ( '+
//       'SELECT emp_supervisor_id FROM employee '+
//     ')'

//   arg = {}
//   arg.query = query

//   return await dbExecuteQuery(arg)
// }

async function loadSupervisors() {
  // input = [{name:'emp_position', value:manager}]
  query = "SELECT * "+
    "FROM employee WHERE "+
    "emp_position <> 'employee' order by emp_lname"
      
  arg = {}
  arg.query = query

  return await dbExecuteQuery(arg)
}




async function userLookup(arg) {
  input = [{name:'emp_id', value:arg.emp_id}]
  query = 'SELECT * '+
    'FROM employee '+
    'WHERE emp_id = @emp_id'

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function pcardLookup(arg) {
  input = [
    {name:'pcard_last_4', value:arg.pcard_last_4}
  ]
  query = 'SELECT * '+
    'FROM pcard LEFT OUTER JOIN employee '+
    'ON employee.emp_id = pcard.pcard_emp_id '+
    'WHERE pcard.pcard_last_4 = @pcard_last_4 '

  if (arg.pcard_first_12){
    input.push({name:'pcard_first_12', value:arg.pcard_first_12})
    query += 'AND pcard.pcard_first_12 = @pcard_first_12 '
  }

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function pcardLookupEmpid(arg) {
  input = [
    {name:'pcard_emp_id', value:arg.emp_id}
  ]
  query = 'SELECT * '+
    'FROM pcard LEFT OUTER JOIN employee '+
    'ON employee.emp_id = pcard.pcard_emp_id '+
    'WHERE pcard.pcard_emp_id = @pcard_emp_id '+
    'ORDER BY pcard.pcard_enabled, pcard.pcard_last_4 DESC '

  arg.input = input
  arg.query = query

  // console.log('DB LOOKUP EMPID ARG:', arg)

  return await dbExecuteQuery(arg)
}

async function userModify(arg, uname){
  input = [
    {name:'emp_id', value:arg.emp_id},
    {name:'emp_uname', value:arg.emp_uname},
    {name:'emp_fname', value:arg.emp_fname},
    {name:'emp_lname', value:arg.emp_lname},
    {name:'emp_email', value:arg.emp_email},
    {name:'emp_org_key', value:arg.emp_org_key},
    {name:'emp_supervisor_id', value:arg.emp_supervisor_id},
    {name:'emp_active', value:arg.emp_active},
    {name:'emp_pcard_permission', value:arg.emp_pcard_permission},
    {name:'emp_pcard_admin', value:arg.emp_pcard_admin},
    {name:'emp_travel_permission', value:arg.emp_travel_permission},
    {name:'emp_travel_admin', value:arg.emp_travel_admin},
    {name:'emp_equipment_permission', value:arg.emp_equipment_permission},
    {name:'emp_equipment_admin', value:arg.emp_equipment_admin},
    {name:'emp_budget_permission', value:arg.emp_budget_permission},
    {name:'emp_budget_admin', value:arg.emp_budget_admin},
    {name:'emp_position', value:arg.emp_position},
    {name:'emp_finance_permission', value:arg.emp_finance_permission},
    {name:'emp_cartegraph_permission', value:arg.emp_cartegraph_permission},
    
    {name:'emp_hr_permission', value:arg.emp_hr_permission},
    {name:'emp_admin_permission', value:arg.emp_admin_permission},
    {name:'emp_Equip_submitmode_permission', value:arg.emp_Equip_submitmode_permission},
    {name:'emp_Equip_approvermode_permission', value:arg.emp_Equip_approvermode_permission}
  ]
  query = 'UPDATE employee SET '+
  'emp_uname = @emp_uname, '+
  'emp_fname = @emp_fname, '+
  'emp_lname = @emp_lname, '+
  'emp_email = @emp_email, '+
  'emp_org_key = @emp_org_key, '+
  'emp_supervisor_id = @emp_supervisor_id, '+
  'emp_active = @emp_active, '+
  'emp_pcard_permission = @emp_pcard_permission, '+
  'emp_pcard_admin = @emp_pcard_admin, '+
  'emp_travel_permission = @emp_travel_permission, '+
  'emp_travel_admin = @emp_travel_admin, '+
  'emp_equipment_permission = @emp_equipment_permission, '+
  'emp_equipment_admin = @emp_equipment_admin, '+
  'emp_budget_permission = @emp_budget_permission, '+
  'emp_budget_admin = @emp_budget_admin, '+
  'emp_position = @emp_position, '+
  'emp_finance_permission = @emp_finance_permission, '+
  'emp_cartegraph_permission = @emp_cartegraph_permission, '+
  'emp_hr_permission = @emp_hr_permission, '+
  'emp_admin_permission = @emp_admin_permission, '+
  'emp_Equip_submitmode_permission = @emp_Equip_submitmode_permission, '+
  'emp_Equip_approvermode_permission = @emp_Equip_approvermode_permission '+
  'WHERE emp_id = (@emp_id) '+
  'IF @@ROWCOUNT=0 '+
  'INSERT INTO employee ( '+
    'emp_id, '+
    'emp_uname, '+
    'emp_fname, '+
    'emp_lname, '+
    'emp_email, '+
    'emp_org_key, '+
    'emp_supervisor_id, '+
    'emp_active, '+
    'emp_pcard_permission, '+
    'emp_pcard_admin, '+
    'emp_travel_permission, '+
    'emp_travel_admin, '+
    'emp_equipment_permission, '+
    'emp_equipment_admin, '+
    'emp_budget_permission, '+
    'emp_budget_admin, '+
    'emp_position, '+
    'emp_finance_permission, '+
    'emp_cartegraph_permission, '+
    'emp_hr_permission, '+
    'emp_admin_permission, '+
    'emp_Equip_submitmode_permission, '+
    'emp_Equip_approvermode_permission '+
  ') '+
  'VALUES ( '+
    '@emp_id, '+
    '@emp_uname, '+
    '@emp_fname, '+
    '@emp_lname, '+
    '@emp_email, '+
    '@emp_org_key, '+
    '@emp_supervisor_id, '+
    '@emp_active, '+
    '@emp_pcard_permission, '+
    '@emp_pcard_admin, '+
    '@emp_travel_permission, '+
    '@emp_travel_admin, '+
    '@emp_equipment_permission, '+
    '@emp_equipment_admin, '+
    '@emp_budget_permission, '+
    '@emp_budget_admin, '+
    '@emp_position, '+
    '@emp_finance_permission, '+
    '@emp_cartegraph_permission, '+
    '@emp_hr_permission, '+
    '@emp_admin_permission, '+
    '@emp_Equip_submitmode_permission, '+
    '@emp_Equip_approvermode_permission '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'employee'
  arg.log_linked_id = arg.emp_id
  arg.log_type = 'INSERT/UPDATE'
  arg.log_desc = 'Update Employee Data'
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function pcardModify(arg, uname){
  input = [
    {name:'pcard_first_12', value:arg.pcard_first_12},
    {name:'pcard_last_4', value:arg.pcard_last_4},
    {name:'pcard_emp_id', value:arg.pcard_emp_id},
    {name:'pcard_cvv', value:arg.pcard_cvv},
    {name:'pcard_pin', value:arg.pcard_pin},
    {name:'pcard_limit', value:arg.pcard_limit},
    {name:'pcard_default_org_key', value:arg.pcard_default_org_key},
    {name:'pcard_default_obj_code', value:arg.pcard_default_obj_code},
    {name:'pcard_notes', value:arg.pcard_notes},
    {name:'pcard_issue_date', value:arg.pcard_issue_date},
    {name:'pcard_expire_date', value:arg.pcard_expire_date},
    {name:'pcard_enabled', value:arg.pcard_enabled},
    {name:'pcard_name_on_card', value:arg.pcard_name_on_card}
  ]
  query = 'UPDATE pcard SET '+
  'pcard_emp_id = @pcard_emp_id, '+
  'pcard_cvv = @pcard_cvv, '+
  'pcard_pin = @pcard_pin, '+
  'pcard_limit = @pcard_limit, '+
  'pcard_default_org_key = @pcard_default_org_key, '+
  'pcard_default_obj_code = @pcard_default_obj_code, '+
  'pcard_notes = @pcard_notes, '+
  'pcard_issue_date = @pcard_issue_date, '+
  'pcard_expire_date = @pcard_expire_date, '+
  'pcard_enabled = @pcard_enabled, '+
  'pcard_name_on_card = @pcard_name_on_card '+
  'WHERE pcard_first_12 = @pcard_first_12 '+
  'AND pcard_last_4 = @pcard_last_4 '+
  'IF @@ROWCOUNT=0 '+
  'INSERT INTO pcard ( '+
    'pcard_emp_id, '+
    'pcard_cvv, '+
    'pcard_pin, '+
    'pcard_limit, '+
    'pcard_default_org_key, '+
    'pcard_default_obj_code, '+
    'pcard_notes, '+
    'pcard_issue_date, '+
    'pcard_expire_date, '+
    'pcard_enabled, '+
    'pcard_name_on_card, '+
    'pcard_first_12, '+
    'pcard_last_4 '+
  ') '+
  'VALUES ( '+
    '@pcard_emp_id, '+
    '@pcard_cvv, '+
    '@pcard_pin, '+
    '@pcard_limit, '+
    '@pcard_default_org_key, '+
    '@pcard_default_obj_code, '+
    '@pcard_notes, '+
    '@pcard_issue_date, '+
    '@pcard_expire_date, '+
    '@pcard_enabled, '+
    '@pcard_name_on_card, '+
    '@pcard_first_12, '+
    '@pcard_last_4 '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'pcard'
  arg.log_linked_id = String(arg.pcard_first_12)+String(arg.pcard_last_4)
  arg.log_type = 'INSERT/UPDATE'
  arg.log_desc = 'Update Pcard Data'
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function loadTravelRecap(arg) {
  input = [{name:'travel_key', value:arg.target_val}]
  query = 'SELECT * '+
    'FROM travel_recap LEFT OUTER JOIN employee '+
    'ON travel_recap.travel_emp_id = employee.emp_id '+
    'LEFT OUTER JOIN travel_event '+
    'ON travel_recap.travel_event_id = travel_event.event_id '+
    'WHERE travel_recap.' +arg.target_name +' = @travel_key '

  arg.input = input
  arg.query = query

  argout = await dbExecuteQuery(arg)

  // console.log('query', arg, 'results', argout)

  arg.log_linked_table = 'travel_recap'
  arg.log_linked_id = arg.target_val

  argout2 = await loadComments(arg)

  let comments = []
  argout2.recordset.forEach(log => {
    if (log.log_note) {
      comments.push(log)
    }
  });

  argout3 = await loadConstants()
  let constants = []
  argout3.recordset.forEach(constant => {
    constants.push(constant)
  })

  argoug4 = await loadHistory(arg)
  let history = []
  argoug4.recordset.forEach(entry =>{
    history.push(entry)
  })

  if (argout.recordset && argout.recordset[0]){
    argout.recordset[0].log_notes = comments
    argout.recordset[0].constants = constants
    argout.recordset[0].history = history
  }
  return argout
}

// load comments
async function loadComments(arg) {
  input = [
    {name:'log_linked_table', value:arg.log_linked_table},
    {name:'log_linked_id', value:arg.log_linked_id}
  ]
  query = 'SELECT * '+
  'FROM log '+
  'WHERE log_linked_table = @log_linked_table '+
  'AND log_linked_id = @log_linked_id '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function uploadFile(arg) {
  input = [
    {name:'filesys_linked_table', value:arg.filesys_linked_table},
    {name:'filesys_linked_id', value:arg.filesys_linked_id},
    {name:'filesys_name', value:arg.filesys_name},
    {name:'filesys_content', value:arg.filesys_content}
  ]

  // console.log('content len', arg.filesys_content.length, 'out of', 2^31-1, 'remaining', 2^31-1 - arg.filesys_content.length)

  query = 'INSERT INTO filesys ( '+
    'filesys_linked_table, '+
    'filesys_linked_id, '+
    'filesys_name, '+
    'filesys_content '+
  ') '+
  'OUTPUT Inserted.filesys_id '+
  'VALUES ( '+
    '@filesys_linked_table, '+
    '@filesys_linked_id, '+
    '@filesys_name, '+
    '@filesys_content '+
  ') '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function loadFileList(arg) {
  if (arg.filesys_linked_table){
    input = [
      {name:'filesys_linked_table', value:arg.filesys_linked_table},
      {name:'filesys_linked_id', value:arg.filesys_linked_id}
    ]
    query = 'SELECT filesys_id, filesys_name, filesys_time '+
    'FROM filesys '+
    'WHERE filesys_linked_table = @filesys_linked_table '+
    'AND filesys_linked_id = @filesys_linked_id '
  } else if (arg.filesys_id){
    input = [
      {name:'filesys_id', value:arg.filesys_id}
    ]
    query = 'SELECT filesys_id, filesys_name, filesys_time '+
    'FROM filesys '+
    'WHERE filesys_id = @filesys_id '
  } else if (arg.filesys_id_list != null && arg.filesys_id_list.length > 0){
    input = []
    query = 'SELECT filesys_id, filesys_name, filesys_time '+
    'FROM filesys '

    let haswhere = false
    for (let i = 0; i < arg.filesys_id_list.length; i++) {
      input.push({name:'filter_val'+i, value:arg.filesys_id_list[i]})
      if (!haswhere){
        haswhere = true
        query += 'WHERE filesys_id = @filter_val'+i+' '
      } else {
        query += 'OR filesys_id = @filter_val'+i+' '
      }
    }
  } else {
    return null
  }

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function loadAllFileContents(arg) {
  if (arg.filesys_linked_id){
    input = [
      {name:'filesys_linked_table', value:arg.filesys_linked_table},
      {name:'filesys_linked_id', value:arg.filesys_linked_id }
    ]
    query = 'SELECT * '+
    'FROM filesys '+
    'WHERE filesys_linked_table = @filesys_linked_table '+
    'AND filesys_linked_id = @filesys_linked_id '
  } else if (arg.filesys_id_list && arg.filesys_id_list.length > 0){
    let haswhere = false

    input = []
    query = 'SELECT * '+
    'FROM filesys '

    for (let i = 0; i < arg.filesys_id_list.length; i++) {
      input.push({name:'filter_val'+i, value:arg.filesys_id_list[i]})
      if (!haswhere){
        haswhere = true
        query += 'WHERE filesys_id = @filter_val'+i+' '
      } else {
        query += 'OR filesys_id = @filter_val'+i+' '
      }
    }
  } else return null

  arg.input = input
  arg.query = query

  // console.log('filesys_load_contents', arg)

  return await dbExecuteQuery(arg)
}

async function loadFile(arg) {
  input = [
    {name:'filesys_id', value:arg.filesys_id}
  ]
  query = 'SELECT * '+
  'FROM filesys '+
  'WHERE filesys_id = @filesys_id '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function setPcardRecapHasSupervisorStage(hasSupervisor, uname){
  input = [
    {name:'constName', value:'pcard_recap_manager_review_enabled'},
    {name:'targetSupervisor', value:hasSupervisor?0:1}
  ]

  arg = {}

  query = 'UPDATE constants SET '+
  'const_value = @targetSupervisor '+
  'WHERE const_name =  @constName '+
  'IF @@ROWCOUNT=0 '+
  'INSERT INTO constants ( '+
    'const_name, '+
    'const_value '+
  ') '+
  'VALUES ( '+
    '@constName, '+
    '@targetSupervisor '+
  ') '

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'constants'
  arg.log_linked_id = 'pcard_recap_manager_review_enabled'
  arg.log_type = 'TOGGLE'
  arg.log_desc = 'TOGGLE SUPERVISOR REVIEW '+(hasSupervisor?'OFF':'ON')
  arg.log_uname = uname

  console.log('arg', arg)

  return await dbExecuteQuery(arg)
}

async function loadPcardRecap(arg) {
  let haswhere = false

  query = 'SELECT * '+
    'FROM pcard_recap '+
    'LEFT OUTER JOIN employee ON employee.emp_id = pcard_recap.txn_emp_id '+
    'LEFT OUTER JOIN pcard ON ( '+
      'pcard.pcard_emp_id = pcard_recap.txn_emp_id '+
      'AND pcard.pcard_last_4 = pcard_recap.txn_card_num '+
    ') '

  if (arg.target_name && arg.target_name != null && arg.target_name != ''){
    haswhere = true
    if (arg.special_or_filter_name && arg.special_or_filter_name != null && arg.special_or_filter_name != ''){
      query += 'WHERE ( '
    } else {
      query += 'WHERE '
    }

    if (arg.target_val == stagelist[0]){
      input = [
        {name:'target_val', value:arg.target_val},
        {name:'status_delivery_pending', value:purchasestatus[0]}
      ]
      query +='( pcard_recap.' +arg.target_name +' = @target_val '+
        'OR pcard_recap.txn_purchase_status = @status_delivery_pending ) '

    } else if (arg.target_val == stagelist[1]){
      input = [
        {name:'target_val', value:arg.target_val}
      ]
      query +='pcard_recap.' +arg.target_name +' = @target_val '

    } else {
      input = [{name:'target_val', value:arg.target_val}]
      query +='pcard_recap.' +arg.target_name +' = @target_val '
    }

    if (arg.special_or_filter_name && arg.special_or_filter_name != null && arg.special_or_filter_name != ''){
      input.push({name:'special_or_filter_val', value:arg.special_or_filter_val})
      query += 'OR pcard_recap.' +arg.special_or_filter_name +' = @special_or_filter_val ) '
    }
  } else {
    input = []
  }

  if (arg.filter_name && arg.filter_val && arg.filter_name.length > 0 && arg.filter_name.length ==  arg.filter_val.length ){
    for (let i = 0; i < arg.filter_name.length; i++) {
      if (arg.filter_name[i] == 'txn_emp_full_name'){
        val = String(arg.filter_val[i]).replace(/[^\w\sa-zA-Z 0-9\.\,\+\-]/gi, '')
        input.push({name:'filter_val'+i, value:val})
        subquery = 'SELECT emp_id FROM employee WHERE '+'emp_fname' +" LIKE '%"+val+"%' " +" OR "+'emp_lname' +" LIKE '%"+val+"%' "
        query += 'WHERE pcard_recap.txn_emp_id IN ('+subquery+') '
      } else {
        //FIXME: APPLY THIS EVERYWHERE QUERIES STRING INSERT VALUES DIRECTLY: cleanup input to prevent SQL injection
        let val = 'INVALID'
        try {
          if (arg.filter_name[i] == 'txn_card_num'){
            throw Error
          } else if (arg.filter_name[i].includes('_date') || arg.filter_name[i].includes('_cycle') || arg.filter_name[i].includes('_year')){
            val = new Date(arg.filter_val[i]).toISOString().split('T')[0]
          } else {
            throw Error
          }
        } catch (error) {
          // console.log('error', error)
          val = String(arg.filter_val[i]).replace(/[^\w\sa-zA-Z 0-9\.\,\+\-]/gi, '')
        }
        console.log('val', val)
        input.push({name:'filter_val'+i, value:val})
        if (!haswhere){
          haswhere = true
          query += 'WHERE pcard_recap.' +arg.filter_name[i] +" LIKE '%"+val+"%' "
        } else {
          query += 'AND pcard_recap.' +arg.filter_name[i] +" LIKE '%"+val+"%' "
        }
      }
    }
  }

  query += 'ORDER BY pcard_recap.txn_purchase_date, pcard_recap.txn_card_num '

  arg.input = input
  arg.query = query

  console.log('arg', arg)
  argout = await dbExecuteQuery(arg)

  if (arg.superlist){
    // LOAD ALL EXTRAS
    for (let i = 0; i < argout.recordset.length; i++) {
      const arg2 = {}
      arg2.log_linked_table = 'pcard_recap'
      arg2.log_linked_id = argout.recordset[i].txn_id
      arg2.filesys_linked_table = 'pcard_recap'
      arg2.filesys_linked_id = argout.recordset[i].txn_id

      argout2 = await loadComments(arg2)
      let comments = []
      argout2.recordset.forEach(log => {
        if (log.log_note != null) {
          comments.push(log)
        }
      });
      // console.log('comments list', comments)
      argout.recordset[i].log_notes = comments

      argout3 = await pcardRecapLoadSubitems(argout.recordset[i])
      let subitems = []
      argout3.recordset.forEach(subitem =>{
        if (subitem.subitem_id != null) {
          subitems.push(subitem)
        }
      })
      // console.log('subitems list', subitems)
      argout.recordset[i].sub_items = subitems

      argout4 = await loadFileList(arg2)
      let files = []
      argout4.recordset.forEach(file =>{
        if (file.filesys_id != null) {
          files.push(file)
        }
      })
      // console.log('file list', files)
      argout.recordset[i].file_list = files

      delete argout.recordset[i].input
      delete argout.recordset[i].query
    }
  } else {
    // ONLY LOAD EXTRAS FOR ITEM 1 (index 0)
    if (argout.recordset && argout.recordset[0]){
      const arg2 = {}
      arg2.log_linked_table = 'pcard_recap'
      arg2.log_linked_id = arg.target_val
      arg2.filesys_linked_table = 'pcard_recap'
      arg2.filesys_linked_id = argout.recordset[0].txn_id

      argout2 = await loadComments(arg2)
      let comments = []
      argout2.recordset.forEach(log => {
        if (log.log_note != null) {
          comments.push(log)
        }
      });
      // console.log('comments list', comments)
      argout.recordset[0].log_notes = comments

      argout3 = await pcardRecapLoadSubitems(argout.recordset[0])
      let subitems = []
      argout3.recordset.forEach(subitem =>{
        if (subitem.subitem_id != null) {
          subitems.push(subitem)
        }
      })
      // console.log('subitems list', subitems)
      argout.recordset[0].sub_items = subitems

      argout4 = await loadFileList(arg2)
      let files = []
      argout4.recordset.forEach(file =>{
        if (file.filesys_id != null) {
          files.push(file)
        }
      })
      // console.log('file list', files)
      argout.recordset[0].file_list = files
    }
  }

  return argout
}

async function pcardRecapModify(arg, uname){
  input = [
    {name:'txn_id', value:arg.txn_id}
  ]

  notescomment = ''

  let purgefirst = false
  query = 'UPDATE pcard_recap SET '

  if (arg.txn_purchase_desc != null && arg.txn_purchase_desc != ''){
    input.push(
      {name:'txn_purchase_desc', value:arg.txn_purchase_desc},
      {name:'txn_purchase_purpose', value:arg.txn_purchase_purpose},
      {name:'txn_purchase_status', value:arg.txn_purchase_status},
      {name:'txn_max_stage', value:arg.txn_max_stage},
      {name:'txn_status', value:arg.txn_status},
      {name:'txn_fiscal_year', value:arg.txn_fiscal_year}
    )
    query += 'txn_purchase_desc = @txn_purchase_desc, '+
    'txn_purchase_purpose = @txn_purchase_purpose, '+
    'txn_purchase_status = @txn_purchase_status, '+
    'txn_max_stage = @txn_max_stage, '+
    'txn_status = @txn_status, '+
    'txn_fy_count = COALESCE(txn_fy_count, '+
      '( '+
        'SELECT COALESCE(MAX(txn_fy_count), 0) '+
        'FROM pcard_recap '+
        'WHERE txn_fiscal_year= ( '+
          'SELECT txn_fiscal_year '+
          'FROM pcard_recap '+
          'WHERE txn_id = @txn_id '+
        ') '+
      ')+1 '+
    ') '

    notescomment += ' to Stage '+String(arg.txn_status)
  } else {
    purgefirst = true

    if (arg.txn_purchase_status != null && arg.txn_purchase_status != ''){
      input.push({name:'txn_purchase_status', value:arg.txn_purchase_status})
      query += ', txn_purchase_status = @txn_purchase_status '
      notescomment += ', to Delivery Status '+String(arg.txn_purchase_status)
    }
  }
  if (arg.txn_user_certificate != null && arg.txn_user_certificate != ''){
    input.push({name:'txn_user_certificate', value:arg.txn_user_certificate})
    query += ', txn_user_certificate = @txn_user_certificate '
    input.push({name:'txn_user_for_another', value:arg.txn_user_for_another})
    query += ', txn_user_for_another = @txn_user_for_another '
    input.push({name:'txn_user_signature', value:arg.txn_user_signature})
    query += ', txn_user_signature = @txn_user_signature '
  }
  if (arg.txn_cartegraph_status != null && arg.txn_cartegraph_status != ''){
    input.push({name:'txn_cartegraph_status', value:arg.txn_cartegraph_status})
    query += ', txn_cartegraph_status = @txn_cartegraph_status '

    notescomment += ', to Cartegraph '+String(arg.txn_cartegraph_status)
  }
  if (arg.txn_cartegraph_amt != null && arg.txn_cartegraph_amt != ''){
    input.push({name:'txn_cartegraph_amt', value:arg.txn_cartegraph_amt})
    query += ', txn_cartegraph_amt = @txn_cartegraph_amt '
  }
  if (arg.txn_use_tax_status != null && arg.txn_use_tax_status != ''){
    input.push({name:'txn_use_tax_status', value:arg.txn_use_tax_status})
    query += ', txn_use_tax_status = @txn_use_tax_status '

    notescomment += ', to Usetax '+String(arg.txn_use_tax_status)
  }
  if (arg.txn_use_tax_rate != null && arg.txn_use_tax_rate != ''){
    input.push({name:'txn_use_tax_rate', value:arg.txn_use_tax_rate})
    query += ', txn_use_tax_rate = @txn_use_tax_rate '
  }
  if (arg.txn_use_tax_amt != null && arg.txn_use_tax_amt != ''){
    input.push({name:'txn_use_tax_amt', value:arg.txn_use_tax_amt})
    query += ', txn_use_tax_amt = @txn_use_tax_amt '
  }
  if (arg.txn_task_id != null && arg.txn_task_id != ''){
    input.push({name:'txn_task_id', value:arg.txn_task_id})
    query += ', txn_task_id = @txn_task_id '
  }
  if (arg.txn_travel_id != null && arg.txn_travel_id != ''){
    input.push({name:'txn_travel_id', value:arg.txn_travel_id})
    query += ', txn_travel_id = @txn_travel_id '
  }

  query += 'WHERE txn_id = @txn_id '

  if(purgefirst){
    query = query.replace(',', '')
    notescomment = notescomment.replace(',', '')
  }

  arg.input = input
  arg.query = query

  arg.log_linked_table = 'pcard_recap'
  arg.log_linked_id = String(arg.txn_id)
  arg.log_type = 'UPDATE'
  arg.log_desc = 'Update Pcard Recap' +notescomment
  arg.log_uname = uname

  return await dbExecuteQuery(arg)
}

async function loadAllUsers(){
  arg = {query:'SELECT * FROM employee'}
  return await dbExecuteQuery(arg)
}

async function loadAllPcards(){
  arg = {query:'SELECT * FROM employee INNER JOIN pcard ON employee.emp_id = pcard.pcard_emp_id'}
  return await dbExecuteQuery(arg)
}

async function getExtraUserData(txnid){
  input = [{name:'txn_id', value:txnid}]
  query = ''+
    'SELECT SUM(txn_amt) AS txn_spent '+
    'FROM pcard_recap '+
    'WHERE txn_emp_id IN '+
    '( '+
      'SELECT txn_emp_id '+
      'FROM pcard_recap '+
      'WHERE pcard_recap.txn_id = @txn_id '+
    ') '+
    'AND txn_bill_cycle = '+
    '( '+
      'SELECT MAX(txn_bill_cycle) '+
      'FROM pcard_recap '+
    ') '

    arg = {
      input: input,
      query: query
    }

    return await dbExecuteQuery(arg)
}

async function pcardRecapLoadSubitems(arg){
  input = [{name:'txn_id', value:arg.txn_id}]

  query = 'SELECT * '+
  'FROM pcard_recap_subitem '+
  'WHERE subitem_txn_id = @txn_id '

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function pcardRecapAddUpdateSubitem(arg){
  if (arg.subitem_id && arg.subitem_id != null && arg.subitem_id != ''){
    input = [
      {name:'subitem_id', value:arg.subitem_id},
      {name:'subitem_name', value:arg.subitem_name},
      {name:'subitem_obj_code', value:arg.subitem_obj_code},
      {name:'subitem_org_key', value:arg.subitem_org_key},
      {name:'subitem_total', value:arg.subitem_total},
      {name:'subitem_txn_id', value:arg.subitem_txn_id}
    ]
    query = 'UPDATE pcard_recap_subitem SET '+
    'subitem_name = @subitem_name, '+
    'subitem_obj_code = @subitem_obj_code, '+
    'subitem_org_key = @subitem_org_key, '+
    'subitem_total = @subitem_total, '+
    'subitem_txn_id = @subitem_txn_id '+
    'WHERE subitem_id = @subitem_id '+
    'IF @@ROWCOUNT=0 '+
    'INSERT INTO pcard_recap_subitem ( '+
      'subitem_name, '+
      'subitem_obj_code, '+
      'subitem_org_key, '+
      'subitem_total, '+
      'subitem_txn_id '+
    ') '+
    'VALUES ( '+
      '@subitem_name, '+
      '@subitem_obj_code, '+
      '@subitem_org_key, '+
      '@subitem_total, '+
      '@subitem_txn_id '+
    ') '
  } else {
    input = [
      {name:'subitem_name', value:arg.subitem_name},
      {name:'subitem_obj_code', value:arg.subitem_obj_code},
      {name:'subitem_org_key', value:arg.subitem_org_key},
      {name:'subitem_total', value:arg.subitem_total},
      {name:'subitem_txn_id', value:arg.subitem_txn_id}
    ]
    query = 'INSERT INTO pcard_recap_subitem ( '+
      'subitem_name, '+
      'subitem_obj_code, '+
      'subitem_org_key, '+
      'subitem_total, '+
      'subitem_txn_id '+
    ') '+
    'VALUES ( '+
      '@subitem_name, '+
      '@subitem_obj_code, '+
      '@subitem_org_key, '+
      '@subitem_total, '+
      '@subitem_txn_id '+
    ') '
  }

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

async function pcardRecapDeleteSubitem(arg){
  input = [{name:'subitem_id', value:arg.subitem_id}]
  query = 'DELETE FROM pcard_recap_subitem '+
    'WHERE subitem_id=@subitem_id'

  arg.input = input
  arg.query = query

  return await dbExecuteQuery(arg)
}

function calculatebillcycle(postdate){
  pdate = new Date(postdate)

  if (pdate.getUTCDate()<=27){
    pdate.setUTCDate(1)
  } else {
    pdate.setUTCDate(1)
    pdate.setUTCMonth(pdate.getUTCMonth()+1)
  }

  return pdate
}

function calculatefiscalyear(transactiondate){
  tdate = new Date(transactiondate)

  // month is 0 indexed
  // date is 1 indexed
  if (tdate.getUTCMonth()+1 >=7){
    tdate.setUTCFullYear(tdate.getUTCFullYear()+1)
  }
  tdate.setUTCMonth(0)
  tdate.setUTCDate(1)

  return tdate
}

async function pcardAddTransaction(arg){
  b_c = calculatebillcycle(arg['Post Date'])
  f_y = calculatefiscalyear(arg['Purchase Date'])
  p_d = new Date(arg['Post Date'])
  p_c_d = new Date(arg['Purchase Date'])

  arg['Card Last 4 Digits'] = String(parseInt(arg['Card Last 4 Digits'])).padStart(4, '0')

  input = [
    {name:'pcard_name_on_card', value:arg['CH Full Name']},
    {name:'txn_card_num', value:arg['Card Last 4 Digits']},
    {name:'txn_vendor_name', value:arg['Comp Supp Name']},
    {name:'txn_amt', value:arg['Original Amount']},
    {name:'txn_post_date', value:p_d},
    {name:'txn_purchase_date', value:p_c_d},
    {name:'txn_id', value:arg['Txn Number']},
    {name:'txn_bill_cycle', value:b_c},
    {name:'txn_fiscal_year', value:f_y},
    {name:'backup_cardnum', value:"000000000000"}
  ]

  let name_segments = arg['CH Full Name'].split(', ')
  // console.log('name_segments', name_segments)
  val1 = String(name_segments[0]).replace(/[^\w\sa-zA-Z 0-9\.\,\+\-]/gi, '')
  try{
    val2 = String(name_segments[1]).replace(/[^\w\sa-zA-Z 0-9\.\,\+\-]/gi, '')
  } catch {
    val2 = val1
  }

  query = 'SELECT * FROM pcard '+
  'WHERE '+'pcard_name_on_card' +" LIKE '%"+val1+"%' " +
  "AND "+'pcard_name_on_card' +" LIKE '%"+val2+"%' "+
  'AND pcard_last_4 = @txn_card_num '+
  'IF @@ROWCOUNT= 0 '+
  'INSERT INTO pcard ( '+
    'pcard_name_on_card, '+
    'pcard_last_4, '+
    'pcard_first_12 '+
  ') '+
  'VALUES ( '+
    '@pcard_name_on_card, '+
    '@txn_card_num, '+
    '@backup_cardnum '+
  ') '

  arg = {
    input:input,
    query:query
  }
  await dbExecuteQuery(arg)

  query = 'UPDATE pcard SET '+
  'pcard_name_on_card = @pcard_name_on_card '+
  'WHERE pcard_name_on_card IS NULL '+
  'AND pcard_last_4 = @txn_card_num '
  arg.query=query
  await dbExecuteQuery(arg)

  query = 'INSERT INTO pcard_recap ( '+
    'txn_emp_id, '+
    'txn_card_num, '+
    'txn_vendor_name, '+
    'txn_amt, '+
    'txn_post_date, '+
    'txn_purchase_date, '+
    'txn_id, '+
    'txn_bill_cycle, '+
    'txn_fiscal_year '+
  ') '+
  'VALUES ( '+
    '( '+
      'SELECT TOP 1 pcard_emp_id FROM pcard '+
      'WHERE pcard_last_4=@txn_card_num '+
      'AND '+'pcard_name_on_card' +" LIKE '%"+val1+"%' " +
      "AND "+'pcard_name_on_card' +" LIKE '%"+val2+"%' "+
      'ORDER BY pcard_enabled, pcard_expire_date, pcard_issue_date DESC'+
    '), '+
    '@txn_card_num, '+
    '@txn_vendor_name, '+
    '@txn_amt, '+
    '@txn_post_date, '+
    '@txn_purchase_date, '+
    '@txn_id, '+
    '@txn_bill_cycle, '+
    '@txn_fiscal_year '+
  ') '
  arg.query=query
  return await dbExecuteQuery(arg)
}

module.exports = {
  createEvent,
  createTravel,
  loadConstants,
  loadOrgKeys,
  loadObjCodes,
  loadPermissions,
  loadSupervisors,
  org_load,
  obj_load,
  org_add,
  obj_add,
  org_edit,
  obj_edit,
  userLookup,
  userModify,
  loadTravelRecap,
  loadPcardRecap,
  loadComments,
  travelModify,
  loadAllUsers,
  loadAllPcards,
  pcardLookup,
  pcardLookupEmpid,
  pcardModify,
  setPcardRecapHasSupervisorStage,
  getExtraUserData,
  pcardRecapModify,
  pcardRecapLoadSubitems,
  pcardRecapAddUpdateSubitem,
  pcardRecapDeleteSubitem,
  pcardAddTransaction,
  dbLogQuery,
  uploadFile,
  loadFileList,
  loadAllFileContents,
  loadFile,
  loadequipmenttypes,
  loadequipmentlocations,
  loaddepartments,
  loadequipmentclassifications,
  loadequipmentmanufacturers,
  loadequipmentvendors,
  submitaddequipmentform,
  loadequipmentlist,
  loadHistory,
  loadAllCartegraphUsers,
  searchlookup,
  deletelookup,
  selectionlookup,
  modifyaddequipmentform,
  selectedequipmentmodify
}