const {ipcRenderer} = require('electron')
const $ = require('jquery')

const {createAlert} = require("../utilities/alert_box")
const {makeSortable} = require('../utilities/sortable')
makeSortable()

document.getElementById("quit_app").addEventListener("click", ()=>{
  ipcRenderer.invoke('quit_app')
});

Supervisors = ipcRenderer.invoke('getSupervisors').then(result =>{
  Supervisors = result
  emp_supervisor_id = document.getElementById("emp_supervisor_id")
  console.log('emp_supervisor_id:', Supervisors)
  for (let i = 0; i < Supervisors.length; i++) {
    let name = Supervisors[i].emp_lname +', '+ Supervisors[i].emp_fname
    let id = Supervisors[i].emp_id
    option = document.createElement('option')
    option.value = id
    option.text = name
    emp_supervisor_id.add(option)
  }
})






OrgKeys = ipcRenderer.invoke('getOrgKeys').then(result =>{
  OrgKeys = result
  emp_org_key = document.getElementById('emp_org_key')
  console.log('emp_org_key:', OrgKeys)
  for (let i = 0; i < OrgKeys.length; i++) {
    let name = OrgKeys[i].org_key +': '+ OrgKeys[i].org_desc
    let id = OrgKeys[i].org_key
    option = document.createElement('option')
    option.value = id
    option.text = name
    emp_org_key.add(option)
  }
})

let values = window.location.search.split('?')
let stagemode = null
if (values.length >= 1 && values[1]){
  stagemode = values[1]
}
console.log('stagemode', stagemode)
baseurl = '../../index.html?equipment'
if (stagemode == null){
  targeturl = baseurl + '?equipadmin'
} else {
  targeturl = baseurl + '?'+String(stagemode)
}
document.getElementById('goto_home').href = targeturl

document.getElementById("exportlist_excel").addEventListener('click', async()=>{
  event.preventDefault()

  ipcRenderer.invoke('load-all-employees').then(async result =>{
    listvals = result.recordset

    // FILTER VALUES
    const keys = Object.keys(listvals[0])
    console.log('keys', keys)
    for (let i = 0; i < listvals.length; i++) {
      for (let j = 0; j < keys.length; j++){
        if (listvals[i][String(keys[j])] && listvals[i][String(keys[j])].toUTCString){
          listvals[i][String(keys[j])] = listvals[i][String(keys[j])].toUTCString().substring(4,16)
        }
      }
    }

    // SAVE FILE
    console.log('table contents', listvals)
    await ipcRenderer.invoke('csv-save-dialog', listvals).then(results=>{
      if (results == -1) {
        createAlert('info', 'Export File Cancelled')
      } else {
        createAlert('success', 'CSV Exported!')
      }
    }).catch(err=>{
      createAlert('error', 'File Save Error: '+err.toString())
    })
  }).catch(error=>{
    createAlert('warning', 'Export Excel Error ' +error.toString())
  })
})

let selection = null

function makeSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('multiselect')){
      trs[i].addEventListener("click", function(){
        console.log('selection set')
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        else cn = cn.replace(thc,"");
        this.className = cn;
      })
    } else if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener("click", function(){
        console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection = this.cells[0].textContent
        console.log('selection', selection)
      })
    }
  }
}

// document.getElementById('headerspace').textContent = document.getElementById('header').textContent

// permission levels: ADMIN, FINANCE, SUPERVISOR, SELF, ''

const table = document.getElementById('userlist')

async function reloadAllUsers(){
  selection = null
  let trs = document.getElementsByClassName('singleselect')
  for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }

  ipcRenderer.invoke('load-all-employees').then( result =>{
    for(let i = 0; i < result.recordset.length; i++){
      let maxpermission = 'None'

      if (result.recordset[i].emp_admin_permission){
        maxpermission = 'Admin'
      } else {
        maxpermission = result.recordset[i].emp_position
      }

      // console.log('add user', result.recordset[i])
      let row = table.insertRow()
      row.className = 'singleselect'
      row.insertCell(0).textContent = result.recordset[i].emp_id
      row.insertCell(1).textContent = result.recordset[i].emp_uname

      row.insertCell(2).textContent = String(result.recordset[i].emp_active?"Yes": "No")
      row.insertCell(3).textContent = result.recordset[i].emp_lname
      row.insertCell(4).textContent = result.recordset[i].emp_fname

      row.insertCell(5).textContent = maxpermission
    }
    makeSelectable()
  })
}

// modal stuff:
const userModal = document.getElementById("userModal");
const closeUserModal = document.getElementsByClassName("close")[0];
const lookupUserModal = document.getElementById('lookupUserModal')
const closelookupUserModal = document.getElementsByClassName("close")[1];
closeUserModal.onclick = function() {
  $(userModal).hide()
}
closelookupUserModal.onclick = function() {
  $(lookupUserModal).hide()
}
window.onclick = function(event) {
  if (event.target == userModal) {
    $(userModal).hide()
  } else if (event.target == lookupUserModal) {
    $(lookupUserModal).hide()
  }
}

document.getElementById('lookup_employee').addEventListener('click', ()=>{
  event.preventDefault()

  target = document.getElementById('lookup_emp_id').value
  console.log('target', target)

  if(document.getElementById('lookupUserForm').checkValidity()) {
    dispUserModal(target)
    $(lookupUserModal).hide()
  } else {
    document.getElementById('lookupPcardForm').reportValidity()
  }
})

document.getElementById('view_selected_user').addEventListener('click', ()=>{
  console.log('load selected user', selection)
  if (selection){
    dispUserModal(selection)
  } else {
    createAlert('No Selection to Load!')
  }
})

mode = 'search'
document.getElementById('search_user').addEventListener('click', ()=>{
  console.log('lookup by emp id')
  document.getElementById('lookup_emp_id').value = ''
  mode = 'search'
  $(lookupUserModal).show();
})

document.getElementById('add_new_user').addEventListener('click', ()=>{
  console.log('create by emp id')
  document.getElementById('lookup_emp_id').value = ''
  mode = 'add'
  $(lookupUserModal).show();
})

const doc_emp_uname = document.getElementById('emp_uname')
async function dispUserModal(instr=''){
  await ipcRenderer.invoke('load-single-employee', instr).then(result =>{
    if (result && result.recordset && result.recordset.length > 0){
      createAlert('info', 'Loaded Employee!')
      let arg = result.recordset[0]
      console.log('result', arg)
      $(userModal).show();

      document.getElementById('emp_active').value = arg.emp_active
      document.getElementById('emp_email').value = arg.emp_email
      document.getElementById('emp_fname').value = arg.emp_fname
      document.getElementById('emp_id').value = arg.emp_id
      document.getElementById('emp_lname').value = arg.emp_lname
      document.getElementById('emp_org_key').value = arg.emp_org_key
      document.getElementById('emp_supervisor_id').value = arg.emp_supervisor_id


      if (arg.emp_uname && arg.emp_uname != '') {
        doc_emp_uname.value = arg.emp_uname
        doc_emp_uname.setAttribute('disabled', 'disabled')
        doc_emp_uname.removeAttribute('required')
      } else {
        doc_emp_uname.value = ''
        doc_emp_uname.setAttribute('required', 'required')
        doc_emp_uname.removeAttribute('disabled')
      }

      document.getElementById('emp_admin_permission').checked = Boolean(arg.emp_admin_permission)
      document.getElementById('emp_cartegraph_permission').checked = Boolean(arg.emp_cartegraph_permission)
      document.getElementById('emp_hr_permission').checked = Boolean(arg.emp_hr_permission)
      document.getElementById('emp_finance_permission').checked = Boolean(arg.emp_finance_permission)
      document.getElementById('emp_position').value = arg.emp_position

      document.getElementById('emp_pcard_permission').checked = Boolean(arg.emp_pcard_permission)
      document.getElementById('emp_travel_permission').checked = Boolean(arg.emp_travel_permission)
      document.getElementById('emp_equipment_permission').checked = Boolean(arg.emp_equipment_permission)
      document.getElementById('emp_budget_permission').checked = Boolean(arg.emp_budget_permission)

      document.getElementById('emp_pcard_admin').checked = Boolean(arg.emp_pcard_admin)
      document.getElementById('emp_travel_admin').checked = Boolean(arg.emp_travel_admin)
      document.getElementById('emp_equipment_admin').checked = Boolean(arg.emp_equipment_admin)
      document.getElementById('emp_budget_admin').checked = Boolean(arg.emp_budget_admin)
      document.getElementById('emp_Equip_submitmode_permission').checked = Boolean(arg.emp_Equip_submitmode_permission)
      document.getElementById('emp_Equip_approvermode_permission').checked = Boolean(arg.emp_Equip_approvermode_permission)
    } else if (mode == 'search'){
      createAlert('Employee Not Found!')
    } else {
      createAlert('Info', 'Creating New Employee!')
      $(userModal).show();

      document.getElementById('emp_active').value = ''
      document.getElementById('emp_email').value = ''
      document.getElementById('emp_fname').value = ''
      document.getElementById('emp_id').value = instr
      document.getElementById('emp_lname').value = ''
      document.getElementById('emp_org_key').value = ''
      document.getElementById('emp_supervisor_id').value = ''

      doc_emp_uname.value = ''
      doc_emp_uname.setAttribute('required', 'required')
      doc_emp_uname.removeAttribute('disabled')

      document.getElementById('emp_admin_permission').checked = false
      document.getElementById('emp_cartegraph_permission').checked = false
      document.getElementById('emp_hr_permission').checked = false
      document.getElementById('emp_finance_permission').checked = false
      document.getElementById('emp_position').value = ''

      document.getElementById('emp_pcard_permission').checked = false
      document.getElementById('emp_travel_permission').checked = false
      document.getElementById('emp_equipment_permission').checked = false
      document.getElementById('emp_budget_permission').checked = false

      document.getElementById('emp_pcard_admin').checked = false
      document.getElementById('emp_travel_admin').checked = false
      document.getElementById('emp_equipment_admin').checked = false
      document.getElementById('emp_budget_admin').checked = false
      document.getElementById('emp_Equip_submitmode_permission').checked = false
      document.getElementById('emp_Equip_approvermode_permission').checked = false
    }
  }).catch(err =>{
    console.log('load user modal error', err.name)
    console.log(err)
  })
}

document.getElementById('emp_pcard_permission').addEventListener('change', event=>{
  if(!event.target.checked){
    document.getElementById('emp_pcard_admin').checked = false
  }
})
document.getElementById('emp_pcard_admin').addEventListener('change', event=>{
  if(event.target.checked){
    document.getElementById('emp_pcard_permission').checked = true
  }
})
document.getElementById('emp_travel_permission').addEventListener('change', event=>{
  if(!event.target.checked){
    document.getElementById('emp_travel_admin').checked = false
  }
})
document.getElementById('emp_travel_admin').addEventListener('change', event=>{
  if(event.target.checked){
    document.getElementById('emp_travel_permission').checked = true
  }
})
document.getElementById('emp_equipment_permission').addEventListener('change', event=>{
  if(!event.target.checked){
    document.getElementById('emp_equipment_admin').checked = false
  }
})
document.getElementById('emp_equipment_admin').addEventListener('change', event=>{
  if(event.target.checked){
    document.getElementById('emp_equipment_permission').checked = true
  }
})
document.getElementById('emp_budget_permission').addEventListener('change', event=>{
  if(!event.target.checked){
    document.getElementById('emp_budget_admin').checked = false
  }
})
document.getElementById('emp_budget_admin').addEventListener('change', event=>{
  if(event.target.checked){
    document.getElementById('emp_budget_permission').checked = true
  }
})


document.getElementById('update-employee').addEventListener('click', async ()=>{
  event.preventDefault()

  arg = {
    emp_active:document.getElementById('emp_active').value,
    emp_id:document.getElementById('emp_id').value,
    emp_uname:document.getElementById('emp_uname').value,
    emp_lname:document.getElementById('emp_lname').value,
    emp_fname:document.getElementById('emp_fname').value,
    emp_email:document.getElementById('emp_email').value,
    emp_supervisor_id:document.getElementById('emp_supervisor_id').value,
    emp_org_key:document.getElementById('emp_org_key').value,
    emp_pcard_permission:document.getElementById('emp_pcard_permission').checked ? 1 : 0,
    emp_pcard_admin:document.getElementById('emp_pcard_admin').checked ? 1 : 0,
    emp_travel_permission:document.getElementById('emp_travel_permission').checked ? 1 : 0,
    emp_travel_admin:document.getElementById('emp_travel_admin').checked ? 1 : 0,
    emp_equipment_permission:document.getElementById('emp_equipment_permission').checked ? 1 : 0,
    emp_equipment_admin:document.getElementById('emp_equipment_admin').checked ? 1 : 0,
    emp_budget_permission:document.getElementById('emp_budget_permission').checked ? 1 : 0,
    emp_budget_admin:document.getElementById('emp_budget_admin').checked ? 1 : 0,
    emp_admin_permission:document.getElementById('emp_admin_permission').checked ? 1 : 0,
    emp_position:document.getElementById('emp_position').value,
    emp_cartegraph_permission:document.getElementById('emp_cartegraph_permission').checked ? 1 : 0,
    emp_finance_permission:document.getElementById('emp_finance_permission').checked ? 1 : 0,
    emp_hr_permission:document.getElementById('emp_hr_permission').checked ? 1 : 0,
    emp_Equip_submitmode_permission:document.getElementById('emp_Equip_submitmode_permission').checked ? 1 : 0,
    emp_Equip_approvermode_permission:document.getElementById('emp_Equip_approvermode_permission').checked ? 1 : 0
  }

  console.log('update user', arg)
  if (document.getElementById('modifyUserForm').checkValidity()) {
    console.log('form valid; submitting update query')
    result = await ipcRenderer.invoke('modify-single-employee', arg)

    if (result) {
      console.log('success')
    } else {
      console.log('failure')
    }

    $(userModal).hide()
    reloadAllUsers()
  } else {
    console.log('Form invalid; Update impossible')
    createAlert('danger', 'Form invalid; Update impossible')
    document.getElementById('modifyUserForm').reportValidity()
  }

})

// on load everything else
reloadAllUsers()