const {ipcRenderer, remote} = require('electron')
const Inputmask = require('inputmask');
const autosize = require('autosize')
const {createObjectURL} = require('blob-util')
const {makeEquipmentPDF} = require('../utilities/reportgen')
const $ = require('jquery')

const {createAlert} = require("../utilities/alert_box")

const {makeSortable} = require('../utilities/sortable')
let windowlist = []
let previframe = []

makeSortable()


// FIXME: remember that this is a partial and hacky solution to preventing the enter key from doing things
// it may or may not be a good decision
// FIXME: decide if it is permanent
$("input").bind("keydown", function(event) {
    if (event.which === 13) {
        event.stopPropagation();
        event.preventDefault();
        $(this).nextAll("input").eq(0).focus();
    }
  });


document.getElementById("quit_app").addEventListener("click", ()=>{
ipcRenderer.invoke('quit_app')
});


const goto_home = document.getElementById("goto_home")
const goto_back = document.getElementById('goto_back')
const goto_search = document.getElementById("goto_search")
const goto_list = document.getElementById("goto_list")


// CLOSE ALL POPUPS ON PAGE CHANGE
window.onbeforeunload = function(){
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';
};

goto_back.addEventListener('click', ()=>{
  event.preventDefault()
  console.log('go back to prev stage')
  
  goto_home.click()
  
})

goto_search.addEventListener('click', ()=>{
  console.log('goto_search')
  //console.log('loading prev filterlist', prev_filterlist.value)
  swapPage('Search', goto_search, 'forestgreen')
  ResetAll()
  // goto_list.setAttribute('disabled', 'disabled')

  
})

goto_list.addEventListener('click', ()=>{
  
  
   swapPage('List', goto_list, 'navy')
  //goto_list.removeAttribute('disabled')
  //requestAutoFilterList() //NOTE: this can have different inputs depending on if it is intended to be filtered or not.
//})

// goto_list.removeAttribute('disabled')
// goto_selected.addEventListener('click', ()=>{
//   swapPage('Selection', goto_selected, 'darkred')
//   goto_list.removeAttribute('disabled')
})

function swapPage(pageName, elmnt, color){
  curstage = elmnt

  window.scrollTo(0,0);
  const tabcontent = document.getElementsByClassName("tabcontent")
  for (i=0; i < tabcontent.length; i++) {
  $(tabcontent[i]).hide()
  }

  const tablinks = document.getElementsByClassName("tablink")
  for (i=0; i < tablinks.length; i++) {
  tablinks[i].style.backgroundColor = ""
  tablinks[i].style.backgroundImage = ""
  }

  let targetpage = document.getElementById(pageName)
  $(targetpage).show()
  targetpage.style.backgroundColor = color
  elmnt.style.backgroundColor = color;
  elmnt.style.backgroundImage = 'none'

  
}


//Makes item in the List selectable
const selection = {}
const subitemselection = {}
function makeRecaplistSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = JSON.parse(this.cells[0].textContent).Equipmentformid

        console.log('selection set', selection.value)
        // getExtraUserData(JSON.parse(this.cells[0].textContent))
      })
    }
  }
}

const table = document.getElementById('recaplist')
//let goto_list = document.getElementById("goto_list")

document.getElementById('apply_filter_major').addEventListener('click', async ()=>{
  
  event.preventDefault()
  console.log('asdf')
  
  

  if (document.getElementById("fromdate").checkValidity() && document.getElementById("todate")){
    arg= {
      fromdate:document.getElementById("fromdate").value,
      todate:document.getElementById("todate").value

    }
    $("#recaplist tr").remove(); 

    selection.value = null
    let trs = document.getElementsByClassName('singleselect')
    for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }
  loadlist()

  
 }


//Loads the List for the Search File
async function loadlist(){

  await ipcRenderer.invoke('searchlookup', arg).then( result=>{
    console.log('result', result)
    arg = result.recordset.reverse()
    console.log('arg',arg)

    for (const entry of arg) {
      let row = table.insertRow()
      row.className = 'singleselect'
      hiddencell = row.insertCell(0)
      hiddencell.textContent = JSON.stringify(entry)
      $(hiddencell).hide()
      row.insertCell(1).textContent = entry.Status
      row.insertCell(2).textContent = entry.Modify_Type + "00" +entry.Formid
      row.insertCell(3).textContent = entry.Data_NO
    
      row.insertCell(4).textContent = entry.Description
      row.insertCell(5).textContent = entry.emp_fname + " "+ entry.emp_lname
    
      row.insertCell(6).textContent = new Date(entry.Submit_Date).toUTCString().substring(4,16)
    }
    makeRecaplistSelectable()
  
  })
 }


 swapPage('List', goto_list, 'navy')
 
})

function ResetAll(){

  document.getElementById("fromdate").value=""
  document.getElementById("todate").value=""
  
  
}


let loopcontinue = false
let firstloop = true
async function loopMessage(){
  return setTimeout( async function () {
    if (loopcontinue){
      createAlert('info', 'Working...', 1000)
      firstloop = false
      loopMessage()
    }
  }, firstloop ? 2200 : 1200)
}

// Export to Excel
document.getElementById("exportlist_excel").addEventListener('click', async()=>{
  event.preventDefault()
  
  loopcontinue = true
  firstloop = true
  loopMessage()
  console.log('starting')
  if (document.getElementById("fromdate").checkValidity() && document.getElementById("todate")){
    arg= {
      fromdate:document.getElementById("fromdate").value,
      todate:document.getElementById("todate").value

    }
    
  }
  await ipcRenderer.invoke('searchlookup',arg).then(async listvals=>{
    console.log('listvals',listvals)
    arg = listvals.recordset.reverse()
    console.log('done')
    
 
    loopcontinue = false
   

    // FILTER VALUES
    // const jsonData = JSON.parse(JSON.stringify(listvals));
    // console.log("jsonData", jsonData);


    const keys = Object.keys(arg[0])
    console.log('keys', keys)

    for (let i = 0; i < arg.length; i++) {
      arg[i].formid =  arg[i].Modify_Type +'00' +arg[i].Formid;
      arg[i].purchase_Date = String(new Date(arg[i].purchase_Date).toUTCString().substring(5, 16))
      if (arg[i].Inservice_Date != null){
        arg[i].Inservice_Date=String(new Date(arg[i].Inservice_Date).toUTCString().substring(5, 16))  
      }   
      arg[i].Submit_Date=String(new Date(arg[i].Submit_Date).toUTCString().substring(5, 16))
      delete(arg[i].Equipmentformid);
      delete(arg[i].Linked_File)
      delete(arg[i].Formid)
    }

    
    

    

    // SAVE FILE
    await ipcRenderer.invoke('csv-save-dialog', arg).then(results=>{
      if (results == -1) {
        createAlert('info', 'Export File Cancelled')
      } else {
        createAlert('success', 'CSV Exported!')
      }
    }).catch(err=>{
      createAlert('error', 'File Save Error: '+err.toString())
    })
  }).catch(error=>{
    createAlert('warning', 'Export Excel Error ' +error.toString())
  })
})




  
  
  
  
  
   




function base64ToUint8Array(base64) {
  var raw = atob(base64);
  var uint8Array = new Uint8Array(raw.length);
  for (var i = 0; i < raw.length; i++) {
    uint8Array[i] = raw.charCodeAt(i);
  }
  return uint8Array;
}

const viewerEle = document.getElementById('viewer');

let startx = 0
let starty = 0
document.getElementById('receiptModal').addEventListener('dragstart', event=>{
  console.log('receipt dragged!', event)
  startx = event.offsetX
  starty = event.offsetY
})


document.getElementById('viewer').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)

    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})
document.getElementById('near_close').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})

documentlist = document.getElementById('documentlist')
documentlist_mirror = document.getElementById('documentlist_mirror')
uploadfilelist=[]

const upload_event_docs = document.getElementById('documentation_fileselect_popup')
upload_event_docs.addEventListener('click', async (event)=>{
  event.preventDefault()
  if (document.getElementById('documentation_type').checkValidity()){
    let path = await ipcRenderer.invoke('open-file-dialog-pdf')

    if (path.canceled){
      console.log('selection canceled')
    } else {

      arg = {
        path:String(path.filePaths[0]),
        filesys_linked_table:'modifyequipment',
        filesys_name:document.getElementById('documentation_type').value +'.pdf'
      }
      console.log('arg', arg)

      createAlert('info', 'Uploading File')
      await ipcRenderer.invoke('save-file-to-filesys', arg).then(async result =>{
        createAlert('success', 'File Uploaded!')
        console.log('saved file to', result.recordset[0].filesys_id)
        uploadfilelist.push(result.recordset[0].filesys_id)
        loadDocumentsByIdList(uploadfilelist)
      }).catch(err =>{
        createAlert('error', 'Upload Failed: '+err.toString())
      })
    }
  } else {
    document.getElementById('documentation_type').reportValidity()
  }
})



let documentationModal = document.getElementById("documentationModal");
document.getElementsByClassName("close")[1].onclick = function() {
  $(documentationModal).hide()
}
let receiptModal = document.getElementById('receiptModal')
document.getElementsByClassName("close")[0].onclick = function() {
  $(receiptModal).hide()
}

window.onclick = function(event) {
  if (event.target == receiptModal) {
    $(receiptModal).hide()
  } else if (event.target == documentationModal) {
    $(documentationModal).hide()
  }
}






document.getElementById('pdf_selected').addEventListener('click', async event=>{
  event.preventDefault()
  let target = selection.value

  if (!target || target == '') {
    createAlert('no selection to load')
  } else {
    console.log('loading', target)
    // await requestEntry(target)
    await viewTravelReport(2, target)
  }
})

async function viewTravelReport(mode=0, id, indata=null){
  console.log('REQUEST REPORT !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  arg = {
    target_name: 'Equipmentformid',
    target_val: selection.value
  }

  try{
    if (!indata){
      console.log('load data')
      result = await ipcRenderer.invoke('loadequipmentlist', arg)
      arg = result.recordset[0]
    } else {
      console.log('imported data')
      arg = indata
    }

    if (arg && id){
      console.log('REPORT DATA LOADED', arg)
      try{
        receiptModal.style.display = "block";
        previframe.forEach(frame=>{
          try{
            viewerEle.removeChild(frame)
          } catch{
            console.log('malformed frame', frame, 'could not be removed')
          }
        })
        previframe = []
        windowlist.forEach(win=>{
          win.close()
        })
        windowlist = []

        viewerEle.innerHTML = '';
      } catch (err){
        createAlert('PDF ERROR'+err.toString())
      }

      if (mode == 1){
        try {
          // FIXME: FIXED: JSON PARSE ERROR: this was incorrectly linking to 'arg.travel_linked_filesys_ids', which is the name of the attribute in the 'travel request' app
          file_list = JSON.parse(arg.Linked_File)
          // FIXME: FIXED: made it prettier if there are no files to load
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
              
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded ' +String(err))
             
            })
          } else {
            console.log('No reciepts to display!')
           
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
         
        }
      } else if (mode == 2){
        try {
          targeturl = await makeEquipmentPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
        try {
          file_list = JSON.parse(arg.Linked_File)
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
              console.log(arg)
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded')
              console.log(arg)
            })
          
          } else {
            console.log('No reciepts to display!')
          
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
          
        }
      } else {
        try {
          targeturl = await makeEquipmentPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
      }
    } else {
      if (id && id != ''){
        createAlert('warning', "Unable to load report for id " +String(id) +"; Something must have gone wrong. Refreshing options list.")
        requestList()
      } else {
        createAlert('warning', "Report ID to load not specified. Report Load Cancelled")
      }
    }
  } catch (err) {
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
  }
  return arg
}



async function loadAllFileContents(file_list){
  filesysarg = {
    filesys_linked_table:'modifyequipment',
    filesys_id_list:file_list
  }

  console.log('loading list', file_list)
  return await ipcRenderer.invoke('loadAllFileContents', filesysarg)
}



function requestList(){

  
  ipcRenderer.invoke('loadequipmentlist',arg).then(result => {
    console.log ("result",result)
    
    makeRecaplistSelectable()
  })

}



goto_search.click()
