const {ipcRenderer} = require('electron')

const Supervisors = await ipcRenderer.invoke('getSupervisors')
const OrgKeys = await ipcRenderer.invoke('getOrgKeys')

selectSupervisor = document.getElementById("supervisor")
console.log('supervisors:', Supervisors)
for (let i = 0; i < Supervisors.length; i++) {
  let name = Supervisors[i].emp_lname +', '+ Supervisors[i].emp_fname
  let id = Supervisors[i].emp_id
  option = document.createElement('option')
  option.value = id
  option.text = name
  selectSupervisor.add(option)
}

selectOrgKey = document.getElementById('orgkey')
console.log('orgkeys:', OrgKeys)
for (let i = 0; i < OrgKeys.length; i++) {
  if (OrgKeys[i].org_enabled == 1){
    let name = OrgKeys[i].org_key +': '+ OrgKeys[i].org_desc
    let id = OrgKeys[i].org_key
    option = document.createElement('option')
    option.value = id
    option.text = name
    selectOrgKey.add(option)
  }
}

const lookupForm = document.querySelector("#modifyForm");
lookupForm.addEventListener("submit", function(event){
  event.preventDefault() // stop the form from submitting
  vals = {
    'emp_id' : document.getElementById("emp_id").value,
    'emp_lname' : document.getElementById("e_lname").value,
    'emp_fname' : document.getElementById("e_fname").value,
    'emp_email' : document.getElementById("e_email").value,
    'emp_supervisor_id' : selectSupervisor.value,
    'org_key' : selectOrgKey.value
  }
  ipcRenderer.invoke('submitUserModifyForm', vals).then(result =>{
    if (result) {
      console.log('modifcation succeeded')
      window.close()
    } else {
      console.log('user change failed')
    }
  })
})

let values = window.location.search.split('?')
console.log('vals', values)
let emp_id = values[1].split("=")[1]
let org_key = ''
if (values.length > 2){
  org_key = values[2].split("=")[1]
}

console.log(emp_id, org_key)
ipcRenderer.invoke('submitUserLookupForm', {emp_id: emp_id}).then(arg =>{
  console.log(arg)
  document.getElementById("modal_modify_emp_id").value = emp_id
  document.getElementById("modal_modify_orgkey").value = org_key

  if (arg) {
    document.getElementById("modal_modify_e_lname").value = arg.emp_lname
    document.getElementById("modal_modify_e_fname").value = arg.emp_fname
    document.getElementById("modal_modify_e_email").value = arg.emp_email
    document.getElementById("modal_modify_supervisor").value = arg.emp_supervisor_id
    if (org_key != null && org_key != ''){
      document.getElementById("modal_modify_orgkey").value = org_key
    } else {
      document.getElementById("modal_modify_orgkey").value = arg.emp_org_key
    }
    startvals = arg
  }
});

document.getElementById("cancel").addEventListener('click', ()=>{
  window.close()
})
