const {ipcRenderer, remote} = require('electron')
const Inputmask = require('inputmask');
const autosize = require('autosize')
const {createObjectURL} = require('blob-util')
const $ = require('jquery')

const {createAlert} = require("../utilities/alert_box")
const {makePDF} = require('../utilities/reportgen')
const {makeSortable} = require('../utilities/sortable')

makeSortable()

// FIXME: remember that this is a partial and hacky solution to preventing the enter key from doing things
// it may or may not be a good decision
// FIXME: decide if it is permanent
$("input").bind("keydown", function(event) {
  if (event.which === 13) {
      event.stopPropagation();
      event.preventDefault();
      $(this).nextAll("input").eq(0).focus();
  }
});

const subitem_org_key = document.getElementById('subitem_org_key')
const subitem_obj_code = document.getElementById('subitem_obj_code')
const pcardmodal_pcard_default_org_key = document.getElementById('pcardmodal_pcard_default_org_key')
const pcardmodal_pcard_default_obj_code = document.getElementById('pcardmodal_pcard_default_obj_code')

const txn_cartegraph_amt = document.getElementById('txn_cartegraph_amt')
const txn_use_tax_rate = document.getElementById('txn_use_tax_rate')
const txn_use_tax_amt = document.getElementById('txn_use_tax_amt')

const prev_filterlist = {}

document.getElementById("quit_app").addEventListener("click", ()=>{
  ipcRenderer.invoke('quit_app')
});

autosize(document.getElementById('link_to_travel'))
autosize(document.getElementById('link_to_task'))

prev_filterlist.value = []

OrgKeys = ipcRenderer.invoke('getOrgKeys').then(result =>{
  OrgKeys = result
  // console.log('subitem_org_key:', OrgKeys)
  for (let i = 0; i < OrgKeys.length; i++) {
    if (OrgKeys[i].org_enabled == 1){
      let name = OrgKeys[i].org_key +': '+ OrgKeys[i].org_desc
      let id = OrgKeys[i].org_key
      option = document.createElement('option')
      option.value = id
      option.text = name
      subitem_org_key.add(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      pcardmodal_pcard_default_org_key.add(option)
    }
  }
})

ObjCodes = ipcRenderer.invoke('getObjCodes').then(result =>{
  ObjCodes = result
  // console.log('subitem_obj_code:', ObjCodes)
  for (let i = 0; i < ObjCodes.length; i++) {
    if (ObjCodes[i].obj_enabled == 1){
      let name = ObjCodes[i].obj_code +': '+ ObjCodes[i].obj_desc
      let id = ObjCodes[i].obj_code
      option = document.createElement('option')
      option.value = id
      option.text = name
      subitem_obj_code.add(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      pcardmodal_pcard_default_obj_code.add(option)
    }
  }
})

// PCARD CONFIRM STAGES: ['New Txn', 'Submitted', 'Approved', 'Processed', 'Reconciled']

// PCARD ADDITIONAL STAGES: [Use Tax (Yes, No, Done), Cartegraph (Yes, No, Done), Items Status (Pending, received)]

const stagelist = ['New Txn', 'Submitted', 'Approved', 'Processed', 'Reconciled']
const headerlist = [
  'Submit New PCARD Recap',
  'Manager Approve PCARD Recap',
  'Finance Process PCARD Recap',
  'Finance Reconcile PCARD Recap',
  'View Completed PCARD Recaps'
]

const addlmodelist = ['View Completed PCARD Recaps', 'Use Tax Entry PCARD Recap', 'Cartegraph Entry PCARD Recap', 'Search All PCARD Recaps']

const selfurl = window.location

// dynamic html stuff:
let values = window.location.search.split('?')
console.log('vals', values)
let stagenum = 0
let addlstagenum = null
if (values.length >= 1 && values[1] && parseInt(values[1])){
  stagenum = parseInt(values[1])
}

if (stagenum == 4){ addlstagenum = 0 }

if (values.length >=2 && values[2] && parseInt(values[2])){
  addlstagenum = parseInt(values[2])
}
let subquery = null
if (values.length >= 3 && values[3] && JSON.parse(decodeURIComponent(values[3]))){
  subquery = JSON.parse(decodeURIComponent(values[3]))
}

if (addlstagenum != 3){
  $(document.getElementById('goto_search')).hide()
  if (stagenum != 0){
    $(document.getElementById('display_anything')).hide()
  }
} else if (subquery != null && subquery.filter_name.length > 0){
  $(document.getElementById('goto_search')).hide()
  $(document.getElementById('display_anything')).hide()
} else{
  $(document.getElementById('display_anything')).hide()
}

const filter_value = document.getElementById('filter_value')
const filter_type = document.getElementById('filter_type')

filter_type.addEventListener('change', event=>{
  filter_type_val = event.target.value
  console.log('filter changed to', filter_type_val)

  filter_value.value = ''

  if (filter_type_val == ''){
    filter_value.type = 'text'
    filter_value.pattern = null //pattern null always fails
    filter_value.removeAttribute('list')
    filter_value.title = 'Select a Filter Type'
  } else if (filter_type_val == 'txn_card_num'){
    filter_value.type = 'text'
    filter_value.pattern = '[0-9]{4}'
    filter_value.removeAttribute('list')
    filter_value.title = 'Last 4 digits of Cardnum'
  } else if (filter_type_val == 'txn_emp_full_name'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Employee Name (last name only is best)'
  } else if (filter_type_val == 'txn_emp_id'){
    filter_value.type = 'text'
    filter_value.pattern = '[0-9]{6}'
    filter_value.removeAttribute('list')
    filter_value.title = '6 Digit Employee ID'
  } else if (filter_type_val == 'txn_task_id'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Task #'
  } else if (filter_type_val == 'txn_travel_id'){
    filter_value.type = 'number'
    filter_value.min = '0'
    filter_value.step = '1'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Travel # (Positive integer)'
  } else if (filter_type_val == 'txn_vendor_name'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Vendor Name (without punctuation)'
  } else if (filter_type_val == 'txn_post_date'){
    filter_value.type = 'date'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Transaction Post Date'
  } else if (filter_type_val == 'txn_purchase_date'){
    filter_value.type = 'date'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('list')
    filter_value.title = 'Transaction Purchase Date'
  } else if (filter_type_val == 'txn_amt'){
    filter_value.type = 'number'
    filter_value.removeAttribute('pattern')
    filter_value.removeAttribute('min')
    filter_value.removeAttribute('list')
    filter_value.step = '0.01'
    filter_value.title = 'Transaction Posted $ Amt'
  } else if (filter_type_val == 'txn_bill_cycle'){
    filter_value.type = 'month'
    filter_value.removeAttribute('list')
    filter_value.title = 'Bill Cycle Month/Year'
  } else if (filter_type_val == 'txn_fiscal_year'){
    filter_value.type = 'text'
    filter_value.pattern = '[0-9]{4}'
    filter_value.removeAttribute('list')
    filter_value.title = '4 digit year e.g. 2020'
  } else if (filter_type_val == 'txn_purchase_purpose'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.setAttribute('list', 'datalist_purchase_purpose_options')
    filter_value.title = 'Purchase Type'
  } else if (filter_type_val == 'txn_purchase_status'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.setAttribute('list', 'datalist_purchase_status_options')
    filter_value.title = 'Purchase Status'
  } else if (filter_type_val == 'txn_cartegraph_status'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.setAttribute('list', 'datalist_cartegraph_status_options')
    filter_value.title = 'Cartegraph Status'
  } else if (filter_type_val == 'txn_use_tax_status'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.setAttribute('list', 'datalist_usetax_status_options')
    filter_value.title = 'Use Tax Status'
  } else if (filter_type_val == 'txn_status'){
    filter_value.type = 'text'
    filter_value.removeAttribute('pattern')
    filter_value.setAttribute('list', 'datalist_recap_status_options')
    filter_value.title = 'RECAP Status'
  }//else if (filter_type_val == 'objectcode'){
  //   filter_value.type = 'text'
  //   filter_value.pattern = '[0-9]{5}'
  //   filter_value.removeAttribute('list')
  //   filter_value.title = '5 Digit object code'
  // }else if (filter_type_val == 'orgkey'){
  //   filter_value.type = 'text'
  //   filter_value.pattern = '[0-9]{8}'
  //   filter_value.removeAttribute('list')
  //   filter_value.title = 'org key'
  // }
})

document.getElementById('add_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('add filter')
  if (filter_type.checkValidity()){
    if (filter_value.checkValidity()){
      addToFilterList(filter_type.value, filter_value.value)
    } else filter_value.reportValidity()
  } else filter_type.reportValidity()
})

const filteritemlist = document.getElementById('filteritemlist')

function addToFilterList(type, value){
  console.log('add to list', type, value)
  arg = {
    target:type,
    value:value
  }
  let row = filteritemlist.insertRow()
  row.className = 'singleselect'
  hiddencell = row.insertCell(0)
  hiddencell.textContent = JSON.stringify(arg)
  $(hiddencell).hide()

  cell = row.insertCell(1)
  cell.textContent = type

  cell = row.insertCell(2)
  cell.textContent = value

  makeSubitemlistSelectable()

  filter_value.value = ''
  filter_type.value = ''
}

document.getElementById('modify_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('modify filter', subitemselection.value)

  if (subitemselection.value && subitemselection.value.value != ''){
    console.log('selection set!')
    document.querySelectorAll(".selected").forEach(selected_row=>{
      selected_row.remove()
    })
    filter_type.value = subitemselection.value.target
    filter_value.value = subitemselection.value.value
    subitemselection.value = null
  } else {
    createAlert('warning', 'Nothing selected to Delete')
  }
})

document.getElementById('remove_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('remove filter', subitemselection.value)

  if (subitemselection.value && subitemselection.value.value != ''){
    console.log('selection set!')
    document.querySelectorAll(".selected").forEach(selected_row=>{
      selected_row.remove()
    })
    filter_type.value = ''
    filter_value.value = ''
    subitemselection.value = null
  } else {
    createAlert('warning', 'Nothing selected to Delete')
  }
})

document.getElementById('reset_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('reset_filter')
  document.getElementById('filteritemlist').querySelectorAll("tr").forEach(row=>{
    row.remove()
  })
  subitemselection.value = null
  filter_pcard_cardnum.blur()
  document.getElementById('filter_type').value = ''

  let filter_value = document.getElementById('filter_value')
  filter_value.value = ''
  filter_value.type = 'text'
  filter_value.pattern = null //pattern null always fails
  filter_value.removeAttribute('list')
  filter_value.title = 'Select a Filter Type'
})

document.getElementById('apply_filter_major').addEventListener('click', ()=>{
  event.preventDefault()

  console.log('add filter if one is pending')
  if (filter_type.checkValidity()){
    if (filter_value.checkValidity()){
      addToFilterList(filter_type.value, filter_value.value)
    }
  }

  console.log('apply_filter_major')
  args = {}
  names = []
  vals = []

  // TODO: custom logic for certain searches
  // e.g. if they are searching a travel#, task#, search for a 'contains' not an 'equals'
  // TODO: ?? make an option for an 'OR' search instead of only 'AND' searches ??
  // TODO: More Concise/Convenient Date Picker Mode for Searches

  prev_filterlist.value = []
  document.getElementById('filteritemlist').querySelectorAll("tr").forEach(row=>{
    arg = JSON.parse(row.cells[0].textContent)
    prev_filterlist.value.push(arg)
    console.log('filterable', arg)
    names.push(arg.target)
    vals.push(arg.value)
  })


  args.filter_name = names
  args.filter_val = vals
  console.log('all filters', args)

  subitemselection.value = null
  requestList(args)

  swapPage('List', goto_list, 'navy')
  goto_list.removeAttribute('disabled')
})

// Note on txn_prev_max & txn_max_stage
// if a recap is denied by manager, it will be viewed again by manager on resubmit
// if a recap is denied by finance review, it will jump directly to user, and will jump directly back to finance review on resubmit
// if a recap is denied by finance reconcile, it will go back to finance review
// txn_prev_max & txn_max_stage are used to calculate this (by using the indices within stagelist). if the stagelist is changed, all elements using those indices must be updated to retain proper functionality, including this special resubmit routing process

let txn_prev_max = 0

console.log('stagenum', stagenum, 'mode', stagelist[stagenum])
console.log('addlstagenum', addlstagenum)

document.getElementById('pageheader').textContent = headerlist[stagenum]

if(addlstagenum != null){
  document.getElementById('pageheader').textContent = addlmodelist[addlstagenum]

  $(document.getElementById('add_subitem_section')).hide()
  //$( document.getElementById('log_note')).hide()
  if (addlstagenum == 0 || addlstagenum == 3){
    document.getElementById('log_note').setAttribute('disabled', 'disabled')
    document.getElementById('log_note').placeholder='Cannot Add Comments from View Mode'
    document.getElementById('txn_purchase_desc').placeholder='Description not yet Set; Recap not yet Submitted'
    document.getElementById('txn_user_signature').placeholder='Not Yet Signed'
  }
  $(document.getElementById('itemlist_buttoncol')).hide()
}

$(document.getElementById('usermode')).hide()
$(document.getElementById('reviewmode')).hide()
$(document.getElementById('financeframe')).hide()
// $(document.getElementById('financeframe2')).hide()
$(document.getElementById('utmode')).hide()
$(document.getElementById('cartegraphmode')).hide()
$(document.getElementById('viewmode')).hide()

if (stagenum == 0){
  console.log('user mode')
  $(document.getElementById('usermode')).show()
  $(document.getElementById('listbutton_singlemode')).show()
  $(document.getElementById('listbutton_searchmode')).hide()

  document.getElementById('upload_documentation_button').textContent = (String(document.getElementById('upload_documentation_button').textContent).replace('List of', 'Upload'))
  document.getElementById('upload_documentation_button').removeAttribute('disabled')

  document.getElementById('txn_purchase_desc').setAttribute('required', 'required')

  document.getElementById('txn_purchase_desc').removeAttribute('disabled')
  document.getElementById('for_recap_travel').removeAttribute('disabled')
  document.getElementById('for_recap_inventory').removeAttribute('disabled')
  document.getElementById('for_recap_task').removeAttribute('disabled')
  document.getElementById('for_recap_other').removeAttribute('disabled')
  document.getElementById('status_recap_pending').removeAttribute('disabled')
  document.getElementById('status_recap_received').removeAttribute('disabled')
  document.getElementById('link_to_travel').removeAttribute('disabled')
  document.getElementById('link_to_task').removeAttribute('disabled')
} else {
  if (stagenum <= 3){
    console.log('review mode')
    $(document.getElementById('reviewmode')).show()
    $(document.getElementById('listbutton_singlemode')).show()
    $(document.getElementById('listbutton_searchmode')).hide()
  } else {
    if (addlstagenum == null || addlstagenum == 0){
      console.log('view completed mode')
      $(document.getElementById('viewmode')).show()
      $(document.getElementById('listbutton_singlemode')).hide()
      $(document.getElementById('listbutton_searchmode')).show()
    } else if (addlstagenum == 1){
      console.log('use tax mode')
      $(document.getElementById('utmode')).show()
      $(document.getElementById('listbutton_singlemode')).show()
      $(document.getElementById('listbutton_searchmode')).hide()
    } else if (addlstagenum == 2){
      console.log('cartegraph mode')
      $(document.getElementById('cartegraphmode')).show()
      $(document.getElementById('listbutton_singlemode')).show()
      $(document.getElementById('listbutton_searchmode')).hide()
    } else if (addlstagenum == 3) {
      console.log('search/view mode')
      $(document.getElementById('viewmode')).show()
      $(document.getElementById('listbutton_singlemode')).hide()
      $(document.getElementById('listbutton_searchmode')).show()
    }
  }

  if (stagenum >= 2){
    console.log('finance mode')
    $(document.getElementById('financeframe')).show()
    //$( document.getElementById('financeframe2')).show()

    if (stagenum <=3){
      document.getElementById('usetax_yes').setAttribute('required', 'required')
      document.getElementById('usetax_no').setAttribute('required', 'required')
      document.getElementById('cartegraph_yes').setAttribute('required', 'required')
      document.getElementById('cartegraph_no').setAttribute('required', 'required')
    } else {
      document.getElementById('itemlist_add').style.background = 'gainsboro';
      document.getElementById('itemlist_add').style.borderColor = 'silver';
      document.getElementById('itemlist_add').setAttribute('disabled', 'disabled')

      document.getElementById('itemlist_modify').style.background = 'gainsboro';
      document.getElementById('itemlist_modify').style.borderColor = 'silver';
      document.getElementById('itemlist_modify').setAttribute('disabled', 'disabled')

      document.getElementById('itemlist_remove').style.background = 'gainsboro';
      document.getElementById('itemlist_remove').style.borderColor = 'silver';
      document.getElementById('itemlist_remove').setAttribute('disabled', 'disabled')

      document.getElementById('usetax_yes').removeAttribute('required')
      document.getElementById('usetax_no').removeAttribute('required')
      document.getElementById('cartegraph_yes').removeAttribute('required')
      document.getElementById('cartegraph_no').removeAttribute('required')

      document.getElementById('usetax_yes').setAttribute('disabled', 'disabled')
      document.getElementById('usetax_no').setAttribute('disabled', 'disabled')
      document.getElementById('cartegraph_yes').setAttribute('disabled', 'disabled')
      document.getElementById('cartegraph_no').setAttribute('disabled', 'disabled')

      txn_use_tax_rate.removeAttribute('required')
      txn_use_tax_amt.removeAttribute('required')
      txn_cartegraph_amt.removeAttribute('required')

      txn_use_tax_rate.setAttribute('disabled', 'disabled')
      txn_use_tax_amt.setAttribute('disabled', 'disabled')
      txn_cartegraph_amt.setAttribute('disabled', 'disabled')
    }
  } else {
    $(document.getElementById('financeframe')).hide()
    //$( document.getElementById('financeframe2')).hide()
    document.getElementById('usetax_yes').removeAttribute('required')
    document.getElementById('usetax_no').removeAttribute('required')
    document.getElementById('cartegraph_yes').removeAttribute('required')
    document.getElementById('cartegraph_no').removeAttribute('required')
  }

  document.getElementById('upload_documentation_button').style.background = 'gainsboro';
  document.getElementById('upload_documentation_button').style.borderColor = 'silver';
  document.getElementById('upload_documentation_button').setAttribute('disabled', 'disabled')

  document.getElementById('txn_purchase_desc').removeAttribute('required')

  document.getElementById('txn_purchase_desc').setAttribute('disabled', 'disabled')
  document.getElementById('for_recap_travel').setAttribute('disabled', 'disabled')
  document.getElementById('for_recap_inventory').setAttribute('disabled', 'disabled')
  document.getElementById('for_recap_task').setAttribute('disabled', 'disabled')
  document.getElementById('for_recap_other').setAttribute('disabled', 'disabled')
  document.getElementById('status_recap_pending').setAttribute('disabled', 'disabled')
  document.getElementById('status_recap_received').setAttribute('disabled', 'disabled')
  document.getElementById('link_to_travel').setAttribute('disabled', 'disabled')
  document.getElementById('link_to_task').setAttribute('disabled', 'disabled')
}

const PAGE_TARGETVAL = stagelist[stagenum]

Permissions = ipcRenderer.invoke('getPermissions').then(result =>{
  Permissions = result

  // FIXME: if any new apps are added, update this conditional (or remove it)
  if (!Permissions.emp_budget_permission && !Permissions.emp_travel_permission && !Permissions.emp_admin_permission && Permissions.emp_position == 'Employee' && Permissions.emp_finance_permission == 0 && Permissions.emp_cartegraph_permission == 0 && Permissions.emp_hr_permission == 0){
    $(document.getElementById('goto-home')).hide()
  }

  if (!Permissions.emp_admin_permission){
    $(document.getElementById('can_export')).hide()
  }
})

Uname = ipcRenderer.invoke('getUname').then(result =>{
  Uname = result
})

const selection = {}

function makeRecaplistSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i] && trs[i].className && trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = JSON.parse(this.cells[0].textContent).txn_id

        console.log('selection set', selection.value)
        getExtraUserData(JSON.parse(this.cells[0].textContent))
      })
    }
  }
}

const subitemselection = {}
function makeSubitemlistSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i] && trs[i].className && trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('subitemselection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        subitemselection.value = JSON.parse(this.cells[0].textContent)

        console.log('subitemselection set', subitemselection.value)
      })
    }
  }
}

async function getExtraUserData(arg) {
  if (arg != null){
    console.log('fancy query based on', arg.txn_emp_id)
    document.getElementById('summary_emp_name').value = arg.emp_lname +', ' +arg.emp_fname
    try {
      document.getElementById('summary_pcard_limit').value = parseFloat(arg.pcard_limit).toFixed(2)
    } catch (error) {document.getElementById('summary_pcard_limit').value = 'Unset'
    }
    ipcRenderer.invoke('getExtraUserData', arg.txn_emp_id).then(result =>{
      console.log('result.recordset', result.recordset)
      if (result.recordset && result.recordset[0]){
        arg2 = result.recordset[0]
        // console.log('arg2', arg2)
        document.getElementById('summary_billcycle_spent').value = parseFloat(0 + arg2.txn_spent).toFixed(2)
        if (arg2.txn_spent){
          document.getElementById('summary_billcycle_remaining').value = parseFloat(parseFloat(arg.pcard_limit) - parseFloat(arg2.txn_spent)).toFixed(2)
        } else {
          document.getElementById('summary_billcycle_remaining').value = parseFloat(arg.pcard_limit).toFixed(2)
        }
      } else {
        console.log('lookup failed')
        document.getElementById('summary_billcycle_spent').value = parseFloat(0).toFixed(2)
      }
    }).catch(err=>{
      console.log('getExtraUserData error', err.name)
      console.log(err)
    })
  } else {
    createAlert('warning', 'No Results Found for this Search Filter')
  }
}

// FIXME: Determine the future of Inputmask
// pros: custom formatting of input boxes looks nice
// note: works well in some places, less well in others
// cons: occasionally makes getting/setting, selecting/deselecting inputboxes glitchy

// note: this one does not work well
// Inputmask({ mask: "9999", greedy: false, autoUnmask: true}).mask(document.getElementById('filter_pcard_cardnum'))

// note: this one does work well
// note2: remember to parseFloat(val).toFixed(2) the result before returning it
document.querySelectorAll(".decimal").forEach(input =>{
  Inputmask({'alias': 'decimal', 'autoGroup': true, 'digits': 2, 'digitsOptional': false, 'placeholder': '0.00', rightAlign : false, clearMaskOnLostFocus: !1 }).mask(input)
})

//  __  __    ____    _____               _
// |  \/  |  / __ \  |  __ \      /\     | |
// | \  / | | |  | | | |  | |    /  \    | |
// | |\/| | | |  | | | |  | |   / /\ \   | |
// | |  | | | |__| | | |__| |  / ____ \  | |____
// |_|  |_|  \____/  |_____/  /_/    \_\ |______|

// documentationModal stuff:
// https://www.w3schools.com/howto/howto_css_modals.asp
let denyModal = document.getElementById('denyModal')
document.getElementsByClassName("close")[3].onclick = function() {
  $(denyModal).hide()
}
let pcardModal = document.getElementById('pcardModal')
document.getElementsByClassName("close")[2].onclick = function() {
  $(pcardModal).hide()
}
let documentationModal = document.getElementById("documentationModal");
document.getElementsByClassName("close")[1].onclick = function() {
  $(documentationModal).hide()
}
let receiptModal = document.getElementById('receiptModal')
document.getElementsByClassName("close")[0].onclick = function() {
  $(receiptModal).hide()
}

window.onclick = function(event) {
  if (event.target == receiptModal) {
    $(receiptModal).hide()
  } else if (event.target == documentationModal) {
    $(documentationModal).hide()
  } else if (event.target == pcardModal) {
    $(pcardModal).hide()
  } else if (event.target == denyModal) {
    $(denyModal).hide()
  }
}

async function SubitemAction(mode = ''){
  console.log('mode', mode)

  if (mode == 'modify'){
    console.log('modify subitemselection', subitemselection)
    if (subitemselection && subitemselection.value && subitemselection.value.subitem_id && subitemselection.value.subitem_id != null && subitemselection.value.subitem_id != '') {

      console.log('delete subitemselection', subitemselection.value)
      ipcRenderer.invoke('delete-pcard-recap-subitem', subitemselection.value).then(()=>{
        refreshSubitemList(document.getElementById('txn_id').value)

        console.log('subitemselection', subitemselection.value)

        document.getElementById('subitem_id').value = subitemselection.value.subitem_id
        document.getElementById('subitem_total').value = subitemselection.value.subitem_total
        document.getElementById('subitem_org_key').value = subitemselection.value.subitem_org_key
        document.getElementById('subitem_obj_code').value = subitemselection.value.subitem_obj_code

        subitemselection.value = null
      }).catch(err=>{
        createAlert('warning', 'Subitem could not be deleted')
        console.log(err)
        refreshSubitemList(document.getElementById('txn_id').value)

        console.log('subitemselection', subitemselection.value)

        document.getElementById('subitem_id').value = subitemselection.value.subitem_id
        document.getElementById('subitem_total').value = subitemselection.value.subitem_total
        document.getElementById('subitem_org_key').value = subitemselection.value.subitem_org_key
        document.getElementById('subitem_obj_code').value = subitemselection.value.subitem_obj_code

        subitemselection.value = null
      })

    } else {
      createAlert('warning', 'Please select an item in the list to ' +String(mode))
    }
  } else if (mode == 'remove') {
    if (subitemselection && subitemselection.value && subitemselection.value.subitem_id && subitemselection.value.subitem_id != null && subitemselection.value.subitem_id != '') {
      console.log('delete subitemselection', subitemselection.value)
      ipcRenderer.invoke('delete-pcard-recap-subitem', subitemselection.value).then(async ()=>{
        remain = await refreshSubitemList(document.getElementById('txn_id').value)
        document.getElementById('subitem_total').value = remain
        document.getElementById('subitem_org_key').value = ''
        document.getElementById('subitem_obj_code').value = ''
        subitemselection.value = null
      }).catch(async err=>{
        createAlert('warning', 'Subitem could not be deleted')
        console.log(err)
        remain = await refreshSubitemList(document.getElementById('txn_id').value)
        document.getElementById('subitem_total').value = remain
        document.getElementById('subitem_org_key').value = ''
        document.getElementById('subitem_obj_code').value = ''
        subitemselection.value = null
      })
    } else {
      createAlert('warning', 'Please select an item in the list to ' +String(mode))
    }
  } else if (mode == 'add') {
    event.preventDefault()
    console.log('changes to be applied')

    arg = {
      subitem_id:document.getElementById('subitem_id').value,
      subitem_name:'item',
      subitem_total:parseFloat(document.getElementById('subitem_total').value).toFixed(2),
      subitem_org_key:document.getElementById('subitem_org_key').value,
      subitem_obj_code:document.getElementById('subitem_obj_code').value,
      subitem_txn_id:document.getElementById('txn_id').value
    }

    console.log('arg', arg)

    if (arg.subitem_total != 0.00 && arg.subitem_total != 'NaN' && arg.subitem_org_key != '' && arg.subitem_obj_code != '') {
      console.log('submit subitem query')
      ipcRenderer.invoke('update-pcard-recap-subitem', arg).then(async result =>{
        console.log('done', result)
        remain = await refreshSubitemList(arg.subitem_txn_id)
        document.getElementById('subitem_total').value = remain
        document.getElementById('subitem_org_key').value = ''
        document.getElementById('subitem_obj_code').value = ''
      }).catch(err =>{
        createAlert('warning', 'Subitem Query Failed')
        console.log(err)
        refreshSubitemList(arg.subitem_txn_id)
      })
    } else {
      if (arg.subitem_total == 0.00 || arg.subitem_total == 'NaN'){
        createAlert('danger', 'Cannot add Subitem with $ Amt of 0.00')
        document.getElementById('subitem_total').focus()
      } else if (arg.subitem_org_key == ''){
        createAlert('danger', 'Cannot add Subitem without Org Key Selected')
        document.getElementById('subitem_org_key').focus()
      } else if (arg.subitem_obj_code == ''){
        createAlert('danger', 'Cannot add Subitem without Obj Code Selected')
        document.getElementById('subitem_obj_code').focus()
      }
    }
  }
}

function base64ToUint8Array(base64) {
  var raw = atob(base64);
  var uint8Array = new Uint8Array(raw.length);
  for (var i = 0; i < raw.length; i++) {
    uint8Array[i] = raw.charCodeAt(i);
  }
  return uint8Array;
}

async function dispPcardModal(){
  await Promise.resolve(Permissions)

  console.log('Permissions:', Permissions)
  let arg = {
    emp_id:Permissions.emp_id
  }

  console.log('arg', arg)

  const pcardmodal_cardlist = document.getElementById('pcardmodal_cardlist')
  for (let i = pcardmodal_cardlist.length - 1; i >= 0; i--){
    pcardmodal_cardlist.remove(i);
  }

  ipcRenderer.invoke('load-single-pcard-by-empid', arg).then(result =>{
    document.getElementById('pcardmodal_emp_id').value = Permissions.emp_id
    document.getElementById('pcardmodal_emp_uname').value = result.recordset[0].emp_uname
    document.getElementById('pcardmodal_emp_lname').value = result.recordset[0].emp_lname
    document.getElementById('pcardmodal_emp_fname').value = result.recordset[0].emp_fname
    document.getElementById('pcardmodal_pcard_name_on_card').value = result.recordset[0].pcard_name_on_card
    document.getElementById('pcardmodal_pcard_enabled').value = result.recordset[0].pcard_enabled
    document.getElementById('pcardmodal_pcard_limit').value = result.recordset[0].pcard_limit
    document.getElementById('pcardmodal_pcard_issue_date').valueAsDate = new Date(result.recordset[0].pcard_issue_date)
    document.getElementById('pcardmodal_pcard_default_org_key').value = result.recordset[0].pcard_default_org_key
    document.getElementById('pcardmodal_pcard_expire_date').valueAsDate = new Date(result.recordset[0].pcard_expire_date)
    document.getElementById('pcardmodal_pcard_default_obj_code').value = result.recordset[0].pcard_default_obj_code
    document.getElementById('pcardmodal_pcard_notes').value = result.recordset[0].pcard_notes

    $(pcardModal).show()

    result.recordset.forEach(record=>{
      // console.log('record', record)
      option = document.createElement('option')
      option.value = JSON.stringify(record)
      option.text = record.pcard_first_12+'-'+record.pcard_last_4
      pcardmodal_cardlist.append(option)
    })

  }).catch(err =>{
    createAlert('error', 'Load User PCARD Data Error: No PCARD Found for '+Permissions.emp_uname)
  })
}

document.getElementById('pcardmodal_cardlist').addEventListener('change', async event=>{
  await Promise.resolve(Permissions)
  arg = JSON.parse(event.target.value)
  console.log('selection', arg)

  document.getElementById('pcardmodal_emp_id').value = Permissions.emp_id
  document.getElementById('pcardmodal_emp_uname').value = arg.emp_uname
  document.getElementById('pcardmodal_emp_lname').value = arg.emp_lname
  document.getElementById('pcardmodal_emp_fname').value = arg.emp_fname
  document.getElementById('pcardmodal_pcard_name_on_card').value = arg.pcard_name_on_card
  document.getElementById('pcardmodal_pcard_enabled').value = arg.pcard_enabled
  document.getElementById('pcardmodal_pcard_limit').value = arg.pcard_limit
  document.getElementById('pcardmodal_pcard_issue_date').valueAsDate = new Date(arg.pcard_issue_date)
  document.getElementById('pcardmodal_pcard_default_org_key').value = arg.pcard_default_org_key
  document.getElementById('pcardmodal_pcard_expire_date').valueAsDate = new Date(arg.pcard_expire_date)
  document.getElementById('pcardmodal_pcard_default_obj_code').value = arg.pcard_default_obj_code
  document.getElementById('pcardmodal_pcard_notes').value = arg.pcard_notes
})

let previframe = []
let windowlist = []
const viewerEle = document.getElementById('viewer');

async function dispReceiptModal(file_id){
  previframe.forEach(frame=>{
    try{
      viewerEle.removeChild(frame)
    } catch{
      console.log('malformed frame', frame, 'could not be removed')
    }
  })
  previframe = []
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';

  createAlert('info', 'Loading File')
  arg = {
    filesys_id:file_id
  }

  await ipcRenderer.invoke('load-file-filesys', arg).then(async result=>{
    Promise.resolve(result)
    loaded_file = result.recordset[0]
    console.log('loaded file', loaded_file)
    $(receiptModal).show();
    viewerEle.innerHTML = '';
    const iframe = document.createElement('iframe')

    // OPENING PDF CODE
    pdfData = base64ToUint8Array(loaded_file.filesys_content);
    targeturl = createObjectURL(new Blob([pdfData], {type: "file"}))

    // SHARED CODE
    let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

    iframe.src = viewerUrl
    viewerEle.appendChild(iframe);
    previframe.push(iframe)
  }).catch(err=>{
    createAlert('error', 'File could not be Loaded: ' +String(err))
  })
}

document.getElementById('upload_documentation_button').addEventListener('click', ()=>{
    event.preventDefault()
    // console.log('upload_documentation_button')
    $(documentationModal).show();
})

document.getElementById('close_documentationModal').addEventListener('click', ()=>{
  event.preventDefault()
  $(documentationModal).hide()
})
document.getElementById('close_pcardModal').addEventListener('click', ()=>{
  event.preventDefault()
  $(pcardModal).hide()
})

documentlist = document.getElementById('documentlist')
documentlist_mirror = document.getElementById('documentlist_mirror')

let numfilesadded = 0
let totalfiles = 0
const upload_event_docs = document.getElementById('documentation_fileselect_popup')
upload_event_docs.addEventListener('click', async (event)=>{
  event.preventDefault()
  if (document.getElementById('documentation_type').checkValidity()){
    let path = await ipcRenderer.invoke('open-file-dialog-pdf')

    if (path.canceled){
      console.log('selection canceled')
    } else {
      arg = {
        path:String(path.filePaths[0]),
        filesys_linked_table:'pcard_recap',
        filesys_linked_id:document.getElementById('txn_id').value,
        filesys_name:document.getElementById('documentation_type').value +'.pdf'
      }
      console.log('arg', arg)

      createAlert('info', 'Uploading File')
      await ipcRenderer.invoke('save-file-to-filesys', arg).then(async result =>{
        console.log('saved file to', result.recordset[0].filesys_id)
        numfilesadded += 1
        createAlert('success', 'File Uploaded!')
        loadDocuments(arg.filesys_linked_id)
      }).catch(err =>{
        createAlert('error', 'Upload Failed: '+err.toString())
      })
    }
  } else {
    document.getElementById('documentation_type').reportValidity()
  }
})

documentlist_mirror.addEventListener('change', event =>{
  console.log('documentlist clicked', documentlist_mirror.value)
  dispReceiptModal(documentlist_mirror.value)
  documentlist_mirror.value = ''
})

documentlist.addEventListener('change', event =>{
  console.log('documentlist clicked', documentlist.value)
  dispReceiptModal(documentlist.value)
  documentlist.value = ''
})

const subitemstable = document.getElementById('subitemlist')
async function refreshSubitemList(subitem_txn_id){
  console.log('request entries for id', subitem_txn_id)

  let trs = document.getElementsByClassName('singleselect')
  for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }

  arg = {
    txn_id:subitem_txn_id
  }

  return ipcRenderer.invoke('load-pcard-recap-subitems', arg).then(result =>{
    let sum = 0
    if (result && result.recordset) {
      arg = result.recordset
      console.log('subitems list', arg)

      for (const entry of arg) {
        let row = subitemstable.insertRow()
        row.className = 'singleselect'
        hiddencell = row.insertCell(0)
        hiddencell.textContent = JSON.stringify(entry)
        $(hiddencell).hide()

        sum += parseFloat(entry.subitem_total)

        row.insertCell(1).textContent = '$' +String(parseFloat(entry.subitem_total).toFixed(2))
        row.insertCell(2).textContent = entry.subitem_org_key
        row.insertCell(3).textContent = entry.subitem_obj_code
      }

      let total = parseFloat(document.getElementById('txn_amt').value).toFixed(2)
      sum = parseFloat(sum).toFixed(2)
      let remain = parseFloat(total-sum).toFixed(2)

      document.getElementById('target_remaining').value = remain

      makeSubitemlistSelectable()
      return remain
    } else {
      console.log("Unable to load list")
      return null
    }
  })
}

// Major Button Logic
document.getElementById('itemlist_add').addEventListener('click', ()=>{
  event.preventDefault()
  SubitemAction('add')
})

document.getElementById('itemlist_modify').addEventListener('click', ()=>{
  event.preventDefault()
  SubitemAction('modify')
})

document.getElementById('itemlist_remove').addEventListener('click', ()=>{
  event.preventDefault()
  SubitemAction('remove')
})

const filter_emp_id = document.getElementById('filter_emp_id')
const filter_pcard_cardnum = document.getElementById('filter_pcard_cardnum')

filter_pcard_cardnum.addEventListener('input', ()=>{
  if (filter_pcard_cardnum.checkValidity()){
    filter_emp_id.value = ''
    console.log('filter by', filter_pcard_cardnum.value)
    requestAutoFilterList()
  } else if (filter_pcard_cardnum.value == '') {
    console.log(filter_pcard_cardnum.value)
    console.log('clear_filter')

    prev_filterlist.value = []
    filter_emp_id.value = ''
    filter_pcard_cardnum.value = ''
    requestAutoFilterList()
  }
})

async function requestAutoFilterList(superlist=false){
  if (filter_emp_id.value != '' && filter_pcard_cardnum.value != ''){
    if (filter_pcard_cardnum.checkValidity()){
      // console.log('filter by only cardnum')
      return await requestList(
        {filter_name_2:'txn_card_num',filter_val_2:filter_pcard_cardnum.value},
        superlist
      )
    } else {
      filter_pcard_cardnum.reportValidity()
      return null
    }
  } else if (filter_emp_id.value != ''){
    if (filter_emp_id.checkValidity()){
      // console.log('filter by emp id')
      return await requestList(
        {filter_name:'txn_emp_id', filter_val:filter_emp_id.value},
        superlist
      )
    } else {
      filter_emp_id.reportValidity()
      return null
    }
  } else if (filter_pcard_cardnum.value != '') {
    if (filter_pcard_cardnum.checkValidity()){
      // console.log('filter by cardnum')
      return await requestList(
        {filter_name:'txn_card_num', filter_val:filter_pcard_cardnum.value},
        superlist
      )
    } else {
      filter_pcard_cardnum.reportValidity()
      return null
    }
  } else {
    // console.log('filter by none')
    return await requestList(null, superlist)
  }
}

// Major Button Logic
document.getElementById('auto_search').addEventListener('click', async()=>{
  event.preventDefault()
  await Promise.resolve(Permissions)

  console.log('Permissions:', Permissions)
  let arg = {
    emp_id:Permissions.emp_id
  }

  console.log('arg', arg)

  const pcardmodal_cardlist = document.getElementById('pcardmodal_cardlist')
  for (let i = pcardmodal_cardlist.length - 1; i >= 0; i--){
    pcardmodal_cardlist.remove(i);
  }

  let filterval = document.getElementById('filter_pcard_cardnum').value
  console.log('filterval', filterval)
  ipcRenderer.invoke('load-single-pcard-by-empid', arg).then(result =>{
    console.log('result', result)
    if(result.recordset.length > 0){
      let proto_subquery = {
        filter_name:['txn_emp_id'],
        filter_val:[Permissions.emp_id],
        backmode:selfurl.href
      }
      window.location = selfurl.href.split('?')[0]+'?4?3?'+encodeURIComponent(JSON.stringify(proto_subquery))
    } else if (parseInt(filterval) > 0 && String(filterval).length == 4){
      let proto_subquery = {
        filter_name:['txn_card_num'],
        filter_val:[filterval],
        backmode:selfurl.href
      }
      window.location = selfurl.href.split('?')[0]+'?4?3?'+encodeURIComponent(JSON.stringify(proto_subquery))
    } else throw Error
  }).catch(err =>{
    createAlert('error', 'Load All Recaps Error: No PCARDs Found For User: '+Permissions.emp_uname)
  })
})

document.getElementById('carddata_popup').addEventListener('click', ()=>{
  event.preventDefault()
  dispPcardModal()
})

// &#x1F504; Reset Filter

let curstage = null

const goto_home = document.getElementById("goto_home")
const goto_back = document.getElementById('goto_back')
const goto_search = document.getElementById("goto_search")
const goto_list = document.getElementById("goto_list")
const goto_selected = document.getElementById("goto_selected")

// CLOSE ALL POPUPS ON PAGE CHANGE
window.onbeforeunload = function(){
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';
};

goto_back.addEventListener('click', ()=>{
  event.preventDefault()
  console.log('go back to prev stage')
  if (curstage == goto_selected){
    goto_list.click()
  } else if (curstage == goto_list){
    if (subquery != null && subquery.backmode && subquery.backmode != null){
      window.location = subquery.backmode
    } else if (addlstagenum == 3){
      goto_search.click()
    } else {
      goto_home.click()
    }
  } else {
    goto_home.click()
  }
})

goto_search.addEventListener('click', ()=>{
  console.log('goto_search')
  console.log('loading prev filterlist', prev_filterlist.value)
  swapPage('Search', goto_search, 'forestgreen')
  // goto_list.setAttribute('disabled', 'disabled')

  prev_filterlist.value.forEach(arg=>{
    addToFilterList(arg.target, arg.value)
  })
})

goto_list.addEventListener('click', ()=>{
  swapPage('List', goto_list, 'navy')
  goto_list.removeAttribute('disabled')
  requestAutoFilterList() //NOTE: this can have different inputs depending on if it is intended to be filtered or not.
})

goto_list.removeAttribute('disabled')
goto_selected.addEventListener('click', ()=>{
  swapPage('Selection', goto_selected, 'darkred')
  goto_list.removeAttribute('disabled')
})

function swapPage(pageName, elmnt, color){
  curstage = elmnt

  window.scrollTo(0,0);
  const tabcontent = document.getElementsByClassName("tabcontent")
  for (i=0; i < tabcontent.length; i++) {
  $(tabcontent[i]).hide()
  }

  const tablinks = document.getElementsByClassName("tablink")
  for (i=0; i < tablinks.length; i++) {
  tablinks[i].style.backgroundColor = ""
  tablinks[i].style.backgroundImage = ""
  }

  let targetpage = document.getElementById(pageName)
  $(targetpage).show()
  targetpage.style.backgroundColor = color
  elmnt.style.backgroundColor = color;
  elmnt.style.backgroundImage = 'none'

  if(pageName == 'List'){
    document.getElementById('filter_pcard_cardnum').focus()
  }
}

const log_note = document.getElementById("log_note")

document.getElementById("submit_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  submitRecap(true)
})

document.getElementById("approve_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  submitRecap(true)
})

const denyModal_notes = document.getElementById('denyModal_notes')
function dispDenyModal(){
  denyModal_notes.value = String(log_note.value)
  $(denyModal).show()
  denyModal_notes.focus()
}

document.getElementById('denyModal_confirm').addEventListener('click', ()=>{
  event.preventDefault()
  if (denyModal_notes.checkValidity()){
    log_note.value = String(denyModal_notes.value)
    $(denyModal).hide()
    submitRecap(false)
  } else {
    denyModal_notes.reportValidity()
  }
})

document.getElementById('denyModal_cancel').addEventListener('click', ()=>{
  event.preventDefault()
  log_note.value = String(denyModal_notes.value)
  $(denyModal).hide()
})

document.getElementById("decline_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  dispDenyModal()
})

async function submitRecap(approve){
  event.preventDefault()

  if (document.getElementById('Selection').checkValidity()) {
    if (txn_prev_max >= 2 && stagenum == 0){
      PAGE_OUTVAL = stagelist[2]
    } else {
      PAGE_OUTVAL = stagelist[stagenum+1]
    }

    if (stagenum == 2){
      PAGE_DENY_OUTVAL = stagelist[0]
    } else {
      PAGE_DENY_OUTVAL = stagelist[Math.max(0, stagenum-1)]
    }

    console.log('PAGE_TARGETVAL', PAGE_TARGETVAL, 'PAGE_OUTVAL', PAGE_OUTVAL, 'PAGE_DENY_OUTVAL', PAGE_DENY_OUTVAL)

    arg = {
      txn_purchase_desc:document.getElementById('txn_purchase_desc').value,
      txn_purchase_purpose: purchase_for_val,
      txn_id: document.getElementById('txn_id').value
    }

    if (prev_cartegraph_status != 'Done'){
      arg.txn_cartegraph_status = radio_cartegraph_val
    }
    if (prev_use_tax_status != 'Done'){
      arg.txn_use_tax_status = radio_usetax_val
    }

    if (txn_cartegraph_amt.value && txn_cartegraph_amt.value != null && txn_cartegraph_amt != ''){
      arg.txn_cartegraph_amt = parseFloat(txn_cartegraph_amt.value).toFixed(2)
    }
    if (txn_use_tax_rate.value && txn_use_tax_rate.value != null && txn_use_tax_rate != ''){
      arg.txn_use_tax_rate = parseFloat(txn_use_tax_rate.value).toFixed(2)
    }
    if (txn_use_tax_amt.value && txn_use_tax_amt.value != null && txn_use_tax_amt != ''){
      arg.txn_use_tax_amt = parseFloat(txn_use_tax_amt.value).toFixed(2)
    }

    if (stagenum == 0){
      arg.txn_user_certificate = document.getElementById('txn_user_certificate').checked ? 1 : 0
      arg.txn_user_for_another = document.getElementById('txn_user_for_another').checked ? 1 : 0
      arg.txn_user_signature = document.getElementById('txn_user_signature').value
    }

    // numfilesadded vs totalfiles
    // IF INITIAL SUBMIT (OR RESUBMIT), MUST HAVE UPLOADED (any) FILES
    if (stagenum == 0 && totalfiles <= 0){
      createAlert('danger', 'Must Upload Any Documentation / Reciepts')
      return false
    } else if (stagenum == 0 && numfilesadded <= 0 && document.getElementById('txn_status').value != stagelist[stagenum]){
      // ELSE IF PENDING DELIVERY, MUST UPLOAD ADDITIONAL FILES
      createAlert('danger', 'Must Upload Additional Documentation / Reciepts')
      return false
    }

    // confirm delivery status
    purchase_delivery_status_val = document.querySelector('input[name=radio_delivery]:checked').value
    if (stagenum == 0 && purchase_delivery_status_val == "Pending"){
      let options  = {
       buttons: ["Yes","No","Cancel"],
       message: "Have you recieved all items and attached all packing slips for this transaction?"
      }
      let response = await remote.dialog.showMessageBox(remote.getCurrentWindow(), options)
      console.log('response', response)
      if (response.response == 0){
        document.getElementById('status_recap_received').checked = true
        createAlert('Submission Changed to Recieved')
      } else if (response.response == 1){
        document.getElementById('status_recap_pending').checked = true
        createAlert('Submission Changed to Pending')
      } else {
        createAlert('Submission Cancelled')
        return false
      }
    }

    purchase_delivery_status_val = document.querySelector('input[name=radio_delivery]:checked').value
    console.log('delivery:', purchase_delivery_status_val)
    arg.txn_purchase_status = purchase_delivery_status_val

    if (approve) {
      if ((stagenum != 2 && stagenum != 3) || document.getElementById('target_remaining').value == 0){
        console.log('target remaining ok')
      } else {
        remainval = document.getElementById('target_remaining').value
        createAlert('danger', 'Item Breakdown Error: $' +String(remainval) +' not accounted for in Org Key / Object Code Breakdown. Please Fix and Try Again')
        document.getElementById('subitem_total').value = remainval
        document.getElementById('subitem_total').focus()
        return
      }

      arg.txn_status = PAGE_OUTVAL
      arg.txn_max_stage = Math.max(txn_prev_max, stagenum+1)
    } else {
      arg.txn_status = PAGE_DENY_OUTVAL
      arg.txn_max_stage = Math.max(txn_prev_max, stagenum)
    }

    //Cartegraph_value

    console.log('cartegraph',radio_cartegraph_val)
    console.log('cartegraph', arg.txn_cartegraph_status)
    

    cartegraph_status_val = document.querySelector('input[name=radio_cartegraph]:checked').value 
    arg.txn_cartegraph_status = cartegraph_status_val
    // console.log('cartegraph',radio_cartegraph_val)
    // console.log('cartegraph', arg.txn_cartegraph_status)
    // console.log('cartegraph',cartegraph_status_val)
    

//Usetax commented to avoid the dialog box
    
    // console.log('usetax',arg.txn_use_tax_status)
    // console.log('usetax',radio_usetax_val)
    // console.log('usetax',prev_use_tax_status)
    
    usetax_status_val = document.querySelector('input[name=radio_usetax]:checked').value 
    arg.txn_use_tax_status = usetax_status_val
    console.log('usetax2',usetax_status_val)
    // console.log('usetax2',arg.txn_use_tax_status)
    // console.log('usetax2',radio_usetax_val)
    // console.log('usetax2',prev_use_tax_status)

    //Use tax Status

    // if (stagenum == 2 && usetax_status_val == 'No'){
    //   console.log('verify', usetax_status_val)
    //   // confirm use tax status
    //   let options  = {
    //   buttons: ["Yes","No"],
    //   message: "Has tax been paid?"
    //   }
    //   let response = await remote.dialog.showMessageBox(remote.getCurrentWindow(), options)
    //   console.log('response', response) 
    //   if (response.response == 0){
    //     createAlert('info', 'Use Tax Paid Confirmed')
    //   } else if (response.response == 1){
    //     createAlert('Please Confirm Use Tax')
    //     return false
    //   } else {
    //     createAlert('Cancelled')
    //     return false
    //   }
    // } else {
    //   console.log('ok', usetax_status_val)
    // }

    if (approve || (log_note.value && log_note.value != '')){
      if (doc_link_to_task.value && doc_link_to_task.value != '') {
        arg.txn_task_id = doc_link_to_task.value
      }

      if (doc_link_to_travel.value && doc_link_to_travel.value != '') {
        arg.txn_travel_id = parseInt(doc_link_to_travel.value)
      }

      if (log_note.value && log_note.value != '') {
        arg.log_note = String(log_note.value)
      }

      if(stagenum == 0 && document.getElementById('txn_status').value != stagelist[stagenum]){
        arg2 = {
          txn_purchase_status:arg.txn_purchase_status,
          log_note:arg.log_note,
          txn_id:arg.txn_id
        }
        arg = arg2
      }

      if(approve){
        console.log('approve selected form')
      } else {
        console.log('deny selected form')
      }
      console.log('user comment:', arg.log_note)
      ipcRenderer.invoke('modify-single-pcard-recap', arg).then( async result =>{
        console.log('MODIFY RESULT', result)
        if(approve && !(stagenum == 0 && document.getElementById('txn_status').value != stagelist[stagenum])){
          await viewReport(2, arg.txn_id)
        }
        goto_list.click()
      }).catch(err =>{
        createAlert('danger', 'Pcard Update Failed! ' +String(err))
      })
    } else {
      console.log('no comment!')
      createAlert('danger', 'Comments/Notes are REQUIRED if DENYING a RECAP. This is so that the original submitter can correct the issue per your note and resubmit.')
      document.getElementById('log_note').focus()
    }
  } else {
    if (document.getElementById('txn_purchase_desc').value == '') {
      createAlert('danger', 'Must Input Item Description')
      document.getElementById('Selection').reportValidity()
    } else if (document.querySelector('input[name=radio_for]:checked') === null){
      createAlert('danger', 'Must Select Purchase Purpose (Task/Inventory/Travel/Other)')
    } else if (document.getElementById('link_to_task').checkValidity() == false) {
      createAlert('danger', 'Must Input Task # or Task #s')
      document.getElementById('link_to_task').reportValidity()
    } else if (document.getElementById('link_to_travel').checkValidity() == false) {
      createAlert('danger', 'Must Input Travel ID or Travel IDs')
      document.getElementById('link_to_travel').reportValidity()
    } else if (document.querySelector('input[name=radio_delivery]:checked') === null){
      createAlert('danger', 'Must Select Delivery Status (Pending/Received)')
    } else if (document.querySelector('input[name=radio_usetax]:checked') === null){
      createAlert('danger', 'Must Select Use Tax Status (Yes/No)')
    } else if (document.querySelector('input[name=radio_cartegraph]:checked') === null){
      createAlert('danger', 'Must Select Cartegraph Status (Yes/No)')
    } else if (document.getElementById('txn_user_certificate').checked == false) {
      createAlert('danger', 'Must Check Certify Checkbox')
    } else if (document.getElementById('txn_user_signature').value == '') {
      createAlert('danger', 'Must Input Signature to Submit')
      document.getElementById('txn_user_signature').reportValidity()
    } else {
      createAlert('danger', 'Form invalid; Update impossible')
      document.getElementById('Selection').reportValidity()
    }
  }
}

const open_selected = document.getElementById("open_selected")
open_selected.addEventListener('click', ()=>{
  event.preventDefault()
  let target = selection.value
  
  if (target == '') {
    console.log('no selection to load')
  } else {
    console.log("loading", target)
    requestEntry(target)
  }
})

document.getElementById("view_selected").addEventListener('click', ()=>{
  event.preventDefault()
  let target = selection.value

  if (target == '') {
    console.log('no selection to load')
  } else {
    console.log("loading", target)
    requestEntry(target)
  }
})

document.getElementById("pdf_selected").addEventListener('click', ()=>{
  event.preventDefault()
  let target = selection.value

  if (target == '') {
    console.log('no selection to load')
  } else {
    console.log("loading", target)
    viewReport(2, target)
  }
})

let loopcontinue = false
let firstloop = true
async function loopMessage(){
  return setTimeout( async function () {
    if (loopcontinue){
      createAlert('info', 'Working...', 1000)
      firstloop = false
      loopMessage()
    }
  }, firstloop ? 2200 : 1200)
}

document.getElementById("exportlist_excel").addEventListener('click', async()=>{
  event.preventDefault()
  loopcontinue = true
  firstloop = true
  loopMessage()
  console.log('starting')
  requestAutoFilterList(true).then(async listvals=>{
    console.log('done')
    loopcontinue = false

    // FILTER VALUES
    const keys = Object.keys(listvals[0])
    console.log('keys', keys)
    for (let i = 0; i < listvals.length; i++) {
      listvals[i].recapid = 'PC-' +String(new Date(listvals[i].txn_fiscal_year).getUTCFullYear()).slice(-2) +'-' +listvals[i].txn_card_num +'-' +(listvals[i].txn_fy_count?String(listvals[i].txn_fy_count).padStart(4, '0'):'NEW')

      // split notes by column
      for (let j = 0; j < listvals[i].log_notes.length; j++) {
        const element = listvals[i].log_notes[j];

        id = 'notes_'+String(j+1)
        listvals[i][id] = (element.log_uname) +', ' + new Date(element.log_time).toUTCString().substring(5, 16) +': ' +(element.log_note)
      }
      delete(listvals[i].log_notes)

      // split subitems by column
      for (let j = 0; j < listvals[i].sub_items.length; j++) {
        const element = listvals[i].sub_items[j];

        id = 'subitems_'+String(j+1)
        listvals[i][id] = '$'+parseFloat(element.subitem_total).toFixed(2) +', ' +element.subitem_org_key + ', ' +element.subitem_obj_code
      }
      delete(listvals[i].sub_items)

      // split file list by column
      for (let j = 0; j < listvals[i].file_list.length; j++) {
        const element = listvals[i].file_list[j];

        id = 'files_'+String(j+1)
        listvals[i][id] = (element.filesys_name)+ '_' +element.filesys_id +', ' + new Date(element.filesys_time).toUTCString().substring(5, 16)
      }
      delete(listvals[i].file_list)

      for (let j = 0; j < keys.length; j++){
        if (String(keys[j]).startsWith('emp_') || String(keys[j]).startsWith('pcard_')){
          delete(listvals[i][String(keys[j])])
        } else if (listvals[i][String(keys[j])] && listvals[i][String(keys[j])].toUTCString){
          listvals[i][String(keys[j])] = listvals[i][String(keys[j])].toUTCString().substring(4,16)
        }
      }
    }

    // SAVE FILE
    await ipcRenderer.invoke('csv-save-dialog', listvals).then(results=>{
      if (results == -1) {
        createAlert('info', 'Export File Cancelled')
      } else {
        createAlert('success', 'CSV Exported!')
      }
    }).catch(err=>{
      createAlert('error', 'File Save Error: '+err.toString())
    })
  }).catch(error=>{
    createAlert('warning', 'Export Excel Error ' +error.toString())
  })
})

const table = document.getElementById('recaplist')
async function requestList(filter=null, superlist=false){
  console.log('REQUEST LIST !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  // FIXME: USE THIS EVERYWHERE PROMISES/GLOBALS ARE USED; THIS PREVENTS RACE CONDITIONS
  let Constants = await ipcRenderer.invoke('getConstants')
  console.log('constants', Constants)

  console.log('request todo-list by stage', PAGE_TARGETVAL)

  selection.value = null
  let trs = document.getElementsByClassName('singleselect')
  for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }

  arg = {
    target_name: 'txn_status',
    target_val: PAGE_TARGETVAL
  }

  if (superlist){
    arg.superlist = true
  }

  if (stagenum == 2 && !Boolean(parseInt(Constants.pcard_recap_manager_review_enabled))){
    console.log('manager review mode DISABLED!')
    arg.special_or_filter_name='txn_status'
    arg.special_or_filter_val=stagelist[stagenum-1]
  } else if (stagenum == 2) {
    console.log('manager review mode ENABLED!')
  }

  // search mode always overrides all other filter settings
  if (addlstagenum == 3){
    arg.target_name = ''
    console.log('search mode: filter by special')
    if (subquery != null && subquery.filter_name.length > 0){
      console.log('filter by subquery', subquery)
      arg.filter_name = subquery.filter_name
      arg.filter_val = subquery.filter_val
    } else if (filter != null && filter.filter_name.length > 0){
      console.log('filter by applied filter', filter)
      arg.filter_name = filter.filter_name
      arg.filter_val = filter.filter_val
    } else if (prev_filterlist.value.length > 0){
      console.log('filter is null, using previous filter')
      names = []
      vals = []
      prev_filterlist.value.forEach(prevarg=>{
        console.log('filterable', prevarg)
        names.push(prevarg.target)
        vals.push(prevarg.value)
      })
      arg.filter_name = names
      arg.filter_val = vals
    } else {
      console.log('previous filter is empty; search is unfiltered')
    }
  // manual filter always overrides default filter settings
  } else if (filter && filter.filter_name && filter.filter_val){
    if (filter.filter_name_2 && filter.filter_val_2){
      console.log('filter by', filter.filter_name, filter.filter_val)
      arg.filter_name = [filter.filter_name, filter.filter_name_2]
      arg.filter_val = [filter.filter_val, filter.filter_val_2]
    } else {
      console.log('filter by', filter.filter_name, filter.filter_val)
      arg.filter_name = [filter.filter_name]
      arg.filter_val = [filter.filter_val]
    }
    console.log('manual filter from filter:', filter, 'made to:', arg)
  } else if (stagenum == 0) {
    console.log('default filter by txn_emp_id', Permissions.emp_id, '; unfiltered pcard recap submit list not allowed')
    filter_emp_id.value = Permissions.emp_id
    arg.filter_name = ['txn_emp_id']
    arg.filter_val = [Permissions.emp_id]
  } else if (stagenum == 1) {
    console.log('TODO: make this filter by all subemployees of current user, recursively (currently filtered by none)')
  } else if (addlstagenum == 1){
    console.log('use tax mode: filter by Reconciled and UT:Yes')
    arg.target_name = ''
    arg.filter_name = ['txn_status', 'txn_use_tax_status']
    arg.filter_val = ['Reconciled', 'Yes']
  } else if (addlstagenum == 2){
    // console.log('cartegraph mode: filter by Reconciled and cartegraph:Yes')
    console.log('cartegraph mode: filter by only cartegraph:Yes')
    arg.target_name = ''
    // arg.filter_name = ['txn_status', 'txn_cartegraph_status']
    // arg.filter_val = ['Reconciled', 'Yes']
    arg.filter_name = ['txn_cartegraph_status']
    arg.filter_val = ['Yes']
  } else {
    console.log('finance mode: unfiltered')
  }

  if (stagenum == 0){
    $(document.getElementById('list_recap_id')).hide()
  } else {
    $(document.getElementById('list_recap_id')).show()
  }

  if (stagenum > 0 && stagenum != 4){
    $(document.getElementById('list_status')).hide()
  } else {
    $(document.getElementById('list_status')).show()
  }

  return ipcRenderer.invoke('load-pcard-recap', arg).then(result =>{
    arg = result.recordset.reverse()

    for (const entry of arg) {
      let row = table.insertRow()
      row.className = 'singleselect'
      hiddencell = row.insertCell(0)
      hiddencell.textContent = JSON.stringify(entry)
      $(hiddencell).hide()

      let stringstatus = entry.txn_status

      if (stagelist[entry.txn_max_stage] != entry.txn_status){
        stringstatus = 'Denied '+stringstatus
      }
      if (entry.txn_purchase_status && entry.txn_purchase_status.includes('Pending')){
        stringstatus = 'Pending '+stringstatus
      }

      // TODO: conditional columns based on stagenum here

      statuscell = row.insertCell(1)
      statuscell.textContent = stringstatus

      idcell = row.insertCell(2)
      idcell.textContent = 'PC-' +String(new Date(entry.txn_fiscal_year).getUTCFullYear()).slice(-2) +'-' +entry.txn_card_num +'-' +(entry.txn_fy_count?String(entry.txn_fy_count).padStart(4, '0'):'NEW')
      
   


      if (stagenum == 0){
        $(idcell).hide()
      } else {
        $(idcell).show()
      }

      if (stagenum > 0 && stagenum != 4){
        $(statuscell).hide()
      } else {
        $(statuscell).show()
      }

      row.insertCell(3).textContent = entry.txn_card_num

      row.insertCell(4).textContent = entry.emp_lname
      row.insertCell(5).textContent = entry.emp_fname

      if (entry.txn_amt){
        row.insertCell(6).textContent = '$'+
          String(parseFloat(entry.txn_amt).toFixed(2))
      } else row.insertCell(6).textContent = 'Unknown'

      if (entry.txn_purchase_date){
        let d1 = new Date(entry.txn_purchase_date)
        row.insertCell(7).textContent = d1.toUTCString().substring(5, 16)
      } else row.insertCell(7).textContent = 'N/A'

      row.insertCell(8).textContent = entry.txn_vendor_name
    }

    getExtraUserData(arg[0])
    makeRecaplistSelectable()

    return arg
  }).catch(err=>{
    createAlert('warning', 'Load Recap Error '+err.toString())
    return null
  })
}

let purchase_for_val = ''
doc_link_to_task = document.getElementById('link_to_task')
doc_link_to_travel = document.getElementById('link_to_travel')

let prev_cartegraph_status = ''
let prev_use_tax_status = ''

async function parseAndSet(arg) {
  numfilesadded = 0
  totalfiles = 0

  await Promise.resolve(Uname)

  purchase_for_val = ''
  subitemselection.value = null

  txn_prev_max = arg.txn_max_stage

  document.getElementById('log_note').value = ''

  document.getElementById('delivery_status_column').style.cssText = "color: black; background-color: initial;"
  document.getElementById('upload_documentation_button').className = 'button nopad'

  document.getElementById('txn_user_certificate').checked = false
  document.getElementById('txn_user_for_another').checked = false
  document.getElementById('txn_user_was_another').checked = false
  document.getElementById('txn_user_signature').value = ''
  $(document.getElementById('user_is_self')).hide()
  $(document.getElementById('user_was_another')).hide()

  if (arg.txn_fy_count == null){
    arg.txn_fy_count = 'NEW'
  }

  // NOTE: THIS CONDITION TREE IS MIRRORED IN PARSE-AND-SET (WITH DIFFERENT CONTENTS)
  // IF FIXING ONE, FIX THE OTHER EQUALLY
  if (stagenum == 0 && arg.txn_status == stagelist[stagenum]){
    document.getElementById('txn_purchase_desc').focus()

    if (stagelist[txn_prev_max] != arg.txn_status){
      createAlert('warning', "THIS RECAP HAS BEEN PREVIOUSLY DENIED. PLEASE VERIFY CAREFULLY AND REVIEW ALL COMMENTS AT THE BOTTOM OF THE PAGE.")
    }
    $(document.getElementById('user_is_self')).show()
    if (!arg.emp_uname || arg.emp_uname.toUpperCase() != Uname.toUpperCase()){
      document.getElementById('txn_user_for_another').checked = true
    }
    document.getElementById('txn_purchase_desc').removeAttribute('disabled')
    document.getElementById('txn_purchase_desc').setAttribute('required', 'required')
    document.getElementById('txn_purchase_desc').removeAttribute('disabled')
    document.getElementById('for_recap_travel').removeAttribute('disabled')
    document.getElementById('for_recap_inventory').removeAttribute('disabled')
    document.getElementById('for_recap_task').removeAttribute('disabled')
    document.getElementById('for_recap_other').removeAttribute('disabled')
    document.getElementById('link_to_travel').removeAttribute('disabled')
    document.getElementById('link_to_task').removeAttribute('disabled')

    document.getElementById('txn_user_certificate').checked = false
    document.getElementById('txn_user_certificate').removeAttribute('disabled')
    document.getElementById('txn_user_certificate').setAttribute('required', 'required')

    document.getElementById('txn_user_signature').value = arg.txn_user_signature
    document.getElementById('txn_user_signature').removeAttribute('disabled')
    document.getElementById('txn_user_signature').setAttribute('required', 'required')
  } else {
    document.getElementById('log_note').focus()
    if (stagenum == 0){
      createAlert('info', "This Recap Cannot Be Edited, but can have new packing slips attached to it. When all items have been received, Select Status 'Received' and attach any new documentation.")

      document.getElementById('delivery_status_column').style.cssText = "color: red; background-color: orange;"
      document.getElementById('upload_documentation_button').className = 'button orange nopad'

      document.getElementById('txn_purchase_desc').removeAttribute('required')
      document.getElementById('txn_purchase_desc').setAttribute('disabled', 'disabled')
      document.getElementById('txn_purchase_desc').setAttribute('disabled', 'disabled')
      document.getElementById('for_recap_travel').setAttribute('disabled', 'disabled')
      document.getElementById('for_recap_inventory').setAttribute('disabled', 'disabled')
      document.getElementById('for_recap_task').setAttribute('disabled', 'disabled')
      document.getElementById('for_recap_other').setAttribute('disabled', 'disabled')
      document.getElementById('link_to_travel').setAttribute('disabled', 'disabled')
      document.getElementById('link_to_task').setAttribute('disabled', 'disabled')
    } else if (stagelist[txn_prev_max] != arg.txn_status){
      createAlert('warning', "THIS RECAP HAS BEEN PREVIOUSLY DENIED. PLEASE VERIFY CAREFULLY AND REVIEW ALL COMMENTS AT THE BOTTOM OF THE PAGE.")
    }

    document.getElementById('user_certificate_label').textContent = 'Submitter has certified that this form is accurate to the best of their knowledge.'

    document.getElementById('txn_user_certificate').checked = arg.txn_user_certificate
    document.getElementById('txn_user_certificate').removeAttribute('required')
    document.getElementById('txn_user_certificate').setAttribute('disabled', 'disabled')

    document.getElementById('txn_user_was_another').checked = arg.txn_user_for_another
    document.getElementById('txn_user_was_another').setAttribute('disabled', 'disabled')

    document.getElementById('txn_user_signature').value = arg.txn_user_signature
    document.getElementById('txn_user_signature').removeAttribute('required')
    document.getElementById('txn_user_signature').setAttribute('disabled', 'disabled')

    if (arg.txn_user_for_another == 1){
      document.getElementById('user_was_another').checked = true
      $(document.getElementById('user_was_another')).show()
    } else {
      $(document.getElementById('user_was_another')).hide()
    }

    $(document.getElementById('user_is_self')).hide()

  }

  document.getElementById('recap_id').value = 'PC-' +String(new Date(arg.txn_fiscal_year).getUTCFullYear()).slice(-2) +'-' +arg.txn_card_num +'-' +(arg.txn_fy_count?String(arg.txn_fy_count).padStart(4, '0'):'NEW')
  document.getElementById('txn_id').value = arg.txn_id
  document.getElementById('txn_status').value = arg.txn_status

  document.getElementById('emp_name').value = arg.emp_lname +', ' +arg.emp_fname
  document.getElementById('emp_id').value = arg.emp_id
  document.getElementById('txn_card_num').value = '******' +arg.txn_card_num

  document.getElementById('txn_amt').value = parseFloat(arg.txn_amt).toFixed(2)
  document.getElementById('txn_vendor_name').value = arg.txn_vendor_name
  document.getElementById('txn_purchase_desc').value = arg.txn_purchase_desc

  d1 = new Date(arg.txn_purchase_date)
  d2 = new Date(arg.txn_post_date)
  d3 = new Date(arg.txn_bill_cycle)
  d4 = new Date(arg.txn_fiscal_year)

  // console.log('purchase date', arg.txn_purchase_date)
  // console.log('post date', arg.txn_post_date)
  // console.log('bill cycle date', arg.txn_bill_cycle)
  // console.log('fiscal year date', arg.txn_fiscal_year)

  document.getElementById('txn_purchase_date').value = d1.getUTCMonth()+1+'/'+d1.getUTCDate()+'/'+d1.getUTCFullYear();
  document.getElementById('txn_post_date').value = d2.getUTCMonth()+1+'/'+d2.getUTCDate()+'/'+d2.getUTCFullYear();
  document.getElementById('txn_bill_cycle').value = d3.getUTCMonth()+1+'/'+d3.getUTCFullYear();
  document.getElementById('txn_fiscal_year').value = +d4.getUTCFullYear();

  $("input[name=radio_for]:checkbox").prop('checked', false)
  $("input[name=radio_delivery]:radio").prop('checked', false)
  $("input[name=radio_usetax]:radio").prop('checked', false)
  $("input[name=radio_cartegraph]:radio").prop('checked', false)

  $(document.getElementById('has_travel_link')).hide()
  document.getElementById('link_to_travel').value = ''
  doc_link_to_travel.removeAttribute('required')

  $(document.getElementById('has_task_link')).hide()
  doc_link_to_task.value = ''
  doc_link_to_task.removeAttribute('required')

  if (arg.txn_cartegraph_status && arg.txn_cartegraph_status != null && arg.txn_cartegraph_status != ''){
    prev_cartegraph_status = arg.txn_cartegraph_status
    if (arg.txn_cartegraph_status == 'No'){
      document.getElementById('cartegraph_no').checked = true
      $(document.getElementById('has_cartegraph')).hide()
      document.getElementById('txn_cartegraph_amt').value = ''
      document.getElementById('txn_cartegraph_amt').removeAttribute('required')
    } else {
      document.getElementById('cartegraph_yes').checked = true
      $(document.getElementById('has_cartegraph')).show()
    }
  } else {
    $(document.getElementById('has_cartegraph')).hide()
  }

  if (arg.txn_cartegraph_amt && arg.txn_cartegraph_amt != null && arg.txn_cartegraph_amt != ''){
      txn_cartegraph_amt.value = arg.txn_cartegraph_amt
  } else {
    txn_cartegraph_amt.value = ''
  }

  if (arg.txn_use_tax_status && arg.txn_use_tax_status != null && arg.txn_use_tax_status != ''){
    prev_use_tax_status = arg.txn_use_tax_status
    if (arg.txn_use_tax_status == 'No'){
      document.getElementById('usetax_no').checked = true
      $(document.getElementById('has_use_tax')).hide()
      document.getElementById('txn_use_tax_rate').value = ''
      document.getElementById('txn_use_tax_amt').value = ''
      document.getElementById('txn_use_tax_rate').removeAttribute('required')
      document.getElementById('txn_use_tax_amt').removeAttribute('required')
    } else {
      document.getElementById('usetax_yes').checked = true
      $(document.getElementById('has_use_tax')).show()
      document.getElementById('txn_use_tax_rate').value = 9.0
      txn_use_tax_amt.value = ((9.0 * parseFloat(document.getElementById('txn_amt').value))/100).toFixed(2)
      document.getElementById('txn_use_tax_rate').setAttribute('required', 'required')
      document.getElementById('txn_use_tax_amt').setAttribute('required', 'required')
    }
  } else {
    $(document.getElementById('has_use_tax')).hide()
  }

  if (arg.txn_use_tax_rate && arg.txn_use_tax_rate != null && arg.txn_use_tax_rate != ''){
    txn_use_tax_rate.value = arg.txn_use_tax_rate
  } else {
    txn_use_tax_rate.value = ''
  }

  if (arg.txn_use_tax_amt && arg.txn_use_tax_amt != null && arg.txn_use_tax_amt != ''){
      txn_use_tax_amt.value = arg.txn_use_tax_amt
  } else {
    txn_use_tax_amt.value = ''
  }

  if (arg.txn_purchase_purpose && arg.txn_purchase_purpose != null && arg.txn_purchase_purpose != ''){
    if (arg.txn_purchase_purpose.includes('Travel')){
      document.getElementById('for_recap_travel').checked = true

      if (arg.txn_travel_id && arg.txn_travel_id != null && arg.txn_travel_id != ''){
        document.getElementById('link_to_travel').value = arg.txn_travel_id
      }

    } else if (arg.txn_purchase_purpose.includes('Inventory')){
      document.getElementById('for_recap_inventory').checked = true
    }

    if (arg.txn_purchase_purpose.includes('Task') || (arg.txn_task_id && arg.txn_task_id != null && arg.txn_task_id != '')){
      document.getElementById('for_recap_task').checked = true
      document.getElementById('link_to_task').value = arg.txn_task_id
      if (stagenum == 2 && txn_prev_max <= 2){
        // shortcut into cartegraph yes on first review
        document.getElementById('cartegraph_yes').click()
      }
    } else if (arg.txn_purchase_purpose.includes('Other')){
      document.getElementById('for_recap_other').checked = true
    }
  }

  if (arg.txn_purchase_status && arg.txn_purchase_status != null && arg.txn_purchase_status != ''){
    if (arg.txn_purchase_status.includes('Pending')){
      document.getElementById('status_recap_pending').checked = true
    } else if (arg.txn_purchase_status.includes('Received')){
      document.getElementById('status_recap_received').checked = true
    }
  }

  applySelection()

  // JQUERY IS AWESOME
  $("input:checkbox").parent().show()
  $("input:radio").parent().show()
  $("input:checkbox:disabled:not(:checked)").parent().hide()
  $("input:radio:disabled:not(:checked)").parent().hide()

  const lognotelist = document.getElementById("lognotelist")
  const lognotelistheader = document.getElementById("lognotelistheader")
  // reset list
  for (let i = lognotelist.length - 1; i >= 0; i--){
    lognotelist.remove(i);
  }

  if (arg.log_notes && arg.log_notes.length > 0) {
    $(lognotelistheader).show();
    $(lognotelist).show();

    lognotelist.size = String(Math.min(Math.max(arg.log_notes.length, 2), 4))

    arg.log_notes.forEach(log =>{
      let d1 = new Date(log.log_time)
      let name = (log.log_uname)+
      ', ' + d1.toUTCString().substring(5, 16)+
      ': ' + (log.log_note)

      option = document.createElement('option')
      option.value = ''
      option.text = name
      lognotelist.prepend(option)
    });
  } else {
    $(lognotelist).hide()
    $(lognotelistheader).hide()
  }

  remain = await refreshSubitemList(arg.txn_id)
  document.getElementById('subitem_total').value = remain
}

function requestEntry(id){
  console.log('REQUEST ENTRY !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  // console.log('request todo-selection')
  arg = {
    target_name: 'txn_id',
    target_val: id
  }

  ipcRenderer.invoke('load-pcard-recap', arg).then(result =>{
    if (result && result.recordset && result.recordset[0]) {
      arg = result.recordset[0]
      console.log('loaded', arg)
      swapPage('Selection', goto_selected, 'darkred')
      goto_list.removeAttribute('disabled')
      loadDocuments(arg.txn_id)
      parseAndSet(arg)
    } else {
      if (selection && selection.value && selection.value != ''){
        createAlert('warning', "Unable to load selection; someone else may have just completed it. Refreshing options list.")
        requestList()
      } else {
        createAlert('warning', "No RECAP selected. Please select a RECAP from the list and try again.")
      }
    }
  }).catch(err =>{
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
  })
}


async function loadDocuments(txn_id) {
  // reset list
  for (let i = documentlist.length - 1; i >= 0; i--){
    documentlist.remove(i);
  }

  for (let i = documentlist_mirror.length - 1; i >= 0; i--){
    documentlist_mirror.remove(i);
  }

  filesysarg = {
    filesys_linked_table:'pcard_recap',
    filesys_linked_id:txn_id
  }

  totalfiles = 0
  await ipcRenderer.invoke('load-file-list-filesys', filesysarg).then(results =>{
    file_list = results.recordset
    console.log('files', file_list)
    file_list.forEach(file_details =>{
      totalfiles+=1
      let id = file_details.filesys_id

      console.log('file id', id)
      document.getElementById('documentation_type').value = ''

      let name = file_details.filesys_name +' ' +new Date(file_details.filesys_time).toUTCString().substring(5, 16)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist.prepend(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist_mirror.prepend(option)
    })
  }).catch(err =>{
    console.log('no files found', err.name)
    console.log(err)
  })
}


for_recap_travel = document.getElementById('for_recap_travel')
for_recap_inventory = document.getElementById('for_recap_inventory')
for_recap_task = document.getElementById('for_recap_task')
for_recap_other = document.getElementById('for_recap_other')

for_recap_travel.addEventListener('click', ()=>{
  if(for_recap_travel.checked == true){
    for_recap_inventory.checked = false
    for_recap_task.checked = false
    for_recap_other.checked = false
  }
})

for_recap_inventory.addEventListener('click', ()=>{
  if(for_recap_inventory.checked == true){
    for_recap_travel.checked = false
    for_recap_other.checked = false
  }
})

for_recap_task.addEventListener('click', ()=>{
  if(for_recap_task.checked == true){
    for_recap_travel.checked = false
    for_recap_other.checked = false
  }
})

for_recap_other.addEventListener('click', ()=>{
  if(for_recap_other.checked == true){
    for_recap_inventory.checked = false
    for_recap_task.checked = false
    for_recap_travel.checked = false
  }
})

$("input[name=radio_for]:checkbox").change((change)=>{
  console.log('changed', change)
  applySelection()
})

function applySelection(){
  values = []
  document.querySelectorAll('input[name=radio_for]:checked').forEach(checkbox =>{
    values.push(checkbox.value)
  })

  console.log('for:', values)
  purchase_for_val = 'Other'

  // Inventory && Task is stored in DB as 'Inventory' only, but with task_num not null
  if (values && values.includes('Task')) {
    if (values.includes('Inventory')) {
      purchase_for_val = 'Inventory'
    } else {
      purchase_for_val = 'Task'
    }

    $(document.getElementById('has_task_link')).show()
    doc_link_to_task.setAttribute('required', 'required')
    document.getElementById('link_to_task').focus()
  } else {
    $(document.getElementById('has_task_link')).hide()
    doc_link_to_task.value = ''
    doc_link_to_task.removeAttribute('required')
  }
  // FIXME: FUTURE: an error message should appear LIVE if the travel ID is not present in travel (request/recap) table
  if (values && values.includes('Travel')) {
    purchase_for_val = 'Travel'

    $(document.getElementById('has_travel_link')).show()
    doc_link_to_travel.setAttribute('required', 'required')
    document.getElementById('link_to_travel').focus()
  } else {
    $(document.getElementById('has_travel_link')).hide()
    doc_link_to_travel.value = ''
    doc_link_to_travel.removeAttribute('required')
  }

  // console.log('values', values, 'length', values.length)
  if (values.length > 0){
    document.querySelectorAll('input[name=radio_for]').forEach(checkbox =>{
      checkbox.removeAttribute('required')
    })
  } else {
    document.querySelectorAll('input[name=radio_for]').forEach(checkbox =>{
      checkbox.setAttribute('required', 'required')
    })
  }
}

let purchase_delivery_status_val = ''
$("input[name=radio_delivery]:radio").change(()=>{
  purchase_delivery_status_val = document.querySelector('input[name=radio_delivery]:checked').value
  console.log('delivery:', purchase_delivery_status_val)
})


let radio_cartegraph_val = ''
$("input[name=radio_cartegraph]:radio").change(()=>{
  radio_cartegraph_val = document.querySelector('input[name=radio_cartegraph]:checked').value
  console.log('radio_cartegraph:', radio_cartegraph_val)
  if (radio_cartegraph_val == 'No') {
    $(document.getElementById('has_cartegraph')).hide()
    updateUTCARTEvalues()
  } else {
    $(document.getElementById('has_cartegraph')).show()
    updateUTCARTEvalues()
  }
})

let radio_usetax_val = ''
$("input[name=radio_usetax]:radio").change(()=>{
  radio_usetax_val = document.querySelector('input[name=radio_usetax]:checked').value
  console.log('radio_usetax:', radio_usetax_val)
  if (radio_usetax_val == 'No') {
    $(document.getElementById('has_use_tax')).hide()
    document.getElementById('txn_use_tax_rate').value = 0.0
    document.getElementById('txn_use_tax_amt').value = 0.00
    document.getElementById('txn_use_tax_rate').removeAttribute('required')
    document.getElementById('txn_use_tax_amt').removeAttribute('required')
    updateUTCARTEvalues()
  } else {
    $(document.getElementById('has_use_tax')).show()
    document.getElementById('txn_use_tax_rate').focus()
    document.getElementById('txn_use_tax_rate').value = 9.0
    txn_use_tax_amt.value = ((9.0 * parseFloat(document.getElementById('txn_amt').value))/100).toFixed(2)
    document.getElementById('txn_use_tax_rate').setAttribute('required', 'required')
    document.getElementById('txn_use_tax_amt').setAttribute('required', 'required')
    updateUTCARTEvalues()
  }
})

async function updateUTCARTEvalues(){
  let usetaxamtval = 0
  let cartegraphamtval = 0

  if (!document.querySelector('input[name=radio_usetax]:checked') || document.querySelector('input[name=radio_usetax]:checked').value == 'No'){
    txn_use_tax_amt.value = 0
    usetaxamtval = 0
  } else {
    usetaxamtval = parseFloat(txn_use_tax_amt.value)
  }
  console.log('usetaxamtval', usetaxamtval)

  if (!document.querySelector('input[name=radio_cartegraph]:checked') ||document.querySelector('input[name=radio_cartegraph]:checked').value == 'No'){
    txn_cartegraph_amt.value = 0
    cartegraphamtval = 0
  } else {
    cartegraphamtval = parseFloat(parseFloat(document.getElementById('txn_amt').value) + usetaxamtval).toFixed(2)
    txn_cartegraph_amt.value = cartegraphamtval
  }
  console.log('cartegraphamtval', cartegraphamtval)
}

txn_use_tax_rate.addEventListener('input', event=>{
  let new_rate = parseFloat(txn_use_tax_rate.value)
  console.log('ut rate changed', new_rate)
  txn_use_tax_amt.value = ((new_rate * parseFloat(document.getElementById('txn_amt').value))/100).toFixed(2)
  updateUTCARTEvalues()
})
txn_use_tax_rate.addEventListener('focusout', event=>{
  let new_rate = parseFloat(txn_use_tax_rate.value)
  console.log('ut rate changed', new_rate)
  txn_use_tax_amt.value = ((new_rate * parseFloat(document.getElementById('txn_amt').value))/100).toFixed(2)
  updateUTCARTEvalues()
})

txn_use_tax_amt.addEventListener('input', event=>{
  let new_amt = parseFloat(txn_use_tax_amt.value)
  console.log('ut amt changed', new_amt)
  txn_use_tax_rate.value = ((100 * new_amt) / parseFloat(document.getElementById('txn_amt').value)).toFixed(2)
  updateUTCARTEvalues()
})
txn_use_tax_amt.addEventListener('focusout', event=>{
  let new_amt = parseFloat(txn_use_tax_amt.value)
  console.log('ut amt changed', new_amt)
  txn_use_tax_rate.value = ((100 * new_amt) / parseFloat(document.getElementById('txn_amt').value)).toFixed(2)
  updateUTCARTEvalues()
})

let startx = 0
let starty = 0
document.getElementById('receiptModal').addEventListener('dragstart', event=>{
  console.log('receipt dragged!', event)
  startx = event.offsetX
  starty = event.offsetY
})
document.getElementById('receiptModal').addEventListener('dragend', event=>{
  console.log('receipt dragged!', event)
  if ((startx - event.offsetX < 50 && starty - event.offsetY < 50) && (startx - event.offsetX > -50 && starty - event.offsetY > -50)){
    createAlert('info', 'If you drag the receipt further, it will become a popup')
  } else {
    createAlert('info', 'Receipt has been dragged, creating popup')
    $(receiptModal).hide()
    offset = 0
    previframe.forEach(frame=>{
      options = `width=700, height=800, x=${25+offset}, y=${25+offset}
      alwaysOnTop=true,`
      console.log('opening with options', options)
      newwin = window.open(frame.src, '', options)
      windowlist.push(newwin)
      offset += 5
    })
    if(windowlist.length > 0){
      windowlist[0].focus()
    }
  }
})
document.getElementById('viewer').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})
document.getElementById('near_close').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})

document.getElementById("cartegraph_notfor_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  alterRecap('txn_cartegraph_status', false)
})
document.getElementById("cartegraph_completed_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  alterRecap('txn_cartegraph_status', true)
})
document.getElementById("usetax_notfor_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  alterRecap('txn_use_tax_status', false)
})
document.getElementById("usetax_completed_pcard_recap").addEventListener('click', ()=>{
  event.preventDefault()
  alterRecap('txn_use_tax_status', true)
})

async function alterRecap(attname, mode){
  targetid = document.getElementById('txn_id').value

  if (mode){
    outval = 'Done'
  } else {
    outval = 'No'
  }


  arg = {
    txn_id:targetid,
  }

  arg[attname] = outval

  if (log_note.value && log_note.value != '') {
    arg.log_note = String(log_note.value)
  }

  console.log('modify selected form', arg)
  ipcRenderer.invoke('modify-single-pcard-recap', arg).then(result =>{
    createAlert('success', 'Pcard Updated!')
    goto_list.click()
  }).catch(err =>{
    createAlert('danger', 'Pcard Update Failed!' +String(err))
  })
}

document.getElementById("go_back_to_list").addEventListener('click', ()=>{
  event.preventDefault()
  goto_list.click()
})

document.getElementById("cartegraph_view_report_receipts").addEventListener('click', ()=>{
  event.preventDefault()
  let tempval = document.getElementById('txn_id').value
  viewReport(2, tempval)
})

document.getElementById("usetax_view_receipts").addEventListener('click', ()=>{
  event.preventDefault()
  let tempval = document.getElementById('txn_id').value
  viewReport(1, tempval)
})

function loadAllContents(txn_id){
  filesysarg = {
    filesys_linked_table:'pcard_recap',
    filesys_linked_id:txn_id
  }

  return ipcRenderer.invoke('loadAllFileContents', filesysarg)
}

async function viewReport(mode=0, id){
  console.log('REQUEST REPORT !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  arg = {
    target_name: 'txn_id',
    target_val: id
  }

  await ipcRenderer.invoke('load-pcard-recap', arg).then(async result =>{
    if (result && result.recordset && result.recordset[0]) {
      arg = result.recordset[0]
      console.log('REPORT DATA LOADED', arg)
      try {
        if (mode == 1){
          $(receiptModal).show();
          previframe.forEach(frame=>{
            try{
              viewerEle.removeChild(frame)
            } catch{
              console.log('malformed frame', frame, 'could not be removed')
            }
          })
          previframe = []
          windowlist.forEach(win=>{
            win.close()
          })
          windowlist = []
          createAlert('info', 'Loading Receipts to Merge')
          loadAllContents(id).then(file_results=>{
            file_results.recordset.forEach(loaded_file=>{
              pdfData = base64ToUint8Array(loaded_file.filesys_content);
              subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
              const iframe = document.createElement('iframe')
              let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
              iframe.src = viewerUrl
              viewerEle.appendChild(iframe);
              previframe.push(iframe)
            })
            return true
          }).catch(err=>{
            createAlert('error', 'Receipts Could not be Loaded ' +String(err))
            return false
          })
        } else if (mode == 2){
          targeturl = await makePDF(arg)
          // targeturl = await ipcRenderer.invoke('generate-recap-pdf', arg)

          $(receiptModal).show();
          previframe.forEach(frame=>{
            try{
              viewerEle.removeChild(frame)
            } catch{
              console.log('malformed frame', frame, 'could not be removed')
            }
          })
          previframe = []
          windowlist.forEach(win=>{
            win.close()
          })
          windowlist = []

          viewerEle.innerHTML = '';
          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)

          createAlert('info', 'Loading Receipts to Merge')
          loadAllContents(id).then(file_results=>{
            file_results.recordset.forEach(loaded_file=>{
              pdfData = base64ToUint8Array(loaded_file.filesys_content);
              subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
              const iframe = document.createElement('iframe')
              let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
              iframe.src = viewerUrl
              viewerEle.appendChild(iframe);
              previframe.push(iframe)
            })
          }).catch(err=>{
            createAlert('error', 'Receipts Could not be Loaded')
          })
        } else {
          targeturl = await makePDF(arg)
          // targeturl = await ipcRenderer.invoke('generate-recap-pdf', arg)

          $(receiptModal).show();
          previframe.forEach(frame=>{
            try{
              viewerEle.removeChild(frame)
            } catch{
              console.log('malformed frame', frame, 'could not be removed')
            }
          })
          previframe = []
          windowlist.forEach(win=>{
            win.close()
          })
          windowlist = []
          viewerEle.innerHTML = '';
          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
          return true
        }
      } catch (err) {
        createAlert('info', 'Report Could not be Displayed! ' +String(err))
        return false
      }
    } else {
      if (id && id != ''){
        createAlert('warning', "Unable to load report data for id " +String(id) +"; Something must have gone wrong. Refreshing options list.")
        await requestList()
        return false
      } else {
        createAlert('warning', "Report ID to load not specified. Report Load Cancelled")
        return false
      }
    }
  }).catch(err =>{
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
    return false
  })
}

// at end of page loading
if (addlstagenum == 3 && !(subquery != null && subquery.filter_name.length > 0)){
  goto_search.click()
} else {
  goto_list.click()
}