const {ipcRenderer} = require('electron')
const {createAlert} = require("../utilities/alert_box")

console.log('this code gets run on page load.')

console.log('any event listeners added allow html buttons to run functions in here')

document.getElementById('sample_button').addEventListener('click', () =>{
    event.preventDefault()
    console.log('button clicked!')
    createAlert('success', 'Button Clicked!')
})

console.log('running ipcRenderer.invoke(name, values) allows your program to ask the main process to run one of the functions it contains. This is how database queries are exectued. The results of the invokation can then be viewed with a .then(result=>{...}) after, or a result = await ... before')

ipcRenderer.invoke('getPermissions').then(results =>{
    permissions = results
    console.log('permissions', permissions)
}).catch(err=>{
    console.log('error', err)
})

console.log('createAlert, meanwhile, is used for the elegant little popups in the bottom left of the screen. Any error messages (and most success messages) that you would make a console.log(message) for, the user might want to see with a createAlert("info", message) too')

createAlert('info', 'sample information!')