const {ipcRenderer} = require('electron')
const {createObjectURL} = require('blob-util')
const $ = require('jquery')

const travelCalculate = require('./travelformulas')
const {createAlert} = require('../utilities/alert_box')
const {makeTravelPDF} = require('../utilities/reportgen')
const {makeSortable} = require('../utilities/sortable')

makeSortable()

const stagelist = ['Cancelled', 'New Travel', 'Submitted', 'Manager Processed', 'Finance Processed', 'Division Head Processed', 'Confirmed']
const headerlist = [
  'Create New Travel Request',
  'Submit Travel Request',
  'Manager Approve Travel Request',
  'Finance Approve Travel Request',
  'Division Head Approve Travel Request',
  'Department Head Approve Travel Request'
]

const goto_home = document.getElementById('goto_home')
const goto_back = document.getElementById('goto_back')

const goto_event = document.getElementById('goto_event')
const goto_travel = document.getElementById('goto_travel')
const goto_traveler = document.getElementById('goto_traveler')
const goto_submit = document.getElementById('goto_submit')

const goto_list = document.getElementById('goto_list')
const goto_selected = document.getElementById('goto_selected')

let travel_max_stage = 0
let self_id = null

const selection = {}

let previframe = []
let windowlist = []

let travel_personal_days = 0
let travel_eligible_lodging_nights = 0
let travel_eligible_rental_car_days = 0
let travel_max_reinbursible = 0
let travel_bfst_allowed = 0
let travel_lnch_allowed = 0
let travel_dinn_allowed = 0
let travel_bfst_not_cvrd = 0
let travel_lnch_not_cvrd = 0
let travel_dinn_not_cvrd = 0
let travel_form_status = 'New Travel'
let readyToSubmit = false

// CLOSE ALL POPUPS ON PAGE CHANGE
window.onbeforeunload = function(){
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';
};

// dynamic html stuff:
let values = window.location.search.split('?')
console.log('vals', values)
let stagenum = 0
if (values.length >= 1 && values[1] && parseInt(values[1])){
  stagenum = parseInt(values[1])
}

console.log('stagenum', stagenum)

document.getElementById('pageheader').textContent = headerlist[stagenum]
const PAGE_TARGETVAL = stagelist[stagenum]

if (stagenum==0){
  $(goto_list).hide()
  $(goto_selected).hide()
} else {
  $(goto_event).hide()
  $(goto_travel).hide()
  $(goto_traveler).hide()
  $(goto_submit).hide()
}

let filesys_id_list = []

modal_modify_orgkey = document.getElementById('modal_modify_orgkey')
OrgKeys = ipcRenderer.invoke('getOrgKeys').then(result =>{
  OrgKeys = result
  // console.log('subitem_org_key:', OrgKeys)
  for (let i = 0; i < OrgKeys.length; i++) {
    if (OrgKeys[i].org_enabled == 1){
      let name = OrgKeys[i].org_key +': '+ OrgKeys[i].org_desc
      let id = OrgKeys[i].org_key
      option = document.createElement('option')
      option.value = id
      option.text = name
      modal_modify_orgkey.add(option)
    }
  }
})

modal_modify_supervisor = document.getElementById('modal_modify_supervisor')
Supervisors = ipcRenderer.invoke('getSupervisors').then(result =>{
  Supervisors = result
  // console.log('subitem_Supervisors:', Supervisors)
  for (let i = 0; i < Supervisors.length; i++) {
    let name = Supervisors[i].emp_lname +', '+ Supervisors[i].emp_fname
    let id = Supervisors[i].emp_id
    option = document.createElement('option')
    option.value = id
    option.text = name
    modal_modify_supervisor.add(option)
  }
})

document.getElementById('quit_app').addEventListener('click', ()=>{
  ipcRenderer.invoke('quit_app')
});

// modal stuff
// https://www.w3schools.com/howto/howto_css_modals.asp
let modal = document.getElementById('myModal');
// Get the <span> element that closes the modal
let span = document.getElementsByClassName('close')[0];
// When the user clicks on <span> (x), close the modal
span.onclick = function() {
  $(modal).hide();
}
// When the user clicks anywhere outside of the modal, close it
window.onclick = function(event) {
  if (event.target == modal) {
  $(modal).hide();
  }
}

let for_travel = true
goto_back.addEventListener('click', ()=>{
  event.preventDefault()
  console.log('go back to prev stage')
  if (curstage == goto_event){
    goto_home.click()
  } else if (curstage == goto_travel){
    goto_event.click()
  } else if (curstage == goto_traveler){
    if (for_travel){
      goto_travel.click()
    } else {
      goto_event.click()
    }
  } else if (curstage == goto_submit){
    goto_traveler.click()
  }

  else if (curstage == goto_list){
    goto_home.click()
  } else if (curstage == goto_selected){
    goto_list.click()
  }
})

if (stagenum == 0){
  $('.goto_next_buttons').on('click', event=>{
    event.preventDefault()
    console.log('go back to next stage')
    if (curstage == goto_event){
      if (for_travel){
        goto_travel.click()
      } else {
        goto_traveler.click()
      }
    } else if (curstage == goto_travel){
      goto_traveler.click()
    } else if (curstage == goto_traveler){
      goto_submit.click()
    }
  })
} else {
  $('.goto_next_buttons').hide()
}

$('#event_type').change(event=>{
  console.log('event type changed to', event.target.value)
  if (event.target.value.includes('Online')) {
    $('#travel_required').attr('required', false)
    $('#travel_required').parent().hide()
    for_travel = false
    forTravel()
  } else if ($('#travel_required').val() != '' && $('#travel_required').val() == 0) {
    console.log('asdf', $('#travel_required').val())
    $('#travel_required').attr('required', true)
    $('#travel_required').parent().show()
    for_travel = false
    forTravel()
  } else {
    console.log('asdf', $('#travel_required').val())
    $('#travel_required').attr('required', true)
    $('#travel_required').parent().show()
    for_travel = true
    forTravel()
  }
})
$('#travel_required').change(event=>{
  console.log('travel required changed to', event.target.value)
  if (event.target.value == 0) {
    for_travel = false
    forTravel()
  } else {
    for_travel = true
    forTravel()
  }
})

function forTravel(){
  if(for_travel){
    $('#goto_travel').show()
    $('#travel_verif').show()
    $('#Travel').find('*').prop('required', true)
    $('#Travel').find('*').prop('disabled', false)
    $('#travel_desc').prop('required', false)
  } else {
    $('#goto_travel').hide()
    $('#travel_verif').hide()
    $('#Travel').find('*').prop('required', false)
    $('#Travel').find('*').prop('disabled', true)
    $('#Travel').find('*').val('')
  }
}

documentlist = document.getElementById('documentlist')
selection_documentlist = document.getElementById('selection_documentlist')
documentlist_mirror = document.getElementById('documentlist_mirror')

async function loadDocumentsByIdList(filesys_id_list) {
  // reset list
  for (let i = documentlist.length - 1; i >= 0; i--){
    documentlist.remove(i);
  }
  for (let i = selection_documentlist.length - 1; i >= 0; i--){
    selection_documentlist.remove(i);
  }
  for (let i = documentlist_mirror.length - 1; i >= 0; i--){
    documentlist_mirror.remove(i);
  }

  filesysarg = {
    filesys_id_list:filesys_id_list
  }

  await ipcRenderer.invoke('load-file-list-filesys', filesysarg).then(results =>{
    file_list = results.recordset
    console.log('files', file_list)
    file_list.forEach(file_details =>{
      let id = file_details.filesys_id

      console.log('file id', id)
      document.getElementById('documentation_type').value = ''

      let name = file_details.filesys_name +' ' +new Date(file_details.filesys_time).toUTCString().substring(5, 16)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist.prepend(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      selection_documentlist.prepend(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist_mirror.prepend(option)
    })
  }).catch(err =>{
    console.log('no files found', err.name)
  })
}

function base64ToUint8Array(base64) {
  var raw = atob(base64);
  var uint8Array = new Uint8Array(raw.length);
  for (var i = 0; i < raw.length; i++) {
    uint8Array[i] = raw.charCodeAt(i);
  }
  return uint8Array;
}

// Major Button Logic
goto_event.addEventListener('click', ()=>{
  swapPageValidate('Event', goto_event, 'navy')
})
goto_travel.addEventListener('click', ()=>{
  swapPageValidate('Travel', goto_travel, 'forestgreen')
})
goto_traveler.addEventListener('click', ()=>{
  swapPageValidate('Traveler', goto_traveler, 'sienna')
})
goto_submit.addEventListener('click', ()=>{
  finalValidate('Submit', goto_submit, 'darkred')
})

goto_list.addEventListener('click', ()=>{
  swapPageValidate('List', goto_list, 'navy')
  requestList()
})
goto_selected.addEventListener('click', ()=>{
  finalValidate('Selection', goto_selected, 'darkred')
})

function swapPage(pageName, elmnt, color){
  curstage = elmnt

  window.scrollTo(0,0);
  let tabcontent = document.getElementsByClassName('tabcontent')
  for (i=0; i < tabcontent.length; i++) {
  $(tabcontent[i]).hide()
  }

  let tablinks = document.getElementsByClassName('tablink')
  for (i=0; i < tablinks.length; i++) {
  tablinks[i].style.backgroundColor = ''
  tablinks[i].style.backgroundImage = ''
  }

  let targetpage = document.getElementById(pageName)
  $(targetpage).show()
  targetpage.style.backgroundColor = color
  elmnt.style.backgroundColor = color;
  elmnt.style.backgroundImage = 'none'
}

function makeRecaplistSelectable(){
  let trs = document.querySelectorAll('tr');
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener('mouseup', function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = ' selected', start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,'');
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = ' selected', start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = JSON.parse(this.cells[0].textContent).travel_id

        console.log('selection set', selection.value)
      })
    }
  }
}

const table = document.getElementById('recaplist')
async function requestList(){
  await Promise.resolve(Permissions)

  console.log('request todo-list by stage', PAGE_TARGETVAL)

  selection.value = null
  let trs = document.getElementsByClassName('singleselect')
  for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }

  arg = {
    target_name: 'travel_form_status',
    target_val: PAGE_TARGETVAL
  }

  return ipcRenderer.invoke('load-travel-recap', arg).then(result =>{
    arg = result.recordset.reverse()

    console.log('list', arg)

    for (const entry of arg) {
      let row = table.insertRow()
      row.className = 'singleselect'
      hiddencell = row.insertCell(0)
      hiddencell.textContent = JSON.stringify(entry)
      $(hiddencell).hide();

      if (stagelist[entry.travel_max_stage] > entry.travel_form_status){
        row.insertCell(1).textContent = 'Denied'
      } else {
        row.insertCell(1).textContent = entry.travel_form_status
      }

      row.insertCell(2).textContent = entry.event_type

      row.insertCell(3).textContent = entry.event_name

      row.insertCell(4).textContent = entry.emp_lname +', ' +entry.emp_fname

      if (entry.event_start_date){
        let d1 = new Date(entry.event_start_date)
        row.insertCell(5).textContent = d1.toUTCString().substring(5, 16)
      } else row.insertCell(5).textContent = 'N/A'

      row.insertCell(6).textContent = entry.travel_method
    }

    makeRecaplistSelectable()

    return arg
  }).catch(err=>{
    createAlert('warning', 'Load Recap Error'+err.toString())
    return null
  })
}

document.getElementById('open_selected').addEventListener('click', async event=>{
  event.preventDefault()
  let target = selection.value

  if (target == '') {
    console.log('no selection to load')
  } else {
    console.log('loading', target)
    await requestEntry(target)
  }
})

document.getElementById('pdf_selected').addEventListener('click', async event=>{
  event.preventDefault()
  let target = selection.value

  if (target == '') {
    console.log('no selection to load')
  } else {
    console.log('loading', target)
    // await requestEntry(target)
    await viewTravelReport(2, target)
  }
})

async function requestEntry(id){
  resetall()
  console.log('REQUEST ENTRY !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  // console.log('request todo-selection')
  arg = {
    target_name: 'travel_id',
    target_val: id
  }

  ipcRenderer.invoke('load-travel-recap', arg).then(async result =>{
    if (result && result.recordset && result.recordset[0]) {
      arg = result.recordset[0]
      console.log('loaded', arg)
      swapPage('Selection', goto_selected, 'darkred')
      goto_list.removeAttribute('disabled')
      filesys_id_list = JSON.parse(arg.travel_linked_filesys_ids)
      loadDocumentsByIdList(filesys_id_list)
      parseAndSet(arg)
      await calculateAll(true, for_travel)
    } else {
      if (selection && selection.value && selection.value != ''){
        createAlert('warning', 'Unable to load selection; someone else may have just completed it. Refreshing options list.')
        requestList()
      } else {
        createAlert('warning', 'No RECAP selected. Please select a RECAP from the list and try again.')
      }
    }
  }).catch(err =>{
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
  })
}

function parseAndSet(arg) {
  if (arg.travel_method == 'N/A'){
    for_travel = false
    $('#summary_travel').hide()
  } else {
    for_travel = true
    $('#summary_travel').show()
  }

  self_id = arg.travel_id
  document.getElementById('selection_emp_id').value = arg.emp_id
  document.getElementById('selection_emp_name').value = arg.emp_lname +', ' +arg.emp_fname

  document.getElementById('selection_event_bfst_prov').value = arg.event_bfst_prov
  document.getElementById('selection_event_city').value = arg.event_city
  document.getElementById('selection_event_desc').value = arg.event_desc
  document.getElementById('selection_event_dinn_prov').value = arg.event_dinn_prov
  document.getElementById('selection_event_id').value = arg.event_id
  document.getElementById('selection_event_lnch_prov').value = arg.event_lnch_prov
  document.getElementById('selection_event_name').value = arg.event_name
  document.getElementById('selection_event_provider').value = arg.event_provider
  document.getElementById('selection_event_regis_fee').value = arg.event_regis_fee
  document.getElementById('selection_event_state').value = arg.event_state
  document.getElementById('selection_event_street').value = arg.event_street
  document.getElementById('selection_event_type').value = arg.event_type
  document.getElementById('selection_event_zip_code').value = arg.event_zip_code

  document.getElementById('selection_travel_airfare_estimate').value = arg.travel_airfare_estimate
  document.getElementById('selection_travel_bfst_allowed').value = arg.travel_bfst_allowed
  document.getElementById('selection_travel_bfst_not_cvrd').value = arg.travel_bfst_not_cvrd
  document.getElementById('selection_travel_desc').value = arg.travel_desc
  document.getElementById('selection_travel_dinn_allowed').value = arg.travel_dinn_allowed
  document.getElementById('selection_travel_dinn_not_cvrd').value = arg.travel_dinn_not_cvrd
  document.getElementById('selection_travel_dist_miles').value = arg.travel_dist_miles
  document.getElementById('selection_travel_eligible_lodging_nights').value = arg.travel_eligible_lodging_nights
  document.getElementById('selection_travel_eligible_rental_car_days').value = arg.travel_eligible_rental_car_days
  document.getElementById('selection_travel_form_status').value = arg.travel_form_status
  document.getElementById('selection_travel_has_rental_car').value = arg.travel_has_rental_car
  document.getElementById('selection_travel_id').value = 'TR-'+String(new Date(arg.event_fiscal_year).getUTCFullYear()).substring(2)+'-'+String(arg.event_fy_count).padStart(4,'0')+'-'+String(arg.travel_event_count).padStart(4,'0')
  document.getElementById('selection_travel_lnch_allowed').value = arg.travel_lnch_allowed
  document.getElementById('selection_travel_lnch_not_cvrd').value = arg.travel_lnch_not_cvrd
  document.getElementById('selection_travel_max_reinbursible').value = arg.travel_max_reinbursible
  document.getElementById('selection_travel_method').value = arg.travel_method
  document.getElementById('selection_travel_org_key').value = arg.travel_org_key
  document.getElementById('selection_travel_personal_days').value = arg.travel_personal_days

  document.getElementById('selection_event_regis_date').valueAsDate = new Date(arg.event_regis_date)
  document.getElementById('selection_event_start_date').valueAsDate = new Date(arg.event_start_date)
  document.getElementById('selection_event_end_date').valueAsDate = new Date(arg.event_end_date)
  document.getElementById('selection_travel_depart_datetime').valueAsNumber = new Date(arg.travel_depart_datetime)
  document.getElementById('selection_travel_return_datetime').valueAsNumber = new Date(arg.travel_return_datetime)

  travel_max_stage = arg.travel_max_stage

  const lognotelist = document.getElementById('lognotelist')
  // reset list
  for (let i = lognotelist.length - 1; i >= 0; i--){
    lognotelist.remove(i);
  }

  if (arg.log_notes && arg.log_notes.length > 0) {
    $(document.getElementById('has_notes')).show()
    arg.log_notes.reverse().forEach(log =>{
      // console.log('note', log.log_note)

      let d1 = new Date(log.log_time)
      let name = (log.log_uname)+
      ', ' + d1.toUTCString().substring(5, 16)+
      ': ' + (log.log_note)

      option = document.createElement('option')
      option.value = ''
      option.text = name
      lognotelist.add(option)
    });
  } else {
    $(document.getElementById('has_notes')).hide()
  }
}

function validate(targettab){
  let valid = true

  if(targettab == null){
  // console.log('no previous page')
  }else {
  try {
    // console.log('validating', targettab.id)
  } catch (error) {
    console.log(error)
    return valid
  }
  if (targettab.id == 'Traveler'){
    return verifTraveler()
  }
  else if (targettab.id == 'Submit'){
    return valid
  }
  valid = targettab.checkValidity()
  }
  return valid
}

function swapPageValidate(pageName, elmnt, color){
  let valid = true

  tabcontent = document.getElementsByClassName('tabcontent')
  tablinks = document.getElementsByClassName('tablink')

  targettab = null

  for (i=0; i < tabcontent.length; i++) {
  if ($(tabcontent[i]).show()) {
    targettab = tabcontent[i]
    // targettablink = tablinks[i]
  }
  }

  valid = validate(targettab)

  // FIXME: determine if swap should be declined for invalid
  if (valid) {
  // console.log('valid')
  swapPage(pageName, elmnt, color)
  }
  else{
  // console.log('invalid')
  swapPage(pageName, elmnt, color)
  }
}

async function finalValidate(pageName, elmnt, color) {
  tabcontent = document.getElementsByClassName('tabcontent')
  veriftabs = [document.getElementById('Event'), document.getElementById('Travel'), document.getElementById('Traveler')]
  verifs = [document.getElementById('event_verif'), document.getElementById('travel_verif'), document.getElementById('traveler_verif')]

  let allvalid = true
  let valid = true
  for (i=0; i < veriftabs.length; i++) {
    valid = validate(veriftabs[i])
    allvalid = valid && allvalid

    if (valid){
      verifs[i].classList.add('pass')
      verifs[i].classList.remove('fail')
    }
    else {
      verifs[i].classList.remove('pass')
      verifs[i].classList.add('fail')
    }
  }
  swapPage(pageName, elmnt, color)

  if (allvalid){
    console.log('All Valid!')
    await calculateAll(true, for_travel)
  } else {
    createAlert('info', 'All Forms are Not Yet Completed!')
    await calculateAll(false, for_travel)
  }
}
let documentationModal = document.getElementById('documentationModal');
document.getElementsByClassName('close')[2].onclick = function() {
  $(documentationModal).hide();
}
let receiptModal = document.getElementById('receiptModal')
document.getElementsByClassName('close')[1].onclick = function() {
  $(receiptModal).hide();
}
let travelerModal = document.getElementById('travelerModal')
document.getElementsByClassName('close')[0].onclick = function() {
  $(travelerModal).hide();
}

document.getElementById('traveler_cancel').addEventListener('click', (event)=>{
  console.log('traveler canceled')
  $(travelerModal).hide();
})

const modal_lookup_emp_id = document.getElementById('modal_lookup_emp_id')
document.getElementById('traveler_continue').addEventListener('click', async (event)=>{
  console.log('traveler lookup and continue')

  if (modal_lookup_emp_id.checkValidity()){
    let emp_id = document.getElementById('modal_lookup_emp_id').value
    arg1 = {
      emp_id:emp_id
    }
    addTravelerByID(arg1)
  } else {
    modal_lookup_emp_id.reportValidity()
  }
})

function addTravelerByID(arg1){
  ipcRenderer.invoke('submitUserLookupForm', arg1).then(result =>{
    document.getElementById('modal_modify_emp_id').value = arg1.emp_id

    if (result.recordset.length > 0) {
      arg = result.recordset[0]
      console.log(arg)
      document.getElementById('modal_modify_e_lname').value = arg.emp_lname
      document.getElementById('modal_modify_e_fname').value = arg.emp_fname
      document.getElementById('modal_modify_e_email').value = arg.emp_email
      document.getElementById('modal_modify_supervisor').value = arg.emp_supervisor_id
      if (arg1.modal_retain_orgkey != null && arg1.modal_retain_orgkey != ''){
        document.getElementById('modal_modify_orgkey').value = arg1.modal_retain_orgkey
      } else {
        document.getElementById('modal_modify_orgkey').value = arg.emp_org_key
      }
      startvals = arg
      $(document.getElementById('traveler_modal_lookup')).hide()
      $(document.getElementById('traveler_modal_results')).show()
    } else {
      createAlert('warning', 'Employee not found. Please double check the ID of the traveler, otherwise contact Finance to add them to the list of verified employees')
    }
  }).catch(error=>{
    createAlert('info', 'Employee Lookup Error'+error.toString())
  })
}

document.getElementById('traveler_cancel').addEventListener('click', (event)=>{
  console.log('traveler canceled')
  $(travelerModal).hide();
})
document.getElementById('traveler_back').addEventListener('click', (event)=>{
  event.preventDefault()
  $(document.getElementById('traveler_modal_lookup')).show()
  $(document.getElementById('traveler_modal_results')).hide()
})

const namelist = document.getElementById('namelist')
document.getElementById('traveler_add').addEventListener('click', (event)=>{
  event.preventDefault()
  if(modal_modify_orgkey.checkValidity()){
    for (let i = namelist.length - 1; i >= 0; i--){
      if (JSON.parse(namelist[i].value).emp_id == arg.emp_id) {
        namelist.remove(i);
      }
    }

    // add new traveler
    let name = document.getElementById('modal_modify_e_lname').value +', '+ document.getElementById('modal_modify_e_fname').value +': ' +modal_modify_orgkey.value
    option = document.createElement('option')
    option.value = JSON.stringify({'emp_id':arg.emp_id, 'org_key':document.getElementById('modal_modify_orgkey').value})
    option.text = name
    console.log('add option', option)
    namelist.add(option)
    $(travelerModal).hide();
  } else {
    modal_modify_orgkey.reportValidity()
  }
})

window.onclick = function(event) {
  if (event.target == receiptModal) {
    $(receiptModal).hide();
  } else if (event.target == documentationModal) {
    $(documentationModal).hide();
  } else if (event.target == travelerModal) {
    $(travelerModal).hide();
  }
}

const upload_event_docs = document.getElementById('documentation_fileselect_popup')
upload_event_docs.addEventListener('click', async (event)=>{
  event.preventDefault()
  if (document.getElementById('documentation_type').checkValidity()){
    let path = await ipcRenderer.invoke('open-file-dialog-pdf')

    if (path.canceled){
      console.log('selection canceled')
    } else {
      arg = {
        path:String(path.filePaths[0]),
        filesys_linked_table:'travel_event',
        filesys_linked_id:null,
        filesys_name:document.getElementById('documentation_type').value +'.pdf'
      }
      console.log('arg', arg)

      createAlert('info', 'Uploading File')
      await ipcRenderer.invoke('save-file-to-filesys', arg).then(async result =>{
        console.log('saved file to', result.recordset[0].filesys_id)
        filesys_id_list.push(result.recordset[0].filesys_id)
        createAlert('success', 'File Uploaded!')
        loadDocumentsByIdList(filesys_id_list)
      }).catch(err =>{
        createAlert('error', 'Upload Failed: '+err.toString())
      })
    }
  } else {
    document.getElementById('documentation_type').reportValidity()
  }
})

const viewerEle = document.getElementById('viewer');
documentlist.addEventListener('change', event =>{
  console.log('documentlist clicked', documentlist.value)
  dispReceiptModal(documentlist.value)
  documentlist.value = ''
})
selection_documentlist.addEventListener('change', event =>{
  console.log('selection_documentlist clicked', selection_documentlist.value)
  dispReceiptModal(selection_documentlist.value)
  selection_documentlist.value = ''
})
documentlist_mirror.addEventListener('change', event =>{
  console.log('documentlist_mirror clicked', documentlist_mirror.value)
  dispReceiptModal(documentlist_mirror.value)
  documentlist_mirror.value = ''
})

let startx = 0
let starty = 0
document.getElementById('receiptModal').addEventListener('dragstart', event=>{
  console.log('receipt dragged!', event)
  startx = event.offsetX
  starty = event.offsetY
})
document.getElementById('receiptModal').addEventListener('dragend', event=>{
  console.log('receipt dragged!', event)
  if ((startx - event.offsetX < 50 && starty - event.offsetY < 50) && (startx - event.offsetX > -50 && starty - event.offsetY > -50)){
    createAlert('info', 'If you drag the receipt further, it will become a popup')
  } else {
    createAlert('info', 'Receipt has been dragged, creating popup')
    $(receiptModal).hide()
    offset = 0
    previframe.forEach(frame=>{
      options = `width=700, height=800, x=${25+offset}, y=${25+offset}
      alwaysOnTop=true,`
      console.log('opening with options', options)
      newwin = window.open(frame.src, '', options)
      windowlist.push(newwin)
      offset += 5
    })
    if(windowlist.length > 0){
      windowlist[0].focus()
    }
  }
})
document.getElementById('viewer').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})
document.getElementById('near_close').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})

async function dispReceiptModal(file_id){
  previframe.forEach(frame=>{
    try{
      viewerEle.removeChild(frame)
    } catch{
      console.log('malformed frame', frame, 'could not be removed')
    }
  })
  previframe = []
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';

  createAlert('info', 'Loading File')
  arg = {
    filesys_id:file_id
  }

  await ipcRenderer.invoke('load-file-filesys', arg).then(async result=>{
    Promise.resolve(result)
    loaded_file = result.recordset[0]
    console.log('loaded file', loaded_file)
    $(receiptModal).show();
    viewerEle.innerHTML = '';
    const iframe = document.createElement('iframe')

    // OPENING PDF CODE
    pdfData = base64ToUint8Array(loaded_file.filesys_content);
    targeturl = createObjectURL(new Blob([pdfData], {type: 'file'}))

    // SHARED CODE
    let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

    iframe.src = viewerUrl
    viewerEle.appendChild(iframe);
    previframe.push(iframe)
  }).catch(err=>{
    createAlert('error', 'File could not be Loaded: ' +String(err))
  })
}

document.getElementById('upload_documentation_button').addEventListener('click', ()=>{
  event.preventDefault()
  $(documentationModal).show();
})
document.getElementById('selection_upload_documentation_button').addEventListener('click', ()=>{
  event.preventDefault()
  $(documentationModal).show();
})

document.getElementById('close_documentationModal').addEventListener('click', ()=>{
  event.preventDefault()
  $(documentationModal).hide();
})

target = null
document.getElementById('lookup_traveler').addEventListener('click', ()=>{
  event.preventDefault()
  modal_lookup_emp_id.value = ''
  target = null
  $(travelerModal).show();
  $(document.getElementById('traveler_modal_lookup')).show()
  $(document.getElementById('traveler_modal_results')).hide()
})

document.getElementById('edit_traveler').addEventListener('click', ()=>{
  event.preventDefault()
  modal_lookup_emp_id.value = ''
  try{
    target = JSON.parse(namelist.value)
    namelist.remove(namelist.selectedIndex)
    $(travelerModal).show();
    console.log('target', target)
    if (target != null){
      arg1 = {
        emp_id:target.emp_id,
        modal_retain_orgkey:target.org_key
      }
    } else {
      createAlert('Invalid Traveler Detected; Removing')
    }
    addTravelerByID(arg1)
  }catch{
    target = null
    createAlert('error', 'Must Select a Traveler to Edit their Information')
  }
})

document.getElementById('remove_traveler').addEventListener('click', ()=>{
  event.preventDefault()
  modal_lookup_emp_id.value = ''
  if (namelist.value){namelist.remove(namelist.selectedIndex)}
})

async function calculateAll(allready, for_travel){
  console.log('performing all form calculations')

  if (stagenum == 0){
    let allvals = {
      event_type:document.getElementById('event_type').value,
      event_regis_fee:document.getElementById('event_regis_fee').value,
      event_regis_date:document.getElementById('event_regis_date').valueAsDate,
      event_start_date:document.getElementById('event_start_date').valueAsDate,
      event_end_date:document.getElementById('event_end_date').valueAsDate,
      event_name:document.getElementById('event_name').value,
      event_desc:document.getElementById('event_desc').value,
      event_provider:document.getElementById('event_provider').value,
      event_street:document.getElementById('event_street').value,
      event_city:document.getElementById('event_city').value,
      event_state:document.getElementById('event_state').value,
      event_zip_code:document.getElementById('event_zip_code').value,
      event_bfst_prov:document.getElementById('event_bfst_prov').value,
      event_lnch_prov:document.getElementById('event_lnch_prov').value,
      event_dinn_prov:document.getElementById('event_dinn_prov').value,

      travel_method:document.getElementById('travel_method').value,
      travel_dist_miles:document.getElementById('travel_dist_miles').value,
      travel_airfare_estimate:document.getElementById('travel_airfare_estimate').value,
      travel_has_rental_car:document.getElementById('travel_has_rental_car').value,
      travel_desc:document.getElementById('travel_desc').value,
      travel_depart_datetime:new Date(document.getElementById('travel_depart_datetime').valueAsNumber),
      travel_return_datetime:new Date(document.getElementById('travel_return_datetime').valueAsNumber)
    }

    result = await travelCalculate(allvals, for_travel)

    console.log("calculate results", result)

    if (result) {
      // prepare values for submit
      travel_personal_days = result.travel_personal_days
      travel_eligible_lodging_nights = result.travel_eligible_lodging_nights
      travel_eligible_rental_car_days = result.travel_eligible_rental_car_days
      travel_max_reinbursible = result.travel_max_reinbursible
      travel_bfst_allowed = result.travel_bfst_allowed
      travel_lnch_allowed = result.travel_lnch_allowed
      travel_dinn_allowed = result.travel_dinn_allowed
      travel_bfst_not_cvrd = result.travel_bfst_not_cvrd
      travel_lnch_not_cvrd = result.travel_lnch_not_cvrd
      travel_dinn_not_cvrd = result.travel_dinn_not_cvrd
      travel_form_status = 'New Travel'

      // output values to summary table
      document.getElementById('disp_eventlen').value = result.disp_eventlen
      document.getElementById('disp_triplen').value = result.disp_triplen
      document.getElementById('travel_personal_days').value = result.travel_personal_days
      document.getElementById('travel_eligible_lodging_nights').value = result.travel_eligible_lodging_nights
      document.getElementById('travel_eligible_rental_car_days').value = result.travel_eligible_rental_car_days
      document.getElementById('travel_max_reinbursible').value = result.travel_max_reinbursible
      document.getElementById('t_dist_bfst_prov').value = document.getElementById('event_bfst_prov').value
      document.getElementById('t_dist_lnch_prov').value = document.getElementById('event_lnch_prov').value
      document.getElementById('t_dist_dinn_prov').value = document.getElementById('event_dinn_prov').value
      document.getElementById('travel_bfst_allowed').value = result.travel_bfst_allowed
      document.getElementById('travel_lnch_allowed').value = result.travel_lnch_allowed
      document.getElementById('travel_dinn_allowed').value = result.travel_dinn_allowed
      document.getElementById('travel_bfst_not_cvrd').value = result.travel_bfst_not_cvrd
      document.getElementById('travel_lnch_not_cvrd').value = result.travel_lnch_not_cvrd
      document.getElementById('travel_dinn_not_cvrd').value = result.travel_dinn_not_cvrd
      // console.log('calculations complete')
      readyToSubmit = allready
      console.log('calculations done, submit ready:', readyToSubmit)
    } else {
      readyToSubmit = false
    }
  } else {
    let allvals = {
      event_type:document.getElementById('selection_event_type').value,
      event_regis_fee:document.getElementById('selection_event_regis_fee').value,
      event_regis_date:document.getElementById('selection_event_regis_date').valueAsDate,
      event_start_date:document.getElementById('selection_event_start_date').valueAsDate,
      event_end_date:document.getElementById('selection_event_end_date').valueAsDate,
      event_name:document.getElementById('selection_event_name').value,
      event_desc:document.getElementById('selection_event_desc').value,
      event_provider:document.getElementById('selection_event_provider').value,
      event_street:document.getElementById('selection_event_street').value,
      event_city:document.getElementById('selection_event_city').value,
      event_state:document.getElementById('selection_event_state').value,
      event_zip_code:document.getElementById('selection_event_zip_code').value,
      event_bfst_prov:document.getElementById('selection_event_bfst_prov').value,
      event_lnch_prov:document.getElementById('selection_event_lnch_prov').value,
      event_dinn_prov:document.getElementById('selection_event_dinn_prov').value,
      travel_method:document.getElementById('selection_travel_method').value,
      travel_dist_miles:document.getElementById('selection_travel_dist_miles').value,
      travel_airfare_estimate:document.getElementById('selection_travel_airfare_estimate').value,
      travel_has_rental_car:document.getElementById('selection_travel_has_rental_car').value,
      travel_desc:document.getElementById('selection_travel_desc').value,
      travel_depart_datetime:new Date(document.getElementById('selection_travel_depart_datetime').valueAsNumber),
      travel_return_datetime:new Date(document.getElementById('selection_travel_return_datetime').valueAsNumber)
    }
    result = travelCalculate(allvals, for_travel)

    if (result) {
      // prepare values for submit
      travel_personal_days = result.travel_personal_days
      travel_eligible_lodging_nights = result.travel_eligible_lodging_nights
      travel_eligible_rental_car_days = result.travel_eligible_rental_car_days
      travel_max_reinbursible = result.travel_max_reinbursible
      travel_bfst_allowed = result.travel_bfst_allowed
      travel_lnch_allowed = result.travel_lnch_allowed
      travel_dinn_allowed = result.travel_dinn_allowed
      travel_bfst_not_cvrd = result.travel_bfst_not_cvrd
      travel_lnch_not_cvrd = result.travel_lnch_not_cvrd
      travel_dinn_not_cvrd = result.travel_dinn_not_cvrd
      travel_form_status = 'New Travel'

      // output values to summary table
      document.getElementById('selection_disp_eventlen').value = result.disp_eventlen
      document.getElementById('selection_disp_triplen').value = result.disp_triplen
      document.getElementById('selection_travel_personal_days').value = result.travel_personal_days
      document.getElementById('selection_travel_eligible_lodging_nights').value = result.travel_eligible_lodging_nights
      document.getElementById('selection_travel_eligible_rental_car_days').value = result.travel_eligible_rental_car_days
      document.getElementById('selection_travel_max_reinbursible').value = result.travel_max_reinbursible
      document.getElementById('selection_t_dist_bfst_prov').value = document.getElementById('selection_event_bfst_prov').value
      document.getElementById('selection_t_dist_lnch_prov').value = document.getElementById('selection_event_lnch_prov').value
      document.getElementById('selection_t_dist_dinn_prov').value = document.getElementById('selection_event_dinn_prov').value
      document.getElementById('selection_travel_bfst_allowed').value = result.travel_bfst_allowed
      document.getElementById('selection_travel_lnch_allowed').value = result.travel_lnch_allowed
      document.getElementById('selection_travel_dinn_allowed').value = result.travel_dinn_allowed
      document.getElementById('selection_travel_bfst_not_cvrd').value = result.travel_bfst_not_cvrd
      document.getElementById('selection_travel_lnch_not_cvrd').value = result.travel_lnch_not_cvrd
      document.getElementById('selection_travel_dinn_not_cvrd').value = result.travel_dinn_not_cvrd
      // console.log('calculations complete')
      readyToSubmit = allready
      console.log('calculations done, submit ready:', readyToSubmit)
    } else {
      readyToSubmit = false
    }
  }
}

function verifTraveler(){
  if (namelist.length >= 1){
    return true
  } else {
    return false
  }
}

// TODO: FIXME: travel_method and travel_has_rental_car are both being reset to '' before the query can execute
document.getElementById('submit_form').addEventListener('click', function(){
  event.preventDefault()
  if (readyToSubmit){
    console.log('document', document.getElementById('travel_method').value)

    let names = []
    for (let i = namelist.length - 1; i >= 0; i--){
      names.push(JSON.parse(namelist[i].value))
    }
    let allvals = {
      event_type:document.getElementById('event_type').value,
      event_regis_fee:document.getElementById('event_regis_fee').value,
      event_regis_date:new Date(document.getElementById('event_regis_date').value),
      event_start_date:new Date(document.getElementById('event_start_date').value),
      event_end_date:new Date(document.getElementById('event_end_date').value),
      event_name:document.getElementById('event_name').value,
      event_desc:document.getElementById('event_desc').value,
      event_provider:document.getElementById('event_provider').value,
      event_street:document.getElementById('event_street').value,
      event_city:document.getElementById('event_city').value,
      event_state:document.getElementById('event_state').value,
      event_zip_code:document.getElementById('event_zip_code').value,
      event_bfst_prov:document.getElementById('event_bfst_prov').value,
      event_lnch_prov:document.getElementById('event_lnch_prov').value,
      event_dinn_prov:document.getElementById('event_dinn_prov').value,

      travel_method:document.getElementById('travel_method').value,
      travel_dist_miles:document.getElementById('travel_dist_miles').value,
      travel_airfare_estimate:document.getElementById('travel_airfare_estimate').value,
      travel_has_rental_car:document.getElementById('travel_has_rental_car').value,
      travel_desc:document.getElementById('travel_desc').value,

      travel_depart_datetime:new Date(document.getElementById('travel_depart_datetime').valueAsNumber),
      travel_return_datetime:new Date(document.getElementById('travel_return_datetime').valueAsNumber),

      travelers:names,

      travel_personal_days:travel_personal_days,
      travel_eligible_lodging_nights:travel_eligible_lodging_nights,
      travel_eligible_rental_car_days:travel_eligible_rental_car_days,
      travel_max_reinbursible:travel_max_reinbursible,
      travel_bfst_allowed:travel_bfst_allowed,
      travel_lnch_allowed:travel_lnch_allowed,
      travel_dinn_allowed:travel_dinn_allowed,
      travel_bfst_not_cvrd:travel_bfst_not_cvrd,
      travel_lnch_not_cvrd:travel_lnch_not_cvrd,
      travel_dinn_not_cvrd:travel_dinn_not_cvrd,
      travel_form_status:travel_form_status,

      travel_linked_filesys_ids:JSON.stringify(filesys_id_list),

      log_note:document.getElementById('event_reason_justify').value
    }

    if(!for_travel){
      allvals.travel_depart_datetime=allvals.event_start_date
      allvals.travel_return_datetime=allvals.event_end_date

      allvals.travel_method='N/A'
      allvals.travel_dist_miles=0
      allvals.travel_airfare_estimate=0
      allvals.travel_has_rental_car=0
      allvals.travel_desc='N/A'
    }

    // strange bug solved by REMOVING async/await; somehow the await was not triggering properly, allowing resetall to reset the select boxes (but not the input boxes) in the passes allvals before db could execute them. This doesn't make ANY sense, but it is nonetheless what must have been happening
    ipcRenderer.invoke('submitNewTravelForm', allvals).then(results=>{
      console.log('results', results)
      createAlert('success', 'New Travel Request Submitted!')
      if (stagenum == 0){
        resetall()
        goto_event.click()
      } else {
        goto_list.click()
      }
    }).catch(error=>{
      createAlert('error', 'New Travel Request Failed'+error.toString())
    })
  } else {
    goto_submit.click()
  }
})

document.getElementById("decline_selected").addEventListener('click', ()=>{
  event.preventDefault()
  processTravelRequest(false)
})

document.getElementById("approve_selected").addEventListener('click', ()=>{
  event.preventDefault()
  processTravelRequest(true)
})

function processTravelRequest(approve){
  if (self_id != null){
    log_note = document.getElementById('log_note')
    log_note_value = log_note.value
    arg = {
      travel_id:self_id
    }

    if(approve){
      arg.travel_form_status = stagelist[stagenum+1]
      arg.travel_max_stage = Math.max(stagenum+1, travel_max_stage)
      if (log_note_value != ''){
        arg.log_note = log_note_value
      }
      arg.log_desc = 'Approve'

      ipcRenderer.invoke('modify-single-travel-recap', arg).then( async result =>{
        console.log('MODIFY RESULT', result)
        await viewTravelReport(2, arg.travel_id)
        goto_list.click()
      }).catch(err =>{
        createAlert('danger', 'Travel Update Failed! ' +String(err))
      })
    }else if(log_note_value != ''){
      if (stagenum > 1){
        arg.travel_form_status = stagelist[1]
      } else {
        arg.travel_form_status = stagelist[0]
      }
      arg.log_note = log_note_value
      arg.log_desc = 'Deny'

      ipcRenderer.invoke('modify-single-travel-recap', arg).then( async result =>{
        console.log('MODIFY RESULT', result)
        await viewTravelReport(2, arg.travel_id)
        goto_list.click()
      }).catch(err =>{
        createAlert('danger', 'Travel Update Failed! ' +String(err))
      })
    }else{
      createAlert('error', 'If Denying, Must Leave a Comment Explaining why.')
      log_note.focus()
    }
  } else {
    createAlert('Form was loaded improperly and cannot be updated. Returning to list.')
    goto_list.click()
  }
}

async function viewTravelReport(mode=0, id){
  console.log('REQUEST REPORT !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  arg = {
    target_name: 'travel_id',
    target_val: id
  }

  await ipcRenderer.invoke('load-travel-recap', arg).then(async result =>{
    if (result && result.recordset && result.recordset[0]) {
      arg = result.recordset[0]
      console.log('REPORT DATA LOADED', arg)
      try{
        $(receiptModal).show();
        previframe.forEach(frame=>{
          try{
            viewerEle.removeChild(frame)
          } catch{
            console.log('malformed frame', frame, 'could not be removed')
          }
        })
        previframe = []
        windowlist.forEach(win=>{
          win.close()
        })
        windowlist = []

        viewerEle.innerHTML = '';
      } catch (err){
        createAlert('PDF ERROR'+err.toString())
      }

      if (mode == 1){
        try {
          file_list = JSON.parse(arg.travel_linked_filesys_ids)
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
              return true
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded ' +String(err))
              return false
            })
          } else {
            console.log('No reciepts to display!')
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
          return false
        }
      } else if (mode == 2){
        try {
          targeturl = await makeTravelPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
        try {
          file_list = JSON.parse(arg.travel_linked_filesys_ids)
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "file"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded')
            })
          } else {
            console.log('No reciepts to display!')
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
      } else {
        try {
          targeturl = await makeTravelPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
          return true
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
          return false
        }
      }
    } else {
      if (id && id != ''){
        createAlert('warning', "Unable to load report for id " +String(id) +"; Something must have gone wrong. Refreshing options list.")
        await requestList()
        return false
      } else {
        createAlert('warning', "Report ID to load not specified. Report Load Cancelled")
        return false
      }
    }
  }).catch(err =>{
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
    return false
  })
}

async function loadAllFileContents(file_list){
  filesysarg = {
    filesys_linked_table:'travel_recap',
    filesys_id_list:file_list
  }

  console.log('loading list', file_list)
  return await ipcRenderer.invoke('loadAllFileContents', filesysarg)
}

function resetall(){
  $('input').val('')
  $('select').val('')
  for (let i = documentlist.length - 1; i >= 0; i--){
    documentlist.remove(i);
  }
  for (let i = selection_documentlist.length - 1; i >= 0; i--){
    selection_documentlist.remove(i);
  }
  for (let i = documentlist_mirror.length - 1; i >= 0; i--){
    documentlist_mirror.remove(i);
  }
  for (let i = namelist.length - 1; i >= 0; i--){
    namelist.remove(i);
  }
  travel_max_stage = 0
  self_id = null

  travel_personal_days = 0
  travel_eligible_lodging_nights = 0
  travel_eligible_rental_car_days = 0
  travel_max_reinbursible = 0
  travel_bfst_allowed = 0
  travel_lnch_allowed = 0
  travel_dinn_allowed = 0
  travel_bfst_not_cvrd = 0
  travel_lnch_not_cvrd = 0
  travel_dinn_not_cvrd = 0
  travel_form_status = 'New Travel'
  readyToSubmit = false
}

// at end of page loading
if (stagenum == 0){
  goto_event.click()
} else {
  goto_list.click()
  if (stagenum == 1){
    document.getElementById('decline_selected').textContent = document.getElementById('decline_selected').textContent.replace('Deny', 'Cancel')
  }
}