const {ipcRenderer} = require('electron')
const Constants = ipcRenderer.invoke('getConstants')
const {createAlert} = require("../utilities/alert_box")

async function travelCalculate(arg, for_travel) {
    await Promise.resolve(Constants)
    // console.log('calculate', arg)

    console.log('for_travel', for_travel)
    // target vars
    let travel_personal_days = 0
    let travel_eligible_lodging_nights = 0
    let travel_eligible_rental_car_days = 0
    let travel_max_reinbursible = 0
    let travel_bfst_allowed = 0
    let travel_lnch_allowed = 0
    let travel_dinn_allowed = 0
    let travel_bfst_not_cvrd = 0
    let travel_lnch_not_cvrd = 0
    let travel_dinn_not_cvrd = 0

    let eventlen = 0
    let triplen = 0

    let event_fiscal_year = null

    // console.log('travel_depart_datetime', arg.travel_depart_datetime)
    // console.log('travel_return_datetime', arg.travel_return_datetime)
    // console.log('event_start_date', arg.event_start_date)
    // console.log('event_end_date', arg.event_end_date)

    if (arg.event_end_date - arg.event_start_date < 0){
        createAlert('error', 'Error in Event: Event start date must be before Event end date.')
        return false
    } else {
        eventlen = Math.max(
            Math.floor(
                (Date.parse(arg.event_end_date) - Date.parse(arg.event_start_date)) / 60000 / 60 / 24), 0)
    }

    if (for_travel) {
        // exit early if invalid dates
        if (arg.travel_return_datetime - arg.travel_depart_datetime >= 0){
            if (arg.event_end_date - arg.event_start_date >= 0){
                console.log('travel leave before event start', arg.travel_depart_datetime - arg.event_start_date >= 0 )
                console.log('event end before travel return', arg.travel_return_datetime - arg.event_end_date  >= 0 )
            } else {
                createAlert('error', 'Error in Event: Event start date must be before Event end date.')
                return false
            }

        } else {
            createAlert('error', 'Error in Travel: Travel must depart before Travel return.')
            return false
        }

        triplen = Math.max(
            Math.floor(
                (Date.parse(arg.travel_return_datetime) - Date.parse(arg.travel_depart_datetime)) / 60000 / 60 / 24), 0)
        personal_pre_days = Math.max(
            Math.floor(
                (Date.parse(arg.event_start_date) - Date.parse(arg.travel_depart_datetime)) / 60000 / 60 / 24), 0)
        personal_post_days = Math.max(
            Math.floor(
                (Date.parse(arg.travel_return_datetime) - Date.parse(arg.event_end_date)) / 60000 / 60 / 24), 0)

        console.log('eventlen', eventlen)
        console.log('triplen', triplen)
        console.log('personal_pre_days', personal_pre_days)
        console.log('personal_post_days', personal_post_days)

        // DONE: simple daycount
        travel_personal_days = Math.max(0, personal_pre_days-1) + Math.max(0, personal_post_days-1)

        // DONE: lodging & rental
        travel_eligible_lodging_nights = Math.max(0, triplen - travel_personal_days)
        travel_eligible_rental_car_days = travel_eligible_lodging_nights + 1

        // DONE: travel reinbursement
        console.log('est airfare', parseFloat(arg.travel_airfare_estimate) || 0)
        console.log('dist mi', parseFloat(arg.travel_dist_miles) || 0)
        console.log('fuel rate', parseFloat(Constants.travel_gallon_fuel_rate) || 0)
        travel_max_reinbursible = Math.max(0, Math.min(parseFloat(arg.travel_airfare_estimate) || 0, parseFloat(arg.travel_dist_miles) || 0 * parseFloat(Constants.travel_gallon_fuel_rate) || 0))

        console.log("MAX REINB", travel_max_reinbursible, 'MAX', Math.max(0,1), 'MIN', Math.min(0,1))

        // DONE: breakfasts
        let bonus_meal = 0
        if (arg.t_start_time <= Constants.travel_depart_breakfast) {
            bonus_meal += 1
        }
        if (arg.t_end_time <= Constants.travel_return_breakfast) {
            bonus_meal -= 1
        }
        travel_bfst_allowed = Math.max(travel_eligible_lodging_nights + bonus_meal - arg.event_bfst_prov, 0)
        travel_bfst_not_cvrd = Math.max(travel_personal_days - bonus_meal - arg.event_bfst_prov, 0)

        // DONE: lunches
        bonus_meal = 0
        if (arg.t_start_time <= Constants.travel_depart_lunch) {
            bonus_meal += 1
        }
        if (arg.t_end_time <= Constants.travel_return_lunch) {
            bonus_meal -= 1
        }
        travel_lnch_allowed = Math.max(travel_eligible_lodging_nights + bonus_meal - arg.event_lnch_prov, 0)
        travel_lnch_not_cvrd = Math.max(travel_personal_days - bonus_meal - arg.event_lnch_prov, 0)

        // DONE: dinners
        bonus_meal = 0
        if (arg.t_start_time <= Constants.travel_depart_dinner) {
            bonus_meal += 1
        }
        if (arg.t_end_time <= Constants.travel_return_dinner) {
            bonus_meal -= 1
        }
        travel_dinn_allowed = Math.max(travel_eligible_lodging_nights + bonus_meal - arg.event_dinn_prov, 0)
        travel_dinn_not_cvrd = Math.max(travel_personal_days - bonus_meal - arg.event_dinn_prov, 0)
    }

    // result
    result = {}
    result.disp_eventlen = eventlen
    result.disp_triplen = triplen
    result.travel_personal_days = travel_personal_days
    result.travel_eligible_lodging_nights = travel_eligible_lodging_nights
    result.travel_eligible_rental_car_days = travel_eligible_rental_car_days
    result.travel_max_reinbursible = travel_max_reinbursible
    result.travel_bfst_allowed = travel_bfst_allowed
    result.travel_lnch_allowed = travel_lnch_allowed
    result.travel_dinn_allowed = travel_dinn_allowed
    result.travel_bfst_not_cvrd = travel_bfst_not_cvrd
    result.travel_lnch_not_cvrd = travel_lnch_not_cvrd
    result.travel_dinn_not_cvrd = travel_dinn_not_cvrd

    console.log('travelformulas result:', result)
    return (result)
}

module.exports = travelCalculate