// https://www.w3schools.com/tags/tag_template.asp
// https://www.w3schools.com/howto/howto_js_alert.asp

function createAlert(input1=null, input2=null, timeout=4000) {
  if (input1 && input2) {
    type = String(input1).toLowerCase()
    message = input2
  } else if (input1) {
    type = ''
    message = input1
  } else {
    type = ''
    message = ''
  }

  try{
    timeout = Math.max(parseInt(timeout), 100)
  }catch{
    timeout = 4000
  }

  console.log('ALERT', input1, input2)

  let template = document.getElementById('alert_template')
  console.log('template', template)
  //get the DIV element from the template:
  dangerbox = template.content.querySelector("div.alert.danger");
  successbox = template.content.querySelector("div.alert.success");
  warningbox = template.content.querySelector("div.alert.warning");
  infobox = template.content.querySelector("div.alert.info");

  if (type == '' || type == 'danger' || type == 'error') {
    target = document.importNode(dangerbox, true)
  } else if (type == 'success') {
    target = document.importNode(successbox, true)
  } else if (type == 'warning') {
    target = document.importNode(warningbox, true)
  } else {
    target = document.importNode(infobox, true)
  }

  if (message != '') {
    target.querySelector('div.alert_content').textContent = message
  }

  // TODO: make boxes stack vertically rather than overlap in corner
  // note: async doesn't seem to make a difference here
  // most likely somehow the function being applied replaces it's previous incarnation rather than threading.
  // target.setTimeout(function(){
  //   const div = target;
  //   div.style.opacity = "0";
  //   setTimeout(function(){div.remove()}, 600);
  // }, 6000);

  target.querySelector('.closebtn').onclick = function(){
    const div = this.parentElement;
    div.style.opacity = "0";
    setTimeout(function(){div.remove()}, 600);
  }

  const item = document.body.appendChild(target)

  setTimeout(function(){ item.style.opacity = "0";
  setTimeout(function(){ item.remove()}, 600);}, timeout);
}

module.exports = {createAlert}