const PDFDocument = require('pdfkit');
const blobStream  = require('blob-stream');

// FIXME: ensure this stays up to date
const stagelist = ['New Txn', 'Submitted', 'Approved', 'Processed', 'Reconciled']
const travel_stagelist = ['Cancelled', 'New Travel', 'Submitted', 'Manager Processed', 'Finance Processed', 'Division Head Processed', 'Confirmed']

const docwidth = 610
const docheight = 775
const fontsize = 13
const margin = 25
const spacing = 1.5
const sidespacing = 3


const recapfontcolor = '#0a25d1'
const recapbgcolor = '#d3f6fa'
const travelfontcolor = '#445626'
const travelbgcolor = '#d1fadf'
const equipmentfontcolor = '#d10a25'
const equipmentbgcolor = '#fad7d3'

// https://medium.com/dailyjs/rewriting-javascript-converting-an-array-of-objects-to-an-object-ec579cafbfc7
const arrayToObject = (arr, keyField) =>
  Object.assign({}, ...arr.map(item => ({[item[keyField]]: item})))

//  _____  _   _  _______  ______  _____   ______        _____  ______
// |_   _|| \ | ||__   __||  ____||  __ \ |  ____|/\    / ____||  ____|
//   | |  |  \| |   | |   | |__   | |__) || |__  /  \  | |     | |__
//   | |  | . ` |   | |   |  __|  |  _  / |  __|/ /\ \ | |     |  __|
//  _| |_ | |\  |   | |   | |____ | | \ \ | |  / ____ \| |____ | |____
// |_____||_| \_|   |_|   |______||_|  \_\|_| /_/    \_\\_____||______|
function Docinterface(doc, x, y, docwidth, docheight, margin, fontsize, sidespacing, spacing, fontcolor, bgcolor){
  this.doc=doc,
  this.x= x,
  this.y= y,
  this.remain = docwidth-margin-margin,
  this.end = function (){
    this.doc.end()
  },
  this.addPage = function addPage(){
    this.doc.addPage()
    this.y=this.doc.y
    this.x=margin
    this.remain = docwidth-margin-margin
  }
  this.addEntry = function addEntry(text='', options={}){
    if (!isNaN(options.width)){
      width = Math.min(options.width, this.remain)
    } else {
      width = this.remain
    }

    if(options.footer){this.y = docheight-margin}
    else if (this.y >= docheight-margin-margin){
      this.doc.addPage()
      this.y=this.doc.y
    }

    if (options.content){
      this.doc
      .font('Helvetica-Bold', fontsize)
      .fillColor(fontcolor)
      .rect(this.x, this.y-sidespacing-1, width-sidespacing, fontsize+sidespacing+1)
      .fill(bgcolor)
      .fillColor(fontcolor)
      .text(text, this.x+sidespacing, this.y, {width:'('+String(width-sidespacing-sidespacing)+')'})
    } else if (options.h1) {
      let h1fontsize = 30
      this.doc
      .font('Helvetica-Bold', h1fontsize)
      .rect(this.x, this.y-sidespacing-1, width-sidespacing, h1fontsize+sidespacing-4)
      .fill(bgcolor)
      .fillColor(fontcolor)
      .text(text, {align:'center'})
    } else if (options.h2) {
      let h2fontsize = 25
      this.doc
      .font('Helvetica', h2fontsize)
      .rect(this.x, this.y, width, h2fontsize+sidespacing)
      .fill('#ffffff')
      .fillColor('#000000')
      .text(text, {align:'center'})
    } else if (options.h3) {
      let h3fontsize = fontsize+5
      this.doc
      .font('Helvetica-Bold', h3fontsize)
      .rect(this.x, this.y-sidespacing-1, width-sidespacing, h3fontsize+sidespacing+1)
      .fill('#ffffff')
      .fillColor('#000000')
      .text(text, this.x, this.y, {width:'('+this.remain+'-sidespacing)'})
    }else if (options.n1){
      this.doc
      .font('Helvetica-Bold', fontsize)
      .fillColor(fontcolor)
      .rect(this.x, this.y-sidespacing-1, width-sidespacing, fontsize+sidespacing+1)
      .fill(bgcolor)
      .fillColor(fontcolor)
      .text(text, this.x+sidespacing, this.y)
      //.text(text, {align:'left'})
    } else if (options.center) {
      this.doc
      .font('Helvetica', fontsize)
      .fillColor('#000000')
      .text(text, {align:'center'})
    } else {
      this.doc
      .font('Helvetica', fontsize)
      .rect(this.x, this.y-sidespacing, width, fontsize+sidespacing)
      .fill('#ffffff')
      .fillColor('#000000')
      .text(text, this.x, this.y, {width:'('+width+'-sidespacing)'})
    }

    if (width >= this.remain){
      if(!options.h1 && !options.h2 && !options.center){ //align:center auto-increments line
        this.doc.moveDown(spacing)
      }
      this.y=this.doc.y
      this.x=margin
      this.remain = docwidth-margin-margin
    } else {
      this.remain-=width;
      this.x+=width
    }
  }
}


// // documentation: https://pdfkitdoc.org/indexdoc.html
//   _____    _____            _____   _____
//  |  __ \  / ____|    /\    |  __ \ |  __ \
//  | |__) || |        /  \   | |__) || |  | |
//  |  ___/ | |       / /\ \  |  _  / | |  | |
//  | |     | |____  / ____ \ | | \ \ | |__| |
//  |_|      \_____|/_/    \_\|_|  \_\|_____/
function makePDF(arg) {
  var doc = new PDFDocument({
    margins: {
      top: margin,
      bottom: margin,
      left: margin,
      right: margin
    }
  });
  var stream = doc.pipe(blobStream());

  recapspacinglinecount = (arg.log_notes?arg.log_notes.length:1)+(arg.sub_items?arg.sub_items.length:1)

  console.log('linecount', recapspacinglinecount)
  recapfontsize = fontsize

  if (recapspacinglinecount < 3){
    recapspacing = spacing+0.5
  } else if (recapspacinglinecount < 5){
    recapspacing = spacing+(3/4)
  } else if (recapspacinglinecount < 7){
    recapspacing = spacing+(1/2)
  } else if (recapspacinglinecount < 10){
    recapspacing = spacing+(1/4)
  } else if (recapspacinglinecount < 14){
    recapspacing = spacing
  } else if (recapspacinglinecount < 17){
    recapspacing = spacing-(1/8)
  } else {
    recapspacing = spacing-(1/6)
    recapfontsize = fontsize - 1
  }

  docinterface = new Docinterface(doc, doc.x, doc.y, docwidth, docheight, margin, recapfontsize, sidespacing, recapspacing, recapfontcolor, recapbgcolor)

  docinterface.addEntry('Charleston County - Public Works Department', {h2:true})

  if (!arg.txn_fy_count || arg.txn_fy_count == null){
    text = 'NEW TXN - NO RECAP YET'
  } else {
    text = 'PCARD RECAP ' +'PC-' +String(new Date(arg.txn_fiscal_year).getUTCFullYear()).slice(-2) +'-' +arg.txn_card_num +'-' +(arg.txn_fy_count?String(arg.txn_fy_count).padStart(4, '0'):'NEW')
  }
  docinterface.addEntry(text, {h1:true})
  docinterface.addEntry('', {center:true})


  docinterface.addEntry('Cardholder:', {width:75})
  docinterface.addEntry(arg.emp_lname +', ' +arg.emp_fname, {content:true, width:150})
  docinterface.addEntry(arg.txn_card_num, {content:true, width:60})

  docinterface.addEntry('Billing Cycle:', {width:90})
  docinterface.addEntry(new Date(arg.txn_bill_cycle).toUTCString().substring(8, 16), {content:true, width:90})

  docinterface.addEntry('FY:', {width:45})
  docinterface.addEntry(new Date(arg.txn_fiscal_year).getUTCFullYear(), {content:true})

  docinterface.addEntry('Purchase:', {width:75})
  docinterface.addEntry(arg.txn_vendor_name, {content:true, width:210})
  docinterface.addEntry(new Date(arg.txn_purchase_date).toUTCString().substring(5, 16), {content:true, width:120})
  docinterface.addEntry('$'+parseFloat(arg.txn_amt).toFixed(2), {content:true})

  docinterface.addEntry('Statement Details:', {width:120})
  docinterface.addEntry(arg.txn_id, {content:true, width:165})
  docinterface.addEntry(new Date(arg.txn_post_date).toUTCString().substring(5, 16), {content:true})

  if (arg.txn_status != stagelist[arg.txn_max_stage] && arg.txn_status != stagelist[stagelist.length-1]){
    if (arg.txn_status == stagelist[0]){
      dispstatus = 'Denied'
    } else {
      dispstatus = 'Resubmit'
    }
  } else {
    dispstatus = arg.txn_status
  }
  docinterface.addEntry('Recap Status:', {width:90})
  docinterface.addEntry(dispstatus, {content:true, width:120})
  docinterface.addEntry(new Date(arg.txn_post_date).toUTCString().substring(5, 16), {content:true})

  docinterface.addEntry('Purchase:', {width:75})
  docinterface.addEntry(arg.txn_purchase_status, {content:true, width:120})

  docinterface.addEntry('Purpose:', {width:75})
  docinterface.addEntry(arg.txn_purchase_purpose != null ? arg.txn_purchase_purpose:'N/A', {content:true})

  if (arg.txn_task_id != null){
    line = arg.txn_task_id
  } else if (arg.txn_travel_id != null){
    line = arg.txn_travel_id
  } else {
    line = 'None'
  }
  docinterface.addEntry('Task/Travel #:')
  docinterface.addEntry(line, {content:true})

  docinterface.addEntry('Item Description:')
  docinterface.addEntry(arg.txn_purchase_desc != null ? arg.txn_purchase_desc:'N/A', {n1:true})

  docinterface.addEntry('All Notes:')
  docinterface.addEntry(arg.txn_purchase_desc != null ? arg.txn_purchase_desc:'N/A', {n1:true})

  if(arg.log_notes && arg.log_notes.length > 0){
    arg.log_notes.forEach(log=>{
      docinterface.addEntry((log.log_uname) +', ' + new Date(log.log_time).toUTCString().substring(5, 16) +': ' +(log.log_note), {n1:true})
    })
  } else {
    docinterface.addEntry('None', {content:true})
  }

  docinterface.addEntry('Use Tax:', {width:90})
  docinterface.addEntry(arg.txn_use_tax_status, {content:true, width:75})
  if (arg.txn_use_tax_status == "Yes" || arg.txn_use_tax_status == "Done"){
    docinterface.addEntry(parseFloat(arg.txn_use_tax_rate).toFixed(2)+'%', {content:true, width:75})
    docinterface.addEntry('Use Tax $:', {width:105})
    docinterface.addEntry('$'+parseFloat(arg.txn_use_tax_amt).toFixed(2), {content:true})
  } else {
    docinterface.addEntry('')
  }

  docinterface.addEntry('Cartegraph:', {width:90})
  docinterface.addEntry(arg.txn_cartegraph_status, {content:true, width:75})
  if (arg.txn_cartegraph_status == "Yes" || arg.txn_cartegraph_status == "Done"){
    docinterface.addEntry('', {width:75})
    docinterface.addEntry('Cartegraph $:', {width:105})
    docinterface.addEntry('$'+parseFloat(arg.txn_cartegraph_amt).toFixed(2), {content:true})
  } else {
    docinterface.addEntry('')
  }

  docinterface.addEntry('Org Keys and Object Codes:')
  if(arg.sub_items && arg.sub_items.length > 0){
    arg.sub_items.forEach(subitem=>{
      docinterface.addEntry('$'+parseFloat(subitem.subitem_total).toFixed(2), {content:true, width:150})
      docinterface.addEntry(subitem.subitem_org_key, {content:true, width:150})
      docinterface.addEntry(subitem.subitem_obj_code, {content:true})
    })
  } else {
    docinterface.addEntry('None', {content:true})
  }


  docinterface.addEntry('User Signature:', {footer:true, width:120})
  docinterface.addEntry(arg.txn_user_signature, {content:true, footer:true, width:150})
  docinterface.addEntry('Certificate:', {footer:true, width:120})
  docinterface.addEntry(arg.txn_user_certificate ? 'Yes':'No', {content:true, footer:true})

  docinterface.end()

  return new Promise((resolve, reject)=>{
    stream.on('finish', function () {
      const url =  this.toBlobURL()
      return resolve(url)
    }).on('error', err=>{
      return reject(err)
    })
  })
}

//  _______  _____        __      __ ______  _
// |__   __||  __ \     /\\ \    / /|  ____|| |
//    | |   | |__) |   /  \\ \  / / | |__   | |
//    | |   |  _  /   / /\ \\ \/ /  |  __|  | |
//    | |   | | \ \  / ____ \\  /   | |____ | |____
//    |_|   |_|  \_\/_/    \_\\/    |______||______|
// documentation: https://pdfkitdoc.org/indexdoc.html
function makeTravelPDF(arg) {
  if (arg.constants){
    constantsObj = arrayToObject(arg.constants, 'const_name')
  }

  var doc = new PDFDocument({
    margins: {
      top: margin,
      bottom: margin,
      left: margin,
      right: margin
    }
  });
  var stream = doc.pipe(blobStream());

  docinterface = new Docinterface(doc, doc.x, doc.y, docwidth, docheight, margin, fontsize, sidespacing, spacing, travelfontcolor, travelbgcolor)

  docinterface.addEntry('Charleston County - Public Works Department', {h2:true})

  if (!arg.travel_event_count || arg.travel_event_count == null){
    text = 'NEW TRAVEL - NO ID YET'
  } else {
    text = 'TRAVEL REQUEST : ' +'TR-'+String(new Date(arg.event_fiscal_year).getUTCFullYear()).substring(2)+'-'+String(arg.event_fy_count).padStart(4,'0')+'-'+String(arg.travel_event_count).padStart(4,'0')
  }
  docinterface.addEntry(text, {h1:true})

  if (arg.travel_form_status != travel_stagelist[arg.travel_max_stage]){
    dispstatus = 'Denied to '+arg.travel_form_status
  } else {
    dispstatus = arg.travel_form_status
  }

  docinterface.addEntry('Status:', {width:75})
  docinterface.addEntry(dispstatus, {content:true, width:175})

  docinterface.addEntry('Org Key:', {width:75})
  docinterface.addEntry(arg.travel_org_key, {content:true})

  docinterface.addEntry('Traveler:', {width:75})
  docinterface.addEntry(arg.emp_lname +', ' +arg.emp_fname, {content:true, width:175})

  docinterface.addEntry('Emp ID:', {width:75})
  docinterface.addEntry(arg.emp_id, {content:true, width:100})

  docinterface.addEntry('FY:', {width:50})
  docinterface.addEntry(new Date(arg.event_fiscal_year).getUTCFullYear(), {content:true})

  docinterface.addEntry('Event', {h3:true})

  docinterface.addEntry('Event ID:', {width:75})
  docinterface.addEntry(arg.event_id, {content:true, width:50})

  docinterface.addEntry('Name:', {width:50})
  docinterface.addEntry(arg.event_name, {content:true, width:200})

  docinterface.addEntry('Type:', {width:50})
  docinterface.addEntry(arg.event_type, {content:true})

  docinterface.addEntry('Description:', {width:75})
  docinterface.addEntry(arg.event_desc, {content:true})

  docinterface.addEntry('Provider:', {width:75})
  docinterface.addEntry(arg.event_provider, {content:true, width:150})

  docinterface.addEntry('Regis Fee:', {width:75})
  docinterface.addEntry('$'+arg.event_regis_fee.toFixed(2), {content:true, width:75})

  docinterface.addEntry('Regis Date:', {width:75})
  docinterface.addEntry(new Date(arg.event_regis_date).toUTCString().substring(5, 16), {content:true})

  docinterface.addEntry('Event Start:', {width:75})
  docinterface.addEntry(new Date(arg.event_start_date).toUTCString().substring(5, 16), {content:true, width:125})

  docinterface.addEntry('Event End:', {width:75})
  docinterface.addEntry(new Date(arg.event_end_date).toUTCString().substring(5, 16), {content:true, width:125})

  docinterface.addEntry('Duration:', {width:75})
  e_len = parseInt((new Date(arg.event_end_date).getTime()-new Date(arg.event_start_date).getTime()) / (1000 * 3600 * 24))
  docinterface.addEntry(String(e_len)+' day'+(e_len==1?'':'s'), {content:true})

  docinterface.addEntry('Address:', {width:75})
  docinterface.addEntry(arg.event_street, {content:true, width:200})
  docinterface.addEntry(arg.event_city, {content:true, width:100})
  docinterface.addEntry(arg.event_state.toUpperCase(), {content:true, width:100})
  docinterface.addEntry(arg.event_zip_code, {content:true})

  if (arg.travel_method != 'N/A'){
    docinterface.addEntry('Travel', {h3:true})

    docinterface.addEntry('Method:', {width:75})
    docinterface.addEntry(arg.travel_method, {content:true, width:175})
    docinterface.addEntry('Rental Car:', {width:75})
    docinterface.addEntry(arg.travel_has_rental_car?'Yes':'No', {content:true})

    docinterface.addEntry('Depart:', {width:75})
    docinterface.addEntry(new Date(arg.travel_depart_datetime).toUTCString().substring(5, 22), {content:true, width:125})

    docinterface.addEntry('Return:', {width:75})
    docinterface.addEntry(new Date(arg.travel_return_datetime).toUTCString().substring(5, 22), {content:true, width:125})

    docinterface.addEntry('Duration:', {width:75})
    t_len =parseInt((new Date(arg.travel_return_datetime).getTime()-new Date(arg.travel_depart_datetime).getTime()) / (1000 * 3600 * 24))
    docinterface.addEntry(String(t_len)+' day'+(t_len==1?'':'s'), {content:true})

    docinterface.addEntry('Description:', {width:75})
    docinterface.addEntry(arg.travel_desc, {content:true})
  } else {
    docinterface.addEntry('Travel', {h3:true})
    docinterface.addEntry('' ,{width:75})
    docinterface.addEntry('None', {content:true})
  }

  docinterface.addEntry('Budget', {h3:true})

  docinterface.addEntry('Eligible:', {width:75})
  docinterface.addEntry(arg.travel_eligible_rental_car_days+' day'+(arg.travel_eligible_rental_car_days==1?'':'s'), {content:true, width:125})
  docinterface.addEntry('Ineligible (Personal Days):', {width:200})
  docinterface.addEntry(arg.travel_personal_days+' day'+(arg.travel_personal_days==1?'':'s'), {content:true})

  docinterface.addEntry('Lodging:', {width:75})
  docinterface.addEntry(arg.travel_eligible_lodging_nights+' night'+(arg.travel_eligible_lodging_nights==1?'':'s'), {content:true, width:125})

  docinterface.addEntry('Rental Car Max:', {width:125})
  docinterface.addEntry(arg.travel_eligible_rental_car_days+' day'+(arg.travel_eligible_rental_car_days==1?'':'s'), {content:true})

  docinterface.addEntry('Distance:', {width:75})
  docinterface.addEntry(arg.travel_dist_miles+' mile'+(arg.travel_dist_miles==1?'':'s'), {content:true, width:100})

  docinterface.addEntry('Airfare:', {width:75})
  docinterface.addEntry('$'+arg.travel_airfare_estimate.toFixed(2), {content:true, width:75})

  docinterface.addEntry('Max Reinbursible:', {width:125})
  docinterface.addEntry('$'+arg.travel_max_reinbursible.toFixed(2), {content:true})

  docinterface.addEntry('Meals', {h3:true})

  docinterface.addEntry('', {width:75})
  docinterface.addEntry('Breakfast', {width:75})
  docinterface.addEntry('Lunch', {width:75})
  docinterface.addEntry('Dinner', {width:75})
  docinterface.addEntry('')

  docinterface.addEntry('Provided:', {width:75})
  docinterface.addEntry(arg.event_bfst_prov, {content:true, width:75})
  docinterface.addEntry(arg.event_lnch_prov, {content:true, width:75})
  docinterface.addEntry(arg.event_dinn_prov, {content:true, width:75})
  docinterface.addEntry('')

  docinterface.addEntry('Not Cvrd:', {width:75})
  docinterface.addEntry(arg.travel_bfst_not_cvrd, {content:true, width:75})
  docinterface.addEntry(arg.travel_lnch_not_cvrd, {content:true, width:75})
  docinterface.addEntry(arg.travel_dinn_not_cvrd, {content:true, width:75})
  docinterface.addEntry('')

  docinterface.addEntry('Covered:', {width:75})
  docinterface.addEntry(arg.travel_bfst_allowed, {content:true, width:75})
  docinterface.addEntry(arg.travel_lnch_allowed, {content:true, width:75})
  docinterface.addEntry(arg.travel_dinn_allowed, {content:true, width:75})
  docinterface.addEntry('')

  docinterface.addEntry('Cvrd Total:', {width:75})
  docinterface.addEntry('$'+(arg.travel_bfst_allowed * (arg.event_state.toUpperCase()=='SC'?parseFloat(constantsObj.travel_sc_breakfast_reinburse.const_value):parseFloat(constantsObj.travel_breakfast_reinburse.const_value))).toFixed(2), {content:true, width:75})
  docinterface.addEntry('$'+(arg.travel_lnch_allowed * (arg.event_state.toUpperCase()=='SC'?parseFloat(constantsObj.travel_sc_lunch_reinburse.const_value):parseFloat(constantsObj.travel_lunch_reinburse.const_value))).toFixed(2), {content:true, width:75})
  docinterface.addEntry('$'+(arg.travel_dinn_allowed * (arg.event_state.toUpperCase()=='SC'?parseFloat(constantsObj.travel_sc_dinner_reinburse.const_value):parseFloat(constantsObj.travel_dinner_reinburse.const_value))).toFixed(2), {content:true, width:75})
  docinterface.addEntry('')

  docinterface.addPage()

  docinterface.addEntry('All Notes', {h3:true})

  if(arg.log_notes && arg.log_notes.length > 0){
    arg.log_notes.forEach(log=>{
      docinterface.addEntry((log.log_uname) +', ' + new Date(log.log_time).toUTCString().substring(5, 16) +': ' +(log.log_note), {content:true,})
    })
  } else {
    docinterface.addEntry('None', {content:true})
  }

  docinterface.addEntry('Submission History', {h3:true})

  if(arg.history && arg.history.length > 0){
    arg.history.forEach(log=>{
      docinterface.addEntry((log.log_uname) +', ' + new Date(log.log_time).toUTCString().substring(5, 16) +': ' +(log.log_desc), {content:true, continued:true})
    })
  } else {
    docinterface.addEntry('None', {content:true})
  }

  docinterface.end()

  return new Promise((resolve, reject)=>{
    stream.on('finish', function () {
      const url =  this.toBlobURL()
      return resolve(url)
    }).on('error', err=>{
      return reject(err)
    })
  })
}
//  ______  ____   _    _  _____  _____
// |  ____|/ __ \ | |  | ||_   _||  __ \
// | |__  | |  | || |  | |  | |  | |__) |
// |  __| | |  | || |  | |  | |  |  ___/
// | |____| |__| || |__| | _| |_ | |
// |______|\___\_\ \____/ |_____||_|

function makeEquipmentPDF(arg){
  if (arg.constants){
    constantsObj = arrayToObject(arg.constants, 'const_name')
  }

  var doc = new PDFDocument({
    margins: {
      top: margin,
      bottom: margin,
      left: margin,
      right: margin
    }
  });
  var stream = doc.pipe(blobStream());

  docinterface = new Docinterface(doc, doc.x, doc.y, docwidth, docheight, margin, fontsize, sidespacing, spacing, equipmentfontcolor, equipmentbgcolor)

  docinterface.addEntry('Charleston County - Public Works Department', {h2:true})

  if (!arg.travel_event_count || arg.travel_event_count == null){
    text = 'EQUIPMENT REQUEST : '+arg.Modify_Type
  }
  docinterface.addEntry(text, {h1:true})

  if (arg.travel_form_status != travel_stagelist[arg.travel_max_stage]){
    dispstatus = 'Denied to '+arg.travel_form_status
  } else {
    dispstatus = arg.travel_form_status
  }

  docinterface.addEntry('Form ID:', {width:80})
  // docinterface.addEntry(line, {content:true})
  docinterface.addEntry(arg.Modify_Type + "00" +arg.Formid, {content:true, width:180})
  docinterface.addEntry('Submitted Date:', {width:100})
  docinterface.addEntry(new Date(arg.Submit_Date).toUTCString().substring(5, 16), {content:true, width:200})

  docinterface.addEntry('Data No:', {width:80})
  docinterface.addEntry(arg.Data_NO, {content:true, width:180})
  docinterface.addEntry('Purchase date:', {width:100})
  docinterface.addEntry(new Date(arg.purchase_Date).toUTCString().substring(5, 16), {content:true, width:200})


  // FIXME: FIXED: this was my fault; the reportgen relied on log_history being present, and I had just reset the db. This conditional will make reportgen resiliant against this issue, but I will also never again delete the log history of your application. My mistake, and apologies. -Jack
  docinterface.addEntry('Submitted By:', {width:80})
  docinterface.addEntry(arg.emp_fname+' '+arg.emp_lname, {content:true, width:180})
  // submittedby = "none"
  // if (arg && arg.history && arg.history[0]){
  //   submittedby = arg.history[0].log_uname
  // }
  // docinterface.addEntry(submittedby, {content:true, width:180})
  docinterface.addEntry('Approved By:', {width:100})
  approveby = "none"
  arg.history.forEach(log=>{
    if(log.log_desc.includes ("APPROVED FORM")){
      approveby= log.log_uname
    }
  })

  // FIXME: FIXED: changed to 'approvedby', was 'arg.history[1].log_uname', which would be undefined if history is of length 0 or 1.
  docinterface.addEntry(approveby, {content:true, width:200})

  docinterface.addEntry('Status:', {width:80})
  docinterface.addEntry(arg.Status, {content:true, width:180})

  docinterface.addEntry('Entered in OMS:', {width:100})
  enterby = "none"
  arg.history.forEach(log=>{
    if(log.log_desc.includes ("COMPLETED")){
      enterby= log.log_uname
    }
  })
  docinterface.addEntry(enterby, {content:true, width:200})
  

  docinterface.addEntry('Description:', {width:80})
  docinterface.addEntry(arg.Description, {content:true, width:480})

  docinterface.addEntry('Manufacturer:', {width:80})
  docinterface.addEntry(arg.Manufacturer, {content:true, width:480})

  docinterface.addEntry('Vendor:', {width:80})
  docinterface.addEntry(arg.Vendor, {content:true, width:480})

  docinterface.addEntry('Location:', {width:80})
  docinterface.addEntry(arg.Location, {content:true, width:480})

  docinterface.addEntry('Department:', {width:80})
  docinterface.addEntry(arg.Department, {content:true, width:480})

  if (arg.Modify_Type== 'TRA'){
    docinterface.addEntry('New Locat:', {width:80})
    docinterface.addEntry(arg.Location_New, {content:true, width:480})

    docinterface.addEntry('New Depart:', {width:80})
    docinterface.addEntry(arg.Department_New, {content:true, width:480})
  }

  if (arg.Modify_Type== 'DEL'){
    docinterface.addEntry('AVL Serial:', {width:80})
    docinterface.addEntry(arg.AVLSerial, {content:true, width:480})
    
  }
  


  docinterface.addEntry('All Notes:')

  if(arg.log_notes && arg.log_notes.length > 0){
    arg.log_notes.forEach(log=>{
      docinterface.addEntry((log.log_uname) +', ' + new Date(log.log_time).toUTCString().substring(5, 16) +': ' +(log.log_note), {n1:true})
    })
  } else {
    docinterface.addEntry('None', {content:true})
  }


  docinterface.end()

  return new Promise((resolve, reject)=>{
    stream.on('finish', function () {
      const url =  this.toBlobURL()
      return resolve(url)
    }).on('error', err=>{
      return reject(err)
    })
  })
}

module.exports = {makePDF, makeTravelPDF, makeEquipmentPDF}