const username = require('username');
const db = require('../db')
const expect = require('chai').expect

let uname = ''
username().then(result =>{
  uname = result
  console.log('username:', uname)
}).catch(err =>{
  console.log('username error:', err.name)
  console.log(err)
})

const arg = {
  'event_type':'Training',
  'event_regis_fee':500,
  'event_regis_date':new Date(),
  'event_start_date':new Date(),
  'event_end_date':new Date(),
  'event_name':'Guys training',
  'event_desc':'guy teaches class',
  'event_provider':'Guy Industries',
  'event_street':'23 Finker St',
  'event_city':'Chust',
  'event_state':'SC',
  'event_zip_code':'12345',
  'event_bfst_prov':3,
  'event_lnch_prov':2,
  'event_dinn_prov':1,
  'e_doc_path':'',
  'travel_method':'Commercial Air',
  'travel_dist_miles':123,
  'travel_airfare_estimate':123,
  'travel_has_rental_car':1,
  'travel_desc':'travel description',
  'travel_depart_datetime':new Date(),
  'travel_return_datetime':new Date(),
  'travelers':[
    {'emp_id':100012, 'org_key':'142000001'},
    {'emp_id':100103, 'org_key':'142000001'}
  ],
  'travel_personal_days':1,
  'travel_eligible_lodging_nights':2,
  'travel_eligible_rental_car_days':3,
  'travel_max_reinbursible':4,
  'travel_bfst_allowed':5,
  'travel_lnch_allowed':6,
  'travel_dinn_allowed':7,
  'travel_bfst_not_cvrd':8,
  'travel_lnch_not_cvrd':9,
  'travel_dinn_not_cvrd':0,
  'travel_form_status':'New Travel'
}

async function submitNewTravel(arg){
  // TODO: add linking to documentation popup
  console.log('submit new travel')
  // console.log(arg)

  // create event
  await db.createEvent(arg, uname)
  .then(async result =>{
    // console.log(result)
    arg.travel_event_id = result[0].event_id
    console.log('event added, id:', arg.travel_event_id)

    // upload documentation
    // let filepath = global.Constants.travel_file_path +'\\EVENT\\' +arg.travel_event_id +'.pdf'

    if (arg.e_doc_path != '') {
      console.log('uploading file')
      await saveEventDoc(arg.e_doc_path, filepath)
      .then(result =>{
        console.log('upload complete')
      }).catch(err =>{
        console.log('upload document error:', err.name)
        console.log(err)
      })
    } else {
      console.log('no file to upload')
    }

    // create travel
    let allPass = true
    // console.log(arg.travelers)

    arg.travelers.forEach(async traveler =>{
      let arg2 = {...arg};
      arg2.travel_emp_id =traveler.emp_id
      arg2.travel_org_key =traveler.org_key
      await db.createTravel(arg2, uname)
    });

    console.log('all submissions complete!\n')
    return allPass
  }).catch(err =>{
    console.log('new event error:', err.name)
    console.log(err)
    return false
  })
}

describe('DB create multi-travel test', function() {
  describe('insert event and travel by arg', function() {
    it('should not throw error', async function() {
      await submitNewTravel(arg);
    });
  });
});